﻿Public Class clsMsgFrame

  Private Delegate Function MsgBoxCallBack(Parent As Object, Message As String, Style As MsgBoxStyle, Title As String) As MsgBoxResult
  Friend Shared Function MsgBox(Parent As Object, Message As String, Optional Style As MsgBoxStyle = MsgBoxStyle.ApplicationModal, Optional Title As String = Nothing) As MsgBoxResult
    Dim oTop As Form
    If Parent.GetType.BaseType.Equals(GetType(Form)) Then
      oTop = Parent
    Else
      oTop = Parent.TopLevelControl
    End If
    If oTop.InvokeRequired Then
      Return oTop.Invoke(New MsgBoxCallBack(AddressOf MsgBox), Parent, Message, Style, Title)
    Else
      Dim oParent As Object = Parent
      Dim isFormChild As Boolean = False
      If oParent.GetType.BaseType.Equals(GetType(Form)) Then
        isFormChild = True
      ElseIf (Style And MsgBoxStyle.SystemModal) = MsgBoxStyle.SystemModal Then
        oParent = Parent.TopLevelControl
        isFormChild = True
      End If
      'If String.IsNullOrEmpty(Title) Then Title = Application.ProductName
      Dim oBox As GroupBox = Nothing
      Dim pnlBox As TableLayoutPanel = Nothing
      Dim pnlMessage As TableLayoutPanel = Nothing
      Dim pnlButtons As TableLayoutPanel = Nothing
      Dim pctIco As PictureBox = Nothing
      Dim lblMessage As Label = Nothing
      Dim cmd1 As Button = Nothing
      Dim cmd2 As Button = Nothing
      Dim cmd3 As Button = Nothing
      'Parent.suspendlayout()
      makeGroupBox(oBox)
      oBox.Text = Title
      makePnlBox(pnlBox)
      oBox.Controls.Add(pnlBox)

      If (Style And MsgBoxStyle.Critical) = MsgBoxStyle.Critical Then
        makePnlMsg(pnlMessage, 2)
        pnlBox.Controls.Add(pnlMessage, 0, 0)
        makePctIco(pctIco)
        pctIco.Image = SystemIcons.Warning.ToBitmap
      ElseIf (Style And MsgBoxStyle.Exclamation) = MsgBoxStyle.Exclamation Then
        makePnlMsg(pnlMessage, 2)
        pnlBox.Controls.Add(pnlMessage, 0, 0)
        makePctIco(pctIco)
        pctIco.Image = SystemIcons.Exclamation.ToBitmap
      ElseIf (Style And MsgBoxStyle.Information) = MsgBoxStyle.Information Then
        makePnlMsg(pnlMessage, 2)
        pnlBox.Controls.Add(pnlMessage, 0, 0)
        makePctIco(pctIco)
        pctIco.Image = SystemIcons.Information.ToBitmap
      ElseIf (Style And MsgBoxStyle.Question) = MsgBoxStyle.Question Then
        makePnlMsg(pnlMessage, 2)
        pnlBox.Controls.Add(pnlMessage, 0, 0)
        makePctIco(pctIco)
        pctIco.Image = SystemIcons.Question.ToBitmap
      Else
        makePnlMsg(pnlMessage, 1)
        pnlBox.Controls.Add(pnlMessage, 0, 0)
      End If
      If pctIco IsNot Nothing Then pnlMessage.Controls.Add(pctIco, 0, 0)
      makeLblMsg(lblMessage)
      If pctIco IsNot Nothing Then
        pnlMessage.Controls.Add(lblMessage, 1, 0)
      Else
        pnlMessage.Controls.Add(lblMessage, 0, 0)
      End If
      lblMessage.Text = Message
      If (Style And MsgBoxStyle.AbortRetryIgnore) = MsgBoxStyle.AbortRetryIgnore Then
        '3 buttons
        makePnlButtons(pnlButtons, 3)
        pnlBox.Controls.Add(pnlButtons, 0, 1)
        makeButton(cmd1, "cmdAbort", 0)
        makeButton(cmd2, "cmdRetry", 1)
        makeButton(cmd3, "cmdIgnore", 2)
        cmd1.Text = "Abort"
        cmd2.Text = "Retry"
        cmd3.Text = "Ignore"
      ElseIf (Style And MsgBoxStyle.YesNoCancel) = MsgBoxStyle.YesNoCancel Then
        '3 Buttons
        makePnlButtons(pnlButtons, 3)
        pnlBox.Controls.Add(pnlButtons, 0, 1)
        makeButton(cmd1, "cmdYes", 0)
        makeButton(cmd2, "cmdNo", 1)
        makeButton(cmd3, "cmdCancel", 2)
        cmd1.Text = "Yes"
        cmd2.Text = "No"
        cmd3.Text = "Cancel"
      ElseIf (Style And MsgBoxStyle.YesNo) = MsgBoxStyle.YesNo Then
        '2 buttons
        makePnlButtons(pnlButtons, 2)
        pnlBox.Controls.Add(pnlButtons, 0, 1)
        makeButton(cmd1, "cmdYes", 0)
        makeButton(cmd2, "cmdNo", 1)
        cmd1.Text = "Yes"
        cmd2.Text = "No"
      ElseIf (Style And MsgBoxStyle.OkCancel) = MsgBoxStyle.OkCancel Then
        '2 buttons
        makePnlButtons(pnlButtons, 2)
        pnlBox.Controls.Add(pnlButtons, 0, 1)
        makeButton(cmd1, "cmdOK", 0)
        makeButton(cmd2, "cmdCancel", 1)
        cmd1.Text = "OK"
        cmd2.Text = "Cancel"
      ElseIf (Style And MsgBoxStyle.RetryCancel) = MsgBoxStyle.RetryCancel Then
        '2 buttons
        makePnlButtons(pnlButtons, 2)
        pnlBox.Controls.Add(pnlButtons, 0, 1)
        makeButton(cmd1, "cmdRetry", 0)
        makeButton(cmd2, "cmdCancel", 1)
        cmd1.Text = "Retry"
        cmd2.Text = "Cancel"
      Else
        'ok only
        makePnlButtons(pnlButtons, 1)
        pnlBox.Controls.Add(pnlButtons, 0, 1)
        makeButton(cmd1, "cmdOK", 0)
        cmd1.Text = "OK"
      End If
      If cmd1 IsNot Nothing Then
        pnlButtons.Controls.Add(cmd1, 0, 0)
        AddHandler cmd1.Click, New EventHandler(AddressOf cmdButton_Click)
      End If
      If cmd2 IsNot Nothing Then
        pnlButtons.Controls.Add(cmd2, 1, 0)
        AddHandler cmd2.Click, New EventHandler(AddressOf cmdButton_Click)
      End If
      If cmd3 IsNot Nothing Then
        pnlButtons.Controls.Add(cmd3, 2, 0)
        AddHandler cmd3.Click, New EventHandler(AddressOf cmdButton_Click)
      End If
      oBox.Tag = 0
      oParent.controls.add(oBox)
      oBox.Top = oParent.Height / 2 - oBox.Height / 2
      oBox.Left = oParent.width / 2 - oBox.Width / 2
      oBox.BringToFront()
      oBox.Focus()
      If isFormChild Then
        Do Until oBox.Tag > 0
          If oParent.Disposing Or oParent.IsDisposed Then Return MsgBoxResult.Cancel
          If Application.OpenForms.Count = 0 Then Return MsgBoxResult.Cancel
          Application.DoEvents()
        Loop
      Else
        Do Until oBox.Tag > 0
          If oParent.Parent Is Nothing Then Return MsgBoxResult.Cancel
          If Application.OpenForms.Count = 0 Then Return MsgBoxResult.Cancel
          Application.DoEvents()
        Loop
      End If
      oParent.Controls.Remove(oBox)
      Return oBox.Tag
    End If
  End Function

  Private Shared Sub makeGroupBox(ByRef oBox As GroupBox)
    oBox = New GroupBox
    oBox.AutoSize = True
    oBox.AutoSizeMode = AutoSizeMode.GrowAndShrink
    oBox.FlatStyle = FlatStyle.Flat
    oBox.Name = "msgFrame"
    oBox.ForeColor = Color.White
  End Sub

  Private Shared Sub makePnlBox(ByRef pnlBox As TableLayoutPanel)
    pnlBox = New TableLayoutPanel
    pnlBox.AutoSize = True
    pnlBox.AutoSizeMode = AutoSizeMode.GrowAndShrink
    pnlBox.ColumnCount = 1
    pnlBox.ColumnStyles.Add(New ColumnStyle(SizeType.Percent, 100.0!))
    pnlBox.Dock = DockStyle.Fill
    pnlBox.Name = "pnlBox"
    pnlBox.RowCount = 2
    pnlBox.RowStyles.Add(New RowStyle(SizeType.Percent, 100.0!))
    pnlBox.RowStyles.Add(New RowStyle(SizeType.AutoSize))
  End Sub

  Private Shared Sub makePnlMsg(ByRef pnlMessage As TableLayoutPanel, Columns As Integer)
    pnlMessage = New TableLayoutPanel
    pnlMessage.AutoSize = True
    pnlMessage.AutoSizeMode = AutoSizeMode.GrowAndShrink
    pnlMessage.ColumnCount = Columns
    If Columns > 1 Then pnlMessage.ColumnStyles.Add(New ColumnStyle(SizeType.AutoSize))
    pnlMessage.ColumnStyles.Add(New ColumnStyle(SizeType.Percent, 100.0!))
    pnlMessage.Dock = DockStyle.Fill
    pnlMessage.Name = "pnlMessage"
    pnlMessage.RowCount = 1
    pnlMessage.RowStyles.Add(New RowStyle(SizeType.Percent, 100.0!))
  End Sub

  Private Shared Sub makePctIco(ByRef pctIco As PictureBox)
    pctIco = New PictureBox
    pctIco.Name = "pctIco"
    pctIco.SizeMode = PictureBoxSizeMode.AutoSize
  End Sub

  Private Shared Sub makeLblMsg(ByRef lblMessage As Label)
    lblMessage = New Label
    lblMessage.AutoSize = True
    lblMessage.Name = "lblMessage"
  End Sub

  Private Shared Sub makePnlButtons(ByRef pnlButtons As TableLayoutPanel, Columns As Integer)
    pnlButtons = New TableLayoutPanel
    pnlButtons.Anchor = AnchorStyles.Bottom
    pnlButtons.AutoSize = True
    pnlButtons.AutoSizeMode = AutoSizeMode.GrowAndShrink
    pnlButtons.ColumnCount = Columns
    For I As Integer = 1 To Columns
      pnlButtons.ColumnStyles.Add(New ColumnStyle(SizeType.AutoSize))
    Next
    pnlButtons.Name = "pnlButtons"
    pnlButtons.RowCount = 1
    pnlButtons.RowStyles.Add(New RowStyle(SizeType.Percent, 100.0!))
  End Sub

  Private Shared Sub makeButton(ByRef cmdButton As Button, Name As String, Index As Integer)
    cmdButton = New Button
    cmdButton.AutoSize = True
    cmdButton.AutoSizeMode = AutoSizeMode.GrowAndShrink
    cmdButton.FlatStyle = FlatStyle.Flat
    cmdButton.FlatAppearance.BorderColor = Color.White
    cmdButton.FlatAppearance.BorderSize = 1
    cmdButton.FlatAppearance.BorderColor = System.Drawing.Color.White
    cmdButton.FlatAppearance.MouseDownBackColor = System.Drawing.Color.Black
    cmdButton.FlatAppearance.MouseOverBackColor = System.Drawing.Color.FromArgb(64, 64, 64)
    cmdButton.Name = Name
    cmdButton.TabIndex = Index
    cmdButton.UseVisualStyleBackColor = False
  End Sub

  Private Shared Sub cmdButton_Click(sender As Object, e As EventArgs)
    Dim mRet As MsgBoxResult
    Select Case sender.Name
      Case "cmdAbort" : mRet = MsgBoxResult.Abort
      Case "cmdRetry" : mRet = MsgBoxResult.Retry
      Case "cmdIgnore" : mRet = MsgBoxResult.Ignore
      Case "cmdYes" : mRet = MsgBoxResult.Yes
      Case "cmdNo" : mRet = MsgBoxResult.No
      Case "cmdOK" : mRet = MsgBoxResult.Ok
      Case "cmdCancel" : mRet = MsgBoxResult.Cancel
      Case Else
        Debug.Print(sender.Name)
        mRet = MsgBoxResult.Ok
    End Select
    CType(CType(CType(CType(sender, Button).Parent, TableLayoutPanel).Parent, TableLayoutPanel).Parent, GroupBox).Tag = mRet
  End Sub
End Class
