﻿Imports System.Runtime.InteropServices
Public NotInheritable Class NativeMethods
  Public Structure SYSTEM_INFO
    Public wProcessorArchitecture As Short
    Public wReserved As Short
    Public dwPageSize As Integer
    Public lpMinimumApplicationAddress As IntPtr
    Public lpMaximumApplicationAddress As IntPtr
    Public dwActiveProcessorMask As IntPtr
    Public dwNumberOfProcessors As Integer
    Public dwProcessorType As Integer
    Public dwAllocationGranularity As Integer
    Public wProcessorLevel As Short
    Public wProcessorRevision As Short
  End Structure
  Public Structure LV_ITEM
    Public mask As UInt32
    Public iItem As Int32
    Public iSubItem As Int32
    Public state As UInt32
    Public stateMask As UInt32
    Public pszText As String
    Public cchTextMax As Int32
    Public iImage As Int32
    Public lParam As IntPtr
  End Structure
  Public Structure FLASHWINFO
    Public cbSize As Int32
    Public hwnd As IntPtr
    Public dwFlags As Int32
    Public uCount As Int32
    Public dwTimeout As Int32
  End Structure
  Public Structure SCROLLINFO
    Public cbSize As Integer
    Public fMask As Integer
    Public nMin As Integer
    Public nMax As Integer
    Public nPage As Integer
    Public nPos As Integer
    Public nTrackPos As Integer
  End Structure
  Public Const FLASHW_CAPTION As Int32 = &H1
  Public Const FLASHW_TRAY As Int32 = &H2
  Public Const FLASHW_ALL As Int32 = (FLASHW_CAPTION Or FLASHW_TRAY)
  <DllImport("kernel32.dll", CharSet:=CharSet.Auto)> _
  Public Shared Sub GetNativeSystemInfo(ByRef lpSystemInfo As SYSTEM_INFO)
  End Sub
  <DllImport("user32.dll", CharSet:=CharSet.Unicode)> _
  Public Shared Function FindWindow(lpClassName As String, lpWindowName As String) As IntPtr
  End Function
  <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Unicode)> _
  Public Shared Function FindWindowEx(parentHandle As IntPtr, childAfter As IntPtr, lclassName As String, windowTitle As String) As IntPtr
  End Function
  <DllImport("user32", CharSet:=CharSet.Auto, SetLastError:=True, ExactSpelling:=True)> _
  Public Shared Function GetWindow(hWnd As IntPtr, uCmd As Integer) As IntPtr
  End Function
  <DllImport("user32", CharSet:=CharSet.Unicode, SetLastError:=True)> _
  Public Shared Function GetWindowText(hWnd As IntPtr, <Out(), MarshalAs(UnmanagedType.LPWStr)> lpString As String, nMaxCount As Integer) As Integer
  End Function
  <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)> _
  Public Shared Function SendMessage(hWnd As IntPtr, Msg As UInteger, wParam As IntPtr, <MarshalAs(UnmanagedType.AsAny)> lParam As Object) As IntPtr
  End Function
  <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Auto)> _
  Public Shared Function PostMessage(hWnd As IntPtr, wMsg As UInteger, wParam As IntPtr, lParam As IntPtr) As IntPtr
  End Function
  <DllImport("user32.dll", CharSet:=CharSet.Unicode)> _
  Public Shared Function MessageBox(hWnd As IntPtr, t As String, caption As String, t2 As UInt32) As Integer
  End Function
  <DllImport("kernel32.dll", CharSet:=CharSet.Unicode, setlasterror:=True)>
  Public Shared Function WritePrivateProfileStringW(lpApplicationName As String, lpKeyName As String, lpString As String, lpFileName As String) As Integer
  End Function
  <DllImport("kernel32.dll", CharSet:=CharSet.Unicode, setlasterror:=True)>
  Public Shared Function GetPrivateProfileStringW(lpApplicationName As String, lpKeyName As String, lpDefault As String, lpReturnedString As String, nSize As Int32, lpFileName As String) As Integer
  End Function
  <DllImport("gdi32.dll")>
  Public Shared Function BitBlt(hdcDest As IntPtr, nXDest As Integer, nYDest As Integer, nWidth As Integer, nHeight As Integer, hdcSrc As IntPtr, nXSrc As Integer, nYSrc As Integer, dwRop As Integer) As Int32
  End Function
  <DllImport("User32.dll")>
  Public Shared Function GetDC(hWnd As IntPtr) As IntPtr
  End Function
  <DllImport("User32.dll")>
  Public Shared Function ReleaseDC(hWnd As IntPtr, hDC As IntPtr) As Integer
  End Function
  <DllImport("User32.dll")>
  Public Shared Function FlashWindowEx(ByRef pfwi As FLASHWINFO) As Int32
  End Function
  <DllImport("User32.dll")>
  Public Shared Function GetScrollInfo(ByVal hWnd As IntPtr, ByVal n As Integer, ByRef lpScrollInfo As SCROLLINFO) As Int32
  End Function
  <DllImport("dwmapi.dll")>
  Private Shared Sub DwmIsCompositionEnabled(ByRef enabledptr As Integer)
  End Sub
  Public Shared Function IsCompositionEnabled() As Boolean
    If Environment.OSVersion.Version.Major < 6 Then Return False
    Dim compositionEnabled As Integer = 0
    DwmIsCompositionEnabled(compositionEnabled)
    Return CBool(compositionEnabled > 0)
  End Function
  Private Structure IconInfo
    Public fIcon As Boolean
    Public xHotspot As Int32
    Public yHotspot As Int32
    Public hbmMask As IntPtr
    Public hbmColor As IntPtr
  End Structure
  <DllImport("user32.dll", EntryPoint:="CreateIconIndirect")> _
  Private Shared Function CreateIconIndirect(ByVal iconInfo As IntPtr) As IntPtr
  End Function
  <DllImport("user32.dll", CharSet:=CharSet.Auto)> _
  Public Shared Function DestroyIcon(ByVal handle As IntPtr) As Boolean
  End Function
  <DllImport("gdi32.dll")> _
  Public Shared Function DeleteObject(ByVal hObject As IntPtr) As Boolean
  End Function
  Public Shared Function CreateCursor(ByVal bmp As Bitmap) As Cursor
    Dim tmp As New IconInfo
    tmp.xHotspot = 16
    tmp.yHotspot = 16
    tmp.fIcon = False
    tmp.hbmMask = bmp.GetHbitmap()
    tmp.hbmColor = bmp.GetHbitmap()

    Dim pnt As IntPtr = Marshal.AllocHGlobal(Marshal.SizeOf(tmp))
    Marshal.StructureToPtr(tmp, pnt, True)
    Dim curPtr As IntPtr = CreateIconIndirect(pnt)

    DestroyIcon(pnt)
    DeleteObject(tmp.hbmMask)
    DeleteObject(tmp.hbmColor)

    Return New Cursor(curPtr)
  End Function
End Class