﻿Imports System.Text.RegularExpressions
Public Class GeckoChat
  Public Enum ChatType
    None
    UserChat
    UserWhisper
    SelfChat
    FriendChat
    StatChat
    Emote
    D2Emote
    ServiceInfo
    ServiceError
    ServiceSuccess
    ServiceBroadcast
    HelpInfo
    VerboseInfo
    JoinLeave_Join
    JoinLeave_Leave
  End Enum
  Public Class NameClickEventArgs
    Inherits EventArgs
    Dim c_Account As String
    Dim c_Mouse As MouseEventArgs
    Public Sub New()
      c_Account = Nothing
    End Sub
    Public Sub New(Account As String)
      c_Account = Account
    End Sub
    Public Sub New(Account As String, Mouse As MouseEventArgs)
      c_Account = Account
      c_Mouse = Mouse
    End Sub
    Public Property Account As String
      Get
        Return c_Account
      End Get
      Set(value As String)
        c_Account = value
      End Set
    End Property
    Public Property Mouse As MouseEventArgs
      Get
        Return c_Mouse
      End Get
      Set(value As MouseEventArgs)
        c_Mouse = value
      End Set
    End Property
  End Class
  Public Class LinkClickEventArgs
    Inherits EventArgs
    Dim c_URL As String
    Dim c_Mouse As MouseEventArgs
    Public Sub New()
      c_URL = Nothing
    End Sub
    Public Sub New(URL As String)
      c_URL = URL
    End Sub
    Public Sub New(URL As String, Mouse As MouseEventArgs)
      c_URL = URL
      c_Mouse = Mouse
    End Sub
    Public Property URL As String
      Get
        Return c_URL
      End Get
      Set(value As String)
        c_URL = value
      End Set
    End Property
    Public Property Mouse As MouseEventArgs
      Get
        Return c_Mouse
      End Get
      Set(value As MouseEventArgs)
        c_Mouse = value
      End Set
    End Property
  End Class
  Public Class BadPassEventArgs
    Inherits EventArgs
    Dim c_ID As Integer
    Dim c_Response As Integer
    Dim c_NewUsername As String
    Dim c_NewPassword As String
    Dim c_OldPassword As String
    Public Sub New()
      c_ID = 0
      c_Response = 0
      c_NewUsername = String.Empty
      c_NewPassword = String.Empty
      c_OldPassword = String.Empty
    End Sub
    Public Sub New(ID As Integer)
      c_ID = ID
      c_Response = 0
      c_NewUsername = String.Empty
      c_NewPassword = String.Empty
      c_OldPassword = String.Empty
    End Sub
    Public Sub New(ID As Integer, Response As Integer)
      c_ID = ID
      c_Response = Response
      c_NewUsername = String.Empty
      c_NewPassword = String.Empty
      c_OldPassword = String.Empty
    End Sub
    Public Sub New(Username As String)
      c_ID = 0
      c_Response = 0
      c_NewUsername = Username
      c_NewPassword = String.Empty
      c_OldPassword = String.Empty
    End Sub
    Public Sub New(Username As String, Password As String)
      c_ID = 0
      c_Response = 0
      c_NewUsername = Username
      c_NewPassword = Password
      c_OldPassword = String.Empty
    End Sub
    Public Sub New(Username As String, Password As String, OldPassword As String)
      c_ID = 0
      c_Response = 0
      c_NewUsername = Username
      c_NewPassword = Password
      c_OldPassword = OldPassword
    End Sub
    Public Sub New(ID As Integer, Username As String)
      c_ID = ID
      c_Response = 0
      c_NewUsername = Username
      c_NewPassword = String.Empty
      c_OldPassword = String.Empty
    End Sub
    Public Sub New(ID As Integer, Response As Integer, Username As String)
      c_ID = ID
      c_Response = Response
      c_NewUsername = Username
      c_NewPassword = String.Empty
      c_OldPassword = String.Empty
    End Sub
    Public Sub New(ID As Integer, Username As String, Password As String)
      c_ID = ID
      c_Response = 0
      c_NewUsername = Username
      c_NewPassword = Password
      c_OldPassword = String.Empty
    End Sub
    Public Sub New(ID As Integer, Username As String, Password As String, OldPassword As String)
      c_ID = ID
      c_Response = 0
      c_NewUsername = Username
      c_NewPassword = Password
      c_OldPassword = OldPassword
    End Sub
    Public Sub New(ID As Integer, Response As Integer, Username As String, Password As String)
      c_ID = ID
      c_Response = Response
      c_NewUsername = Username
      c_NewPassword = Password
      c_OldPassword = String.Empty
    End Sub
    Public Sub New(ID As Integer, Response As Integer, Username As String, Password As String, OldPassword As String)
      c_ID = ID
      c_Response = Response
      c_NewUsername = Username
      c_NewPassword = Password
      c_OldPassword = OldPassword
    End Sub
    Public Property ID As Integer
      Get
        Return c_ID
      End Get
      Set(value As Integer)
        c_ID = value
      End Set
    End Property
    Public Property Response As Integer
      Get
        Return c_Response
      End Get
      Set(value As Integer)
        c_Response = value
      End Set
    End Property
    Public Property Username As String
      Get
        Return c_NewUsername
      End Get
      Set(value As String)
        c_NewUsername = value
      End Set
    End Property
    Public Property Password As String
      Get
        Return c_NewPassword
      End Get
      Set(value As String)
        c_NewPassword = value
      End Set
    End Property
    Public Property OldPassword As String
      Get
        Return c_OldPassword
      End Get
      Set(value As String)
        c_OldPassword = value
      End Set
    End Property
  End Class
  Private Class WebClientEx
    Inherits Net.WebClient
    Private ReadOnly cc As New Net.CookieContainer
    Protected Overrides Function GetWebRequest(address As Uri) As Net.WebRequest
      Dim wr As Net.WebRequest = MyBase.GetWebRequest(address)
      Dim hwr As Net.HttpWebRequest = wr
      If hwr IsNot Nothing Then
        'hwr.Headers = Me.Headers
        hwr.CookieContainer = Me.cc
      End If
      Return wr
    End Function
  End Class
  Private Class URLTitleGrabber
    Implements IDisposable
    Private WithEvents webClient As WebClientEx
    Public Event UpdateHTMLTitle(URL As String, Title As String)
    Public Event UpdateHTMLObject(URL As String, ContentType As String, ContentLength As UInt32)
    Private Structure DBList
      Public URL As String
      Public Title As String
      Public Type As Byte
    End Structure
    Private TitleList As New Collections.ArrayList
    Private TitleSearch As Threading.Thread

    Public Sub New()
      webClient = New WebClientEx
      webClient.Proxy = Nothing
      webClient.CachePolicy = New Net.Cache.HttpRequestCachePolicy(Net.Cache.HttpRequestCacheLevel.NoCacheNoStore)
      webClient.Headers.Clear()
      webClient.Headers.Add("User-Agent", UserAgent)
    End Sub

    Public Function GetHTMLTitle(URL As String) As String
      Try
        URL = URL.Replace("&amp;", "&")
        Dim tItem As DBList = Array.Find(TitleList.ToArray, Function(titleItem As DBList) String.Compare(titleItem.URL, URL, True) = 0) '(From titleItem As DBList In TitleList Where String.Compare(titleItem.URL, URL, True) = 0 Select titleItem).FirstOrDefault
        If String.IsNullOrEmpty(tItem.Title) OrElse tItem.URL = tItem.Title Then
          If URL.StartsWith("about:", True, Nothing) Then
            Dim tNItem As DBList
            tNItem.URL = URL
            tNItem.Title = URL & " information page"
            TitleList.Add(tNItem)
            RaiseEvent UpdateHTMLTitle(tNItem.URL, tNItem.Title)
            Return tNItem.Title
          Else
            Dim uriAddr As Uri
            If URL.StartsWith("www.", True, Nothing) Then
              uriAddr = New Uri("http://" & URL)
            ElseIf URL.StartsWith("http://", True, Nothing) Or URL.StartsWith("https://", True, Nothing) Then
              uriAddr = New Uri(URL)
            ElseIf URL.StartsWith("file://", True, Nothing) Then
              uriAddr = New Uri(URL)
            Else
              Dim tNItem As DBList
              tNItem.URL = URL
              tNItem.Title = URL
              TitleList.Add(tNItem)
              RaiseEvent UpdateHTMLTitle(tNItem.URL, tNItem.Title)
              Return URL
            End If
            If TitleSearch Is Nothing OrElse Not TitleSearch.IsAlive Then
              TitleSearch = New Threading.Thread(AddressOf BeginGetHTMLTitle)
              TitleSearch.Start(uriAddr)
            End If
          End If
          Return URL
          'If webClient.IsBusy Then
          '  Return URL
          'Else
          '  webClient.Headers.Clear()
          '  webClient.Headers.Add("User-Agent", UserAgent)
          '  If URL.StartsWith("www.") Then
          '    webClient.DownloadStringAsync(New Uri("http://" & URL), URL)
          '  ElseIf URL.StartsWith("http://") Or URL.StartsWith("https://") Then
          '    webClient.DownloadStringAsync(New Uri(URL), URL)
          '  ElseIf URL.StartsWith("file://") Then
          '    webClient.DownloadStringAsync(New Uri(URL), URL)
          '  ElseIf URL.StartsWith("about:") Then
          '    Dim tNItem As DBList
          '    tNItem.URL = URL
          '    tNItem.Title = URL & " information page"
          '    TitleList.Add(tNItem)
          '    RaiseEvent UpdateHTMLTitle(tNItem.URL, tNItem.Title)
          '  End If
          '  Return URL
          'End If
        Else
          If TitleSearch Is Nothing OrElse Not TitleSearch.IsAlive Then
            TitleSearch = New Threading.Thread(AddressOf BeginRepeatedUpdate)
            TitleSearch.Start(tItem)
            Return tItem.Title
          Else
            Return URL
          End If
        End If
      Catch ex As Exception
        Return URL & " unresolvable."
      End Try
    End Function

    Private Sub BeginRepeatedUpdate(tItem As DBList)
      Select Case tItem.Type
        Case 0
          'Other
          RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
        Case 1, 2, 3, 4
          Dim sMIME As String = tItem.Title
          Dim iSize As Integer = 0
          If sMIME.Contains(" - YouTube") Then
            'NADA
          ElseIf sMIME.Contains("("c) Then
            Dim sSize As String = sMIME.Substring(sMIME.IndexOf("("c))
            sMIME = sMIME.Substring(0, sMIME.IndexOf("("c)).Trim
            'Stop
            sSize = sSize.Substring(1, sSize.Length - 2)
            If sSize.Contains(" "c) Then
              Dim sMult As String = sSize.Substring(sSize.LastIndexOf(" "c) + 1)
              sSize = sSize.Substring(0, sSize.LastIndexOf(" "c))
              Select Case sMult.ToLower
                Case "b" : iSize = sSize
                Case "kb" : iSize = sSize * 1024
                Case "mb" : iSize = sSize * 1024 * 1024
                Case "gb" : iSize = sSize * 1024 * 1024 * 1024
                Case "tb" : iSize = sSize * 1024 * 1024 * 1024 * 1024
                Case Else : iSize = 0 : sMIME = tItem.Title
              End Select
            Else
              iSize = Val(sSize)
            End If
          End If
          RaiseEvent UpdateHTMLObject(tItem.URL, sMIME, iSize)
        Case Else
          'Unknown
          RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
      End Select
    End Sub

    Private Sub BeginGetHTMLTitle(Address As Uri)
      If webClient.IsBusy Then Exit Sub
      webClient.Headers.Clear()
      webClient.Headers.Add("User-Agent", UserAgent)
      webClient.DownloadStringAsync(Address, Address.OriginalString)
      TitleSearch = Nothing
    End Sub

    Private Sub webClient_DownloadProgressChanged(sender As Object, e As System.Net.DownloadProgressChangedEventArgs) Handles webClient.DownloadProgressChanged
      If Not String.IsNullOrEmpty(webClient.ResponseHeaders("Content-Type")) Then
        Dim ContentType As String = webClient.ResponseHeaders("Content-Type")
        If ContentType.Contains(";") Then ContentType = ContentType.Split(";"c).First
        Select Case ContentType.ToLower
          Case "text/html"
            If e.TotalBytesToReceive > 1024 * 1024 Then
              Dim tItem As DBList
              tItem.URL = e.UserState
              tItem.Title = webClient.ResponseHeaders("Content-Type") & " (" & ByteSize(e.TotalBytesToReceive) & ")"
              tItem.Type = 0
              TitleList.Add(tItem)
              RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
              webClient.CancelAsync()
            ElseIf e.TotalBytesToReceive = -1 Then
              If e.BytesReceived > 1024 * 1024 Then
                Dim tItem As DBList
                tItem.URL = e.UserState
                tItem.Title = webClient.ResponseHeaders("Content-Type") & " (Unknown Size [ > 1 MB])"
                tItem.Type = 0
                TitleList.Add(tItem)
                RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
                webClient.CancelAsync()
              End If
            End If
          Case "image/gif", "image/jpeg", "image/png", "image/svg+xml", "image/tiff", "image/vnd.microsoft.icon", "audio/wave", "audio/wav", "audio/x-wav", "audio/x-pn-wav", "audio/webm", "audio/ogg", "video/webm", "video/ogg", "application/ogg"
            Dim tItem As DBList
            tItem.URL = e.UserState
            tItem.Title = webClient.ResponseHeaders("Content-Type") & " (" & ByteSize(e.TotalBytesToReceive) & ")"
            Select Case ContentType.ToLower.Substring(0, ContentType.IndexOf("/"))
              Case "image" : tItem.Type = 1
              Case "audio" : tItem.Type = 2
              Case "video" : tItem.Type = 3
            End Select
            tItem.Type = 1
            TitleList.Add(tItem)
            RaiseEvent UpdateHTMLObject(tItem.URL, webClient.ResponseHeaders("Content-Type"), e.TotalBytesToReceive)
            webClient.CancelAsync()
          Case Else
            If e.TotalBytesToReceive > 1024 * 512 Then
              Dim tItem As DBList
              tItem.URL = e.UserState
              tItem.Title = webClient.ResponseHeaders("Content-Type") & " (" & ByteSize(e.TotalBytesToReceive) & ")"
              tItem.Type = 0
              TitleList.Add(tItem)
              RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
              webClient.CancelAsync()
            ElseIf e.TotalBytesToReceive = -1 Then
              Dim tItem As DBList
              tItem.URL = e.UserState
              tItem.Title = webClient.ResponseHeaders("Content-Type") & " (Unknown Size)"
              tItem.Type = 0
              TitleList.Add(tItem)
              RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
              webClient.CancelAsync()
            End If
        End Select
      Else
        If e.TotalBytesToReceive > 1024 * 512 Then
          Dim tItem As DBList
          tItem.URL = e.UserState
          tItem.Title = "Unknown Content Type (" & ByteSize(e.TotalBytesToReceive) & ")"
          tItem.Type = 0
          TitleList.Add(tItem)
          RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
          webClient.CancelAsync()
        ElseIf e.TotalBytesToReceive = -1 Then
          Dim tItem As DBList
          tItem.URL = e.UserState
          tItem.Title = "Unknown Content Type (Unknown Size [ > " & ByteSize(e.BytesReceived) & "])"
          tItem.Type = 0
          TitleList.Add(tItem)
          RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
          If e.BytesReceived > 1024 * 512 Then webClient.CancelAsync()
        End If
      End If
    End Sub

    Private Sub webClient_DownloadStringCompleted(sender As Object, e As System.Net.DownloadStringCompletedEventArgs) Handles webClient.DownloadStringCompleted
      If e.Error Is Nothing Then
        Dim result As String = e.Result
        If Not String.IsNullOrEmpty(webClient.ResponseHeaders("Content-Type")) Then
          Dim ContentType As String = webClient.ResponseHeaders("Content-Type")
          If ContentType.Contains(";") Then ContentType = ContentType.Split(";"c).First
          Select Case ContentType.ToLower
            Case "text/html"
              If Not (String.IsNullOrEmpty(result) Or result = "0") Then
                If InStr(result, "<title", CompareMethod.Text) > 0 Then
                  Dim sText As String = result.Substring(InStr(result, "<title", CompareMethod.Text) + 5)
                  sText = sText.Substring(InStr(sText, ">", CompareMethod.Text))
                  sText = sText.Substring(0, InStr(sText, "</title>", CompareMethod.Text) - 1)
                  Dim tItem As DBList
                  tItem.URL = e.UserState
                  tItem.Title = System.Net.WebUtility.HtmlDecode(sText.Replace(vbCr, String.Empty).Replace(vbLf, String.Empty).Trim)
                  If tItem.Title.StartsWith("YouTube", True, Nothing) Then tItem.Title = "YouTube " & Trim(tItem.Title.Substring(7))
                  If tItem.Title.EndsWith(" - YouTube", True, Nothing) Then tItem.Title = Trim(tItem.Title.Substring(0, tItem.Title.Length - 9)) & " - YouTube"
                  tItem.Title = tItem.Title.Replace("&", "&&")
                  Dim eURI As Uri
                  Try
                    If e.UserState.ToString.Contains("://") Then
                      eURI = New Uri(e.UserState.ToString)
                    Else
                      eURI = New Uri("http://" & e.UserState.ToString)
                    End If
                  Catch ex As Exception
                    eURI = Nothing
                  End Try
                  If eURI IsNot Nothing Then
                    If eURI.Host.EndsWith("youtube.com", True, Nothing) Then
                      If eURI.AbsolutePath.StartsWith("/watch", True, Nothing) Or
                         eURI.AbsolutePath.StartsWith("/embed", True, Nothing) Or
                         eURI.AbsolutePath.StartsWith("/v", True, Nothing) Then
                        tItem.Type = 4
                        TitleList.Add(tItem)
                        RaiseEvent UpdateHTMLObject(tItem.URL, tItem.Title, 0)
                      Else
                        tItem.Type = 0
                        TitleList.Add(tItem)
                        RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
                      End If
                    ElseIf eURI.Host.EndsWith("youtu.be", True, Nothing) Then
                      tItem.Type = 4
                      TitleList.Add(tItem)
                      RaiseEvent UpdateHTMLObject(tItem.URL, tItem.Title, 0)
                    Else
                      tItem.Type = 0
                      TitleList.Add(tItem)
                      RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
                    End If
                  Else
                    tItem.Type = 0
                    TitleList.Add(tItem)
                    RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
                  End If
                  'Exit Sub
                End If
              End If
            Case "image/gif", "image/jpeg", "image/png", "image/svg+xml", "image/tiff", "image/vnd.microsoft.icon", "audio/wave", "audio/wav", "audio/x-wav", "audio/x-pn-wav", "audio/webm", "audio/ogg", "video/webm", "video/ogg"
              Dim tItem As DBList
              tItem.URL = e.UserState
              tItem.Title = webClient.ResponseHeaders("Content-Type") & " (" & ByteSize(result.Length) & ")"
              Select Case ContentType.ToLower.Substring(0, ContentType.IndexOf("/"))
                Case "image" : tItem.Type = 1
                Case "audio" : tItem.Type = 2
                Case "video" : tItem.Type = 3
              End Select
              TitleList.Add(tItem)
              RaiseEvent UpdateHTMLObject(tItem.URL, webClient.ResponseHeaders("Content-Type"), result.Length)
            Case Else
              Dim tItem As DBList
              tItem.URL = e.UserState
              tItem.Title = webClient.ResponseHeaders("Content-Type") & " (" & ByteSize(result.Length) & ")"
              tItem.Type = 0
              TitleList.Add(tItem)
              If Not (String.IsNullOrEmpty(result) Or result = "0") Then
                Dim eURI As Uri
                Try
                  If e.UserState.ToString.Contains("://") Then
                    eURI = New Uri(e.UserState.ToString)
                  Else
                    eURI = New Uri("http://" & e.UserState.ToString)
                  End If
                Catch ex As Exception
                  eURI = Nothing
                End Try
                If eURI IsNot Nothing Then
                  If eURI.Host.EndsWith("youtube.com", True, Nothing) Then
                    If eURI.AbsolutePath.StartsWith("/watch", True, Nothing) Or
                         eURI.AbsolutePath.StartsWith("/embed", True, Nothing) Or
                         eURI.AbsolutePath.StartsWith("/v", True, Nothing) Then
                      tItem.Type = 4
                      TitleList.Add(tItem)
                      RaiseEvent UpdateHTMLObject(tItem.URL, "YoutTube Video [" & tItem.Title & "]", 0)
                    Else
                      tItem.Type = 0
                      TitleList.Add(tItem)
                      RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
                    End If
                  ElseIf eURI.Host.EndsWith("youtu.be", True, Nothing) Then
                    tItem.Type = 4
                    TitleList.Add(tItem)
                    RaiseEvent UpdateHTMLObject(tItem.URL, tItem.Title, 0)
                  Else
                    tItem.Type = 0
                    TitleList.Add(tItem)
                    RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
                  End If
                Else
                  tItem.Type = 0
                  TitleList.Add(tItem)
                  RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
                End If
              Else
                RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
              End If
          End Select
        Else
          If Not (String.IsNullOrEmpty(result) Or result = "0") Then
            If InStr(result, "<title", CompareMethod.Text) > 0 Then
              Dim sText As String = result.Substring(InStr(result, "<title", CompareMethod.Text) + 5)
              sText = sText.Substring(InStr(sText, ">", CompareMethod.Text))
              sText = sText.Substring(0, InStr(sText, "</title>", CompareMethod.Text) - 1)
              Dim tItem As DBList
              tItem.URL = e.UserState
              tItem.Title = System.Net.WebUtility.HtmlDecode(sText.Replace(vbCr, String.Empty).Replace(vbLf, String.Empty).Trim)
              If tItem.Title.StartsWith("YouTube", True, Nothing) Then tItem.Title = "YouTube " & Trim(tItem.Title.Substring(7))
              If tItem.Title.EndsWith(" - YouTube", True, Nothing) Then tItem.Title = Trim(tItem.Title.Substring(0, tItem.Title.Length - 9)) & " - YouTube"
              tItem.Title = tItem.Title.Replace("&", "&&")
              tItem.Type = 4
              TitleList.Add(tItem)
              Dim eURI As Uri
              Try
                If e.UserState.ToString.Contains("://") Then
                  eURI = New Uri(e.UserState.ToString)
                Else
                  eURI = New Uri("http://" & e.UserState.ToString)
                End If
              Catch ex As Exception
                eURI = Nothing
              End Try
              If eURI IsNot Nothing Then
                If eURI.Host.EndsWith("youtube.com", True, Nothing) Then
                  If eURI.AbsolutePath.StartsWith("/watch", True, Nothing) Or
                     eURI.AbsolutePath.StartsWith("/embed", True, Nothing) Or
                     eURI.AbsolutePath.StartsWith("/v", True, Nothing) Then
                    tItem.Type = 4
                    TitleList.Add(tItem)
                    RaiseEvent UpdateHTMLObject(tItem.URL, tItem.Title, 0)
                  Else
                    tItem.Type = 0
                    TitleList.Add(tItem)
                    RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
                  End If
                ElseIf eURI.Host.EndsWith("youtu.be", True, Nothing) Then
                  tItem.Type = 4
                  TitleList.Add(tItem)
                  RaiseEvent UpdateHTMLObject(tItem.URL, tItem.Title, 0)
                Else
                  tItem.Type = 0
                  TitleList.Add(tItem)
                  RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
                End If
              Else
                tItem.Type = 0
                TitleList.Add(tItem)
                RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
              End If
            End If
          End If
        End If
      Else
        Dim tExists As Boolean = Array.Exists(TitleList.ToArray, Function(titleItem As DBList) String.Compare(titleItem.URL, e.UserState, True) = 0)
        If tExists Then
          Dim tItem As DBList = Array.Find(TitleList.ToArray, Function(titleItem As DBList) String.Compare(titleItem.URL, e.UserState, True) = 0)
          'Debug.Print("<" & tItem.URL & "> Exists as: " & tItem.Title)
        Else
          Dim tItem As DBList
          tItem.URL = e.UserState
          tItem.Title = e.Error.Message
          tItem.Type = 0
          TitleList.Add(tItem)
          RaiseEvent UpdateHTMLTitle(tItem.URL, tItem.Title)
        End If
      End If
    End Sub

#Region "IDisposable Support"
    Private disposedValue As Boolean ' To detect redundant calls

    ' IDisposable
    Protected Overridable Sub Dispose(disposing As Boolean)
      If Not Me.disposedValue Then
        If disposing Then
          ' TODO: dispose managed state (managed objects).
          webClient.Dispose()
        End If

        ' TODO: free unmanaged resources (unmanaged objects) and override Finalize() below.
        ' TODO: set large fields to null.
      End If
      Me.disposedValue = True
    End Sub

    ' TODO: override Finalize() only if Dispose( disposing As Boolean) above has code to free unmanaged resources.
    'Protected Overrides Sub Finalize()
    '    ' Do not change this code.  Put cleanup code in Dispose( disposing As Boolean) above.
    '    Dispose(False)
    '    MyBase.Finalize()
    'End Sub

    ' This code added by Visual Basic to correctly implement the disposable pattern.
    Public Sub Dispose() Implements IDisposable.Dispose
      ' Do not change this code.  Put cleanup code in Dispose( disposing As Boolean) above.
      Dispose(True)
      GC.SuppressFinalize(Me)
    End Sub
#End Region
  End Class
  Private Class GeckoBox
    Inherits Gecko.GeckoWebBrowser
    Protected Overrides Sub OnPaint(e As System.Windows.Forms.PaintEventArgs)
      'Static LastUpdate As Integer, lastBMP As Bitmap
      'e.Graphics.Clear(Color.Black)
      'If Environment.TickCount - LastUpdate < 1000 Then
      '  e.Graphics.DrawImageUnscaled(lastBMP, MyBase.DisplayRectangle)
      'Else

      '  Using bmpTmp = MyBase.GetBitmap(MyBase.DisplayRectangle.X, CType(MyBase.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop, MyBase.DisplayRectangle.Width, MyBase.DisplayRectangle.Height)
      '    lastBMP = bmpTmp.Clone
      '    e.Graphics.DrawImageUnscaled(bmpTmp, MyBase.DisplayRectangle)
      '  End Using
      '  LastUpdate = Environment.TickCount
      'End If

      If MyBase.Document Is Nothing Then
        MyBase.OnPaint(e)
        Exit Sub
      End If
      If MyBase.Document.StyleSheets.Count < 1 Then
        MyBase.OnPaint(e)
        Exit Sub
      End If
      Dim NoJL As Boolean = False
      Dim fFont As Font = New Font(Drawing.FontFamily.GenericSansSerif, 10, FontStyle.Regular, GraphicsUnit.Point)
      e.Graphics.Clear(Color.Black)
      Dim styleNode As Gecko.DOM.GeckoStyleElement = Nothing
      For Each node In MyBase.Document.Head.ChildNodes
        If node.GetType Is GetType(Gecko.DOM.GeckoStyleElement) Then
          styleNode = node
        End If
      Next
      If styleNode IsNot Nothing Then
        Dim cssStyle As New clsCSS(styleNode.InnerHtml)
        For Each rule In cssStyle.Elements
          If rule.Name = "body" Then

            Dim bgColor As String = rule.Styles.Find("background-color").Value
            If String.IsNullOrEmpty(bgColor) Then bgColor = "black"
            e.Graphics.Clear(ColorStrToColor(bgColor))
            Dim bgImage As String = rule.Styles.Find("background-image").Value
            If Not String.IsNullOrEmpty(bgImage) Then
              If bgImage.StartsWith("url", True, Nothing) Then
                bgImage = bgImage.Substring(bgImage.IndexOf("(""") + 2)
                bgImage = bgImage.Substring(0, bgImage.LastIndexOf(""")"))
                bgImage = bgImage.Substring(bgImage.IndexOf("://") + 3)
                bgImage = bgImage.Replace("\'", "'")
                bgImage = bgImage.Replace("%20", " ")
                bgImage = bgImage.Replace("/", "\")
                If My.Computer.FileSystem.FileExists(bgImage) Then
                  Dim iBG As Image = Image.FromFile(bgImage)
                  Dim cX, cY, cW, cH As Integer
                  If iBG.Width > iBG.Height Then
                    cW = MyBase.DisplayRectangle.Width
                    cH = iBG.Height / iBG.Width * MyBase.DisplayRectangle.Width
                    cY = (MyBase.DisplayRectangle.Height - cH) / 2
                  Else
                    cH = MyBase.DisplayRectangle.Height
                    cW = iBG.Width / iBG.Height * MyBase.DisplayRectangle.Height
                    cX = (MyBase.DisplayRectangle.Width - cW) / 2
                  End If
                  e.Graphics.DrawImage(iBG, New Rectangle(cX, cY, cW, cH), New Rectangle(Point.Empty, iBG.Size), GraphicsUnit.Pixel)
                End If
              End If
            End If
            Dim fontFam As String = rule.Styles.Find("font-family").Value
            If String.IsNullOrEmpty(fontFam) Then fontFam = "Microsoft Sans Serif"
            Dim fontSize As String = rule.Styles.Find("font-size").Value
            If String.IsNullOrEmpty(fontSize) Then fontSize = "11pt"
            Dim su As String, sz As Single
            If fontSize.EndsWith("%") Then
              su = "%"
              sz = fontSize.Substring(0, fontSize.Length - 1)
            Else
              su = fontSize.Substring(fontSize.Length - 2, 2)
              sz = Single.Parse(fontSize.Substring(0, fontSize.Length - 2))
            End If
            Select Case su.ToLower
              Case "%" : fFont = New Font(fontFam, (sz / 100) * 10, GraphicsUnit.Point)
              Case "pt" : fFont = New Font(fontFam, sz, GraphicsUnit.Point)
              Case "px" : fFont = New Font(fontFam, sz, GraphicsUnit.Pixel)
              Case "mm" : fFont = New Font(fontFam, sz, GraphicsUnit.Millimeter)
              Case "cm" : fFont = New Font(fontFam, sz * 10, GraphicsUnit.Millimeter)
              Case "em" : fFont = New Font(fontFam, sz * 10, GraphicsUnit.Point)
              Case "in" : fFont = New Font(fontFam, sz, GraphicsUnit.Inch)
              Case "ex" : fFont = New Font(fontFam, sz * 5, GraphicsUnit.Point)
              Case "pc" : fFont = New Font(fontFam, sz * 12, GraphicsUnit.Point)
              Case Else : fFont = New Font(fontFam, sz, GraphicsUnit.Point)
            End Select
          ElseIf rule.Name = ".joinleave" Then
            If rule.Styles.Find("display").Value = "none" Then NoJL = True
          End If

        Next

      End If


      'If MyBase.Document IsNot Nothing AndAlso MyBase.Document.StyleSheets.Count > 0 AndAlso MyBase.Document.StyleSheets(0).CssRules.Count > 0 Then
      '  For Each rule In MyBase.Document.StyleSheets(0).CssRules
      '    If rule.SelectorText = "body" Then
      '      Dim bgColor As String = GetCSSRule(rule.StyleCssText, "background-color")
      '      If String.IsNullOrEmpty(bgColor) Then bgColor = "black"
      '      e.Graphics.Clear(ColorStrToColor(bgColor))
      '      Dim bgImage As String = GetCSSRule(rule.StyleCssText, "background-image")
      '      If Not String.IsNullOrEmpty(bgImage) Then
      '        If bgImage.StartsWith("url", True, Nothing) Then
      '          bgImage = bgImage.Substring(bgImage.IndexOf("(""") + 2)
      '          bgImage = bgImage.Substring(0, bgImage.LastIndexOf(""")"))
      '          bgImage = bgImage.Substring(bgImage.IndexOf("://") + 3)
      '          bgImage = bgImage.Replace("\'", "'")
      '          bgImage = bgImage.Replace("%20", " ")
      '          bgImage = bgImage.Replace("/", "\")
      '          If My.Computer.FileSystem.FileExists(bgImage) Then
      '            Dim iBG As Image = Image.FromFile(bgImage)
      '            Dim cX, cY, cW, cH As Integer
      '            If iBG.Width > iBG.Height Then
      '              cW = MyBase.DisplayRectangle.Width
      '              cH = iBG.Height / iBG.Width * MyBase.DisplayRectangle.Width
      '              cY = (MyBase.DisplayRectangle.Height - cH) / 2
      '            Else
      '              cH = MyBase.DisplayRectangle.Height
      '              cW = iBG.Width / iBG.Height * MyBase.DisplayRectangle.Height
      '              cX = (MyBase.DisplayRectangle.Width - cW) / 2
      '            End If
      '            e.Graphics.DrawImage(iBG, New Rectangle(cX, cY, cW, cH), New Rectangle(Point.Empty, iBG.Size), GraphicsUnit.Pixel)
      '          End If
      '        End If
      '      End If
      '      Dim fontFam As String = GetCSSRule(rule.StyleCssText, "font-family")
      '      If String.IsNullOrEmpty(fontFam) Then fontFam = "Microsoft Sans Serif"
      '      Dim fontSize As String = GetCSSRule(rule.StyleCssText, "font-size")
      '      If String.IsNullOrEmpty(fontSize) Then fontSize = "11pt"
      '      Dim su As String, sz As Single
      '      If fontSize.EndsWith("%") Then
      '        su = "%"
      '        sz = fontSize.Substring(0, fontSize.Length - 1)
      '      Else
      '        su = fontSize.Substring(fontSize.Length - 2, 2)
      '        sz = Single.Parse(fontSize.Substring(0, fontSize.Length - 2))
      '      End If
      '      Select Case su.ToLower
      '        Case "%" : fFont = New Font(fontFam, (sz / 100) * 10, GraphicsUnit.Point)
      '        Case "pt" : fFont = New Font(fontFam, sz, GraphicsUnit.Point)
      '        Case "px" : fFont = New Font(fontFam, sz, GraphicsUnit.Pixel)
      '        Case "mm" : fFont = New Font(fontFam, sz, GraphicsUnit.Millimeter)
      '        Case "cm" : fFont = New Font(fontFam, sz * 10, GraphicsUnit.Millimeter)
      '        Case "em" : fFont = New Font(fontFam, sz * 10, GraphicsUnit.Point)
      '        Case "in" : fFont = New Font(fontFam, sz, GraphicsUnit.Inch)
      '        Case "ex" : fFont = New Font(fontFam, sz * 5, GraphicsUnit.Point)
      '        Case "pc" : fFont = New Font(fontFam, sz * 12, GraphicsUnit.Point)
      '        Case Else : fFont = New Font(fontFam, sz, GraphicsUnit.Point)
      '      End Select
      '    ElseIf rule.SelectorText = ".joinleave" Then
      '      If GetCSSRule(rule.StyleCssText, "display") = "none" Then NoJL = True
      '    End If
      '  Next
      'End If
      Dim sFmt As New Drawing.StringFormat
      sFmt.Alignment = StringAlignment.Near
      sFmt.LineAlignment = StringAlignment.Near
      Dim uCount As UInt64 = MyBase.Document.GetElementsByClassName("contents").Count
      If uCount > 0 Then
        Dim uVal As UInt64 = 2
        For I As Integer = 0 To uCount - 1
          Dim iItem = MyBase.Document.GetElementsByClassName("contents")(I)
          If NoJL AndAlso iItem.ParentElement.ParentElement.ParentElement.ParentElement.ParentElement.ClassName = "joinleave" Then Continue For
          Dim sText As String
          If iItem.HasChildNodes Then
            Try
              If iItem.FirstChild.NodeType = Gecko.NodeType.Text Then
                sText = iItem.TextContent
              Else
                If CType(iItem.FirstChild, Gecko.GeckoHtmlElement).ClassName = "protocol" Then
                  sText = CType(iItem, Gecko.GeckoHtmlElement).TextContent
                Else
                  'sText = CType(iItem.FirstChild, Gecko.GeckoHtmlElement).TextContent
                  If iItem.ChildNodes.Count > 1 Then
                    If iItem.ChildNodes(1).HasChildNodes Then
                      Dim sItem As Gecko.GeckoHtmlElement = iItem.CloneNode(True)
                      sItem.InnerHtml = RemoveEmotes(sItem.InnerHtml)
                      sText = sItem.TextContent
                    Else
                      sText = iItem.ChildNodes(1).TextContent
                    End If
                  Else
                    sText = CType(iItem.FirstChild, Gecko.GeckoHtmlElement).TextContent
                  End If
                End If
              End If
            Catch ex As Exception
              sText = iItem.TextContent
            End Try
          Else
            sText = iItem.TextContent
          End If
          Dim brushColor As Brush
          Dim sType As String = "text"
          If iItem.HasChildNodes Then
            If iItem.ChildNodes.Count > 1 Then
              If iItem.ChildNodes(1).HasAttributes Then sType = iItem.ChildNodes(1).Attributes(0).NodeValue
            Else
              If iItem.ChildNodes(0).HasAttributes Then sType = iItem.ChildNodes(0).Attributes(0).NodeValue
            End If
          End If
          If sType.Contains(" ") Then sType = Split(sType, " ")(0)
          Select Case sType
            Case "text" : brushColor = Brushes.White
            Case "emote" : brushColor = Brushes.Yellow
            Case "d2emote", "whisper" : brushColor = Brushes.Gray
            Case "info" : brushColor = Brushes.Yellow
            Case "error" : brushColor = Brushes.Red
            Case "success" : brushColor = Brushes.Lime
            Case "broadcast" : brushColor = Brushes.Orange
            Case Else : brushColor = Brushes.White
          End Select
          Dim ScrollTop As Integer = CType(MyBase.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop
          If ScrollTop > 0 Then
            e.Graphics.DrawString(sText, fFont, brushColor, New Rectangle(0, uVal - ScrollTop, MyBase.DisplayRectangle.Width, iItem.ParentElement.ClientHeight), sFmt)
          Else
            e.Graphics.DrawString(sText, fFont, brushColor, New Rectangle(0, uVal, MyBase.DisplayRectangle.Width, iItem.ParentElement.ClientHeight), sFmt)
          End If
          uVal += iItem.ParentElement.ClientHeight + 4
        Next
      End If
      MyBase.OnPaint(e)
    End Sub

    Private Function RemoveEmotes(sMessage As String) As String
      If InStr(sMessage, "img") > 0 Then
        Dim regx As New Regex("<img src=""chrome://entelechy/skin/emote/\S+\.svg"" class=""emoticon"" title=""[^"" <>]+"" alt=""[^"" <>]+"">", RegexOptions.IgnoreCase)
        Dim mactches As MatchCollection = regx.Matches(sMessage)
        For Each match As Match In mactches
          sMessage = sMessage.Replace(match.Value, match.Value.Substring(match.Value.LastIndexOf("alt=""") + 5, match.Value.LastIndexOf(""">") - (match.Value.LastIndexOf("alt=""") + 5)))
        Next
      End If
      Return sMessage
    End Function
  End Class
  Public Event UserNameClick(sender As Object, e As NameClickEventArgs)
  Public Event UserNameHover(sender As Object, e As NameClickEventArgs)
  Public Event HyperlinkClick(sender As Object, e As LinkClickEventArgs)
  Public Shadows Event MouseDown(sender As Object, e As MouseEventArgs)
  Public Shadows Event MouseUp(sender As Object, e As MouseEventArgs)
  Public Event ReconnectResult(sender As Object, e As Boolean)
  Public Event BadPassResult(sender As Object, e As BadPassEventArgs)
  Public Event EMailChange(NewEMail As String)
  Public Event PassChange(NewPass As String)
  Public Event EndJoinRetry()
  Private sTimeStampFormat As String
  Private bTimeStampEnabled As Boolean
  Private bJoinLeave As Boolean
  Private bEmoticons As Boolean
  Private bRichText As Boolean
  Private lMaxLines As UInt32
  Private sLogFile As String
  Private sCSS As String
  Private Const ScrollGive As Integer = 30
  Private WithEvents titleGrabber As New URLTitleGrabber
  Private WithEvents tmrReconnect As New Timers.Timer(1000)
  Private WithEvents tmrBadPass As New Timers.Timer(1000)
  Private WithEvents gwBrowse As Gecko.GeckoWebBrowser
  Private ReconnectMessage As String
  Private ReconnectLeft As UShort
  Private BadPassMessage As String
  Private BadPassLeft As Integer
  Private BadPassID As Integer
  Private BadPassUser As String
  Private BadPassOldPass As String
  Private BadPassPass As String
  Private GoDownOnFocus As Boolean
  Public DontFocus As Boolean
  Private ResMan As New Resources.ResourceManager("Entelechy.GeckoChat", Reflection.[Assembly].GetExecutingAssembly)
#Region "Control Events"
  Private Sub GeckoChat_Load(sender As Object, e As System.EventArgs) Handles Me.Load
    If DesignMode Then
      Me.BackColor = Color.Black
    Else
      Me.BackColor = Color.Transparent
      gwBrowse = New GeckoBox
      gwBrowse.Dock = DockStyle.Fill
      gwBrowse.Margin = New Padding(0)
      gwBrowse.Padding = New Padding(0)
      gwBrowse.NoDefaultContextMenu = True
      Me.Controls.Add(gwBrowse)
      If gwBrowse.Created Then
        Control.CheckForIllegalCrossThreadCalls = True
        Clear()
        'Debug.Print(Gecko.GeckoPreferences.User("general.useragent.override"))
      Else
        MsgBox(ResMan.GetString("ERR_CANTCREATE"), MsgBoxStyle.Critical, "GeckoFx")
      End If
    End If
  End Sub
  Private Sub GeckoChat_Resize(sender As Object, e As System.EventArgs) Handles Me.Resize
    If gwBrowse Is Nothing Then Exit Sub
    If Not gwBrowse.Created Then Exit Sub
    Dim bScroll As Boolean = (CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollHeight - CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop < CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).OffsetHeight + ScrollGive)
    If bScroll Then CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop = (CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollHeight - CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).OffsetHeight)
  End Sub
  Private Sub GeckoChat_VisibleChanged(sender As Object, e As System.EventArgs) Handles Me.VisibleChanged
    If GoDownOnFocus Then ToBottom() : GoDownOnFocus = False
  End Sub
#End Region
#Region "Gecko Browser Events"
  Private Sub gwBrowse_DocumentCompleted(sender As Object, e As System.EventArgs) Handles gwBrowse.DocumentCompleted
    If Not gwBrowse.DocumentTitle = "Entelechy ChatBox" Then Clear()
    SetCSS(sCSS)
    gwBrowse.NoDefaultContextMenu = True
  End Sub
  Private Sub gwBrowse_DomKeyUp(sender As Object, e As Gecko.DomKeyEventArgs) Handles gwBrowse.DomKeyUp
    If e.KeyCode = Keys.Return Or e.KeyCode = Keys.Space Then
      If e.Target IsNot Nothing Then
        If e.Target.TagName.ToLower = "input" Then
          Select Case e.Target.Id
            Case "saveLogin"
              Dim gUser As Gecko.GeckoElement = gwBrowse.Document.GetElementById("username")
              Dim gPass As Gecko.GeckoElement = gwBrowse.Document.GetElementById("password")
              BadPassUser = CType(gUser, Gecko.DOM.GeckoInputElement).Value
              BadPassOldPass = CType(gPass, Gecko.DOM.GeckoInputElement).Value
              DontFocus = False
              EndBadPass(3)
            Case "savePass"
              Dim gOld As Gecko.GeckoElement = gwBrowse.Document.GetElementById("oldpassword")
              Dim gNew As Gecko.GeckoElement = gwBrowse.Document.GetElementById("newpassword")
              BadPassOldPass = CType(gOld, Gecko.DOM.GeckoInputElement).Value
              BadPassPass = CType(gNew, Gecko.DOM.GeckoInputElement).Value
              DontFocus = False
              EndBadPass(5)
            Case "noSaveLogin", "noSavePass"
              DontFocus = False
              UpdateBadPass()
            Case "togglePass"
              Dim gPass As Gecko.GeckoElement = gwBrowse.Document.GetElementById("password")
              If gPass.GetAttribute("type") = "password" Then
                gPass.SetAttribute("type", "text")
              Else
                gPass.SetAttribute("type", "password")
              End If
            Case "toggleOldPass"
              Dim gPass As Gecko.GeckoElement = gwBrowse.Document.GetElementById("oldpassword")
              If gPass.GetAttribute("type") = "password" Then
                gPass.SetAttribute("type", "text")
              Else
                gPass.SetAttribute("type", "password")
              End If
            Case "toggleNewPass"
              Dim gPass As Gecko.GeckoElement = gwBrowse.Document.GetElementById("newpassword")
              If gPass.GetAttribute("type") = "password" Then
                gPass.SetAttribute("type", "text")
              Else
                gPass.SetAttribute("type", "password")
              End If
          End Select
        End If
      End If
    End If
  End Sub
  Private Sub gwBrowse_DomMouseDown(sender As Object, e As Gecko.DomMouseEventArgs) Handles gwBrowse.DomMouseDown
    If gwBrowse Is Nothing Then Exit Sub
    If Not gwBrowse.DocumentTitle = "Entelechy ChatBox" Then Clear()
    RaiseEvent MouseDown(Me, New MouseEventArgs(e.Button, 1, e.ClientX, e.ClientY, 0))
  End Sub
  Private Sub gwBrowse_DomMouseMove(sender As Object, e As Gecko.DomMouseEventArgs) Handles gwBrowse.DomMouseMove
    If e.Target IsNot Nothing AndAlso e.Target.TagName.ToLower = "a" Then
      e.Handled = True
      If Not String.IsNullOrEmpty(e.Target.GetAttribute("name")) Then
        If e.Target.GetAttribute("name") = "URL" Then
          If e.Target.GetAttribute("title") = e.Target.GetAttribute("href").Substring(1) Then
            e.Target.SetAttribute("title", titleGrabber.GetHTMLTitle(e.Target.GetAttribute("href").Substring(1)))
          End If
        Else
          RaiseEvent UserNameHover(Me, New NameClickEventArgs(e.Target.GetAttribute("name"), New MouseEventArgs(e.Button, 1, e.ClientX, e.ClientY, 0)))
        End If
      End If
    End If
  End Sub
  Private Sub gwBrowse_DomMouseUp(sender As Object, e As Gecko.DomMouseEventArgs) Handles gwBrowse.DomMouseUp
    GoDownOnFocus = isAtBottom()
    If gwBrowse Is Nothing Then Exit Sub
    If Not gwBrowse.DocumentTitle = "Entelechy ChatBox" Then Clear()
    If Me.InvokeRequired Then
      Debug.Print("INVOKE THIS SHIT")
    End If
    If gwBrowse.CanCopySelection Then
      gwBrowse.CopySelection()
      Dim sTmp As String = Clipboard.GetText
      If Not String.IsNullOrEmpty(sTmp) Then
        gwBrowse.SelectNone()
        Clipboard.SetText(Replace(sTmp, vbTab & vbNewLine, " "))
      End If
    End If
    If e.Target IsNot Nothing Then
      If e.Target.TagName.ToLower = "a" Then
        e.Handled = True
        If Not String.IsNullOrEmpty(e.Target.GetAttribute("name")) Then
          Select Case e.Target.GetAttribute("name")
            Case "URL"
              If e.Button = 0 Then
                If Not String.IsNullOrEmpty(e.Target.GetAttribute("href")) AndAlso Not e.Target.GetAttribute("href") = "#" AndAlso Not e.Target.GetAttribute("href").StartsWith("##") Then
                  RaiseEvent HyperlinkClick(Me, New LinkClickEventArgs(e.Target.GetAttribute("href").Substring(1), New MouseEventArgs(e.Button, 1, e.ClientX, e.ClientY, 0)))
                End If
              Else
                If Not String.IsNullOrEmpty(e.Target.GetAttribute("href")) AndAlso Not e.Target.GetAttribute("href") = "#" Then
                  If e.Target.GetAttribute("href").StartsWith("##") Then
                    RaiseEvent HyperlinkClick(Me, New LinkClickEventArgs(e.Target.GetAttribute("href").Substring(2), New MouseEventArgs(e.Button, 1, e.ClientX, e.ClientY, 0)))
                  Else
                    RaiseEvent HyperlinkClick(Me, New LinkClickEventArgs(e.Target.GetAttribute("href").Substring(1), New MouseEventArgs(e.Button, 1, e.ClientX, e.ClientY, 0)))
                  End If
                End If
              End If
              Exit Sub
            Case "CONRET"
              Select Case e.Target.GetAttribute("href")
                Case "#OK" : EndReconnect(True)
                Case "#CANCEL" : EndReconnect(False)
              End Select
            Case "FULL"
              RaiseEvent EndJoinRetry()
            Case "BADPASS"
              Select Case e.Target.GetAttribute("href")
                Case "#CREATE" : EndBadPass(1)
                Case "#CHANGE"
                  tmrBadPass.Enabled = False
                  BadPassLeft = -1
                  DontFocus = True
                  Dim bpCSS As New clsCSS
                  bpCSS.Elements.Add(".promptTable", New clsCSS.StyleList(
                                     {
                                       New clsCSS.StyleList.Style("display", "inline-block"),
                                       New clsCSS.StyleList.Style("vertical-align", "middle"),
                                       New clsCSS.StyleList.Style("font-size", "11px"),
                                       New clsCSS.StyleList.Style("color", "white")
                                     }))
                  bpCSS.Elements.Add(".promptText", New clsCSS.StyleList(
                                     {
                                       New clsCSS.StyleList.Style("background-color", "black"),
                                       New clsCSS.StyleList.Style("border", "1px solid white"),
                                       New clsCSS.StyleList.Style("color", "white"),
                                       New clsCSS.StyleList.Style("font-size", "10px")
                                     }))
                  bpCSS.Elements.Add(".promptText:hover, .promptText:focus", New clsCSS.StyleList({New clsCSS.StyleList.Style("background-color", "#202020")}))
                  bpCSS.Elements.Add(".promptButton", New clsCSS.StyleList(
                                     {
                                       New clsCSS.StyleList.Style("background-color", "black"),
                                       New clsCSS.StyleList.Style("border", "1px solid white"),
                                       New clsCSS.StyleList.Style("border-radius", "2px"),
                                       New clsCSS.StyleList.Style("color", "white"),
                                       New clsCSS.StyleList.Style("font-size", "10px")
                                     }))
                  bpCSS.Elements.Add(".promptButton:hover", New clsCSS.StyleList({New clsCSS.StyleList.Style("background-color", "#404040")}))
                  bpCSS.Elements.Add(".promptButton:hover:active", New clsCSS.StyleList(
                                     {
                                       New clsCSS.StyleList.Style("background-color", "black"),
                                       New clsCSS.StyleList.Style("outline", "none")
                                     }))
                  bpCSS.Elements.Add(".promptButton:focus", New clsCSS.StyleList({New clsCSS.StyleList.Style("outline", "dotted thin white")}))
                  bpCSS.Elements.Add(".passButton", New clsCSS.StyleList({New clsCSS.StyleList.Style("width", "20px")}))
                  bpCSS.Elements.Add("#username", New clsCSS.StyleList({New clsCSS.StyleList.Style("width", "100px")}))
                  bpCSS.Elements.Add("#password", New clsCSS.StyleList({New clsCSS.StyleList.Style("width", "78px")}))
                  bpCSS.Elements.Add("#saveLogin, #noSaveLogin", New clsCSS.StyleList({New clsCSS.StyleList.Style("width", "100%")}))
                  Dim bScroll As Boolean = (CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollHeight - CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop < CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).OffsetHeight + ScrollGive)
                  e.Target.ParentElement.InnerHtml = "<style type=""text/css"">" & vbNewLine & bpCSS.ToString & vbNewLine & "</style>" & vbNewLine & BadPassMessage & " [<table id=""passTable"" class=""promptTable""><tr><td><table><tr><td><label for=""username"">" & ResMan.GetString("LBL_USERNAME") & "</label></td><td colspan=""2""><input type=""text"" class=""promptText"" id=""username"" value=""" & BadPassUser & """ title=""" & ResMan.GetString("TXT_USERNAME_TT") & """ /></tr><tr><td><label for=""password"">" & ResMan.GetString("LBL_PASSWORD") & "</label></td><td><input type=""password"" class=""promptText"" id=""password"" value=""" & BadPassOldPass & """ title=""" & ResMan.GetString("TXT_PASSWORD_TT") & """ /></td><td style=""text-align: right;""><input type=""submit"" class=""promptButton passButton"" value=""*"" id=""togglePass"" title=""" & ResMan.GetString("TT_TOGGLEPASS") & """ /></td></tr></table></td><td><table><tr><td><input type=""submit"" class=""promptButton"" value=""" & ResMan.GetString("CMD_LOGIN") & """ id=""saveLogin"" title=""" & ResMan.GetString("CMD_LOGIN_TT") & """ /></td></tr><tr><td style=""text-align: right;""><input type=""submit"" class=""promptButton"" value=""" & ResMan.GetString("CMD_CANCEL") & """ id=""noSaveLogin"" title=""" & ResMan.GetString("CMD_CANCELLOGIN_TT") & """ /></td></tr></table></td></tr></table>]"
                  If bScroll AndAlso gwBrowse.Document.GetElementsByTagName("tr").Count > 0 Then gwBrowse.Document.GetElementsByTagName("tr").Last.ScrollIntoView(False)
                Case "#CHANGEP"
                  tmrBadPass.Enabled = False
                  BadPassLeft = -1
                  DontFocus = True
                  Dim bpCSS As New clsCSS
                  bpCSS.Elements.Add(".promptTable", New clsCSS.StyleList(
                                     {
                                       New clsCSS.StyleList.Style("display", "inline-block"),
                                       New clsCSS.StyleList.Style("vertical-align", "middle"),
                                       New clsCSS.StyleList.Style("font-size", "11px"),
                                       New clsCSS.StyleList.Style("color", "white")
                                     }))
                  bpCSS.Elements.Add(".promptText", New clsCSS.StyleList(
                                     {
                                       New clsCSS.StyleList.Style("background-color", "black"),
                                       New clsCSS.StyleList.Style("border", "1px solid white"),
                                       New clsCSS.StyleList.Style("color", "white"),
                                       New clsCSS.StyleList.Style("font-size", "10px"),
                                       New clsCSS.StyleList.Style("width", "80px")
                                     }))
                  bpCSS.Elements.Add(".promptText:hover, .promptText:focus", New clsCSS.StyleList({New clsCSS.StyleList.Style("background-color", "#202020")}))
                  bpCSS.Elements.Add(".promptButton", New clsCSS.StyleList(
                                     {
                                       New clsCSS.StyleList.Style("background-color", "black"),
                                       New clsCSS.StyleList.Style("border", "1px solid white"),
                                       New clsCSS.StyleList.Style("border-radius", "2px"),
                                       New clsCSS.StyleList.Style("color", "white"),
                                       New clsCSS.StyleList.Style("font-size", "10px")
                                     }))
                  bpCSS.Elements.Add(".promptButton:hover", New clsCSS.StyleList({New clsCSS.StyleList.Style("background-color", "#404040")}))
                  bpCSS.Elements.Add(".promptButton:hover:active", New clsCSS.StyleList(
                                     {
                                       New clsCSS.StyleList.Style("background-color", "black"),
                                       New clsCSS.StyleList.Style("outline", "none")
                                     }))
                  bpCSS.Elements.Add(".promptButton:focus", New clsCSS.StyleList({New clsCSS.StyleList.Style("outline", "dotted thin white")}))
                  bpCSS.Elements.Add(".passButton", New clsCSS.StyleList({New clsCSS.StyleList.Style("width", "20px")}))
                  bpCSS.Elements.Add("#savePass, #noSavePass", New clsCSS.StyleList({New clsCSS.StyleList.Style("width", "100%")}))
                  Dim bScroll As Boolean = (CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollHeight - CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop < CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).OffsetHeight + ScrollGive)
                  e.Target.ParentElement.InnerHtml = "<style type=""text/css"">" & vbNewLine & bpCSS.ToString & vbNewLine & "</style>" & vbNewLine & BadPassMessage & " [<table id=""passTable"" class=""promptTable""><tr><td><table><tr><td><label for=""oldpassword"">" & ResMan.GetString("LBL_PASSWORD_CUR") & "</label></td><td><input type=""password"" class=""promptText"" id=""oldpassword"" value=""" & BadPassOldPass & """ title=""" & ResMan.GetString("TXT_PASSWORD_CUR_TT") & """ /><td><input type=""submit"" class=""promptButton passButton"" value=""*"" id=""toggleOldPass"" title=""" & ResMan.GetString("CMD_TOGGLEPASS_CUR") & """ /></td></tr><tr><td><label for=""newpassword"">" & ResMan.GetString("LBL_PASSWORD_NEW") & "</label></td><td><input type=""password"" class=""promptText"" id=""newpassword"" value=""" & BadPassPass & """ title=""" & ResMan.GetString("TXT_PASSWORD_NEW_TT") & """ /></td><td><input type=""submit"" class=""promptButton passButton"" value=""*"" id=""toggleNewPass"" title=""" & ResMan.GetString("CMD_TOGGLEPASS_NEW_TT") & """ /></td></tr></table></td><td><table><tr><td><input type=""submit"" class=""promptButton"" value=""" & ResMan.GetString("CMD_CHANGE") & """ id=""savePass"" title=""" & ResMan.GetString("CMD_CHANGEPASS_TT") & """ /></td></tr><tr><td style=""text-align: right;""><input type=""submit"" class=""promptButton"" value=""" & ResMan.GetString("CMD_CANCEL") & """ id=""noSavePass"" title=""" & ResMan.GetString("CMD_CANCELPASS_TT") & """ /></td></tr></table></td></tr></table>]"
                  If bScroll AndAlso gwBrowse.Document.GetElementsByTagName("tr").Count > 0 Then gwBrowse.Document.GetElementsByTagName("tr").Last.ScrollIntoView(False)
                Case "#RESET" : EndBadPass(2)
                Case "#LOGIN" : EndBadPass(3)
                Case "#CANCEL" : EndBadPass(4)
              End Select
            Case Else
              RaiseEvent UserNameClick(Me, New NameClickEventArgs(e.Target.GetAttribute("name"), New MouseEventArgs(e.Button, 1, e.ClientX, e.ClientY, 0)))
              Exit Sub
          End Select
        End If
      ElseIf e.Target.Parent IsNot Nothing AndAlso e.Target.Parent.TagName.ToLower = "a" Then
        e.Handled = True
        If Not String.IsNullOrEmpty(e.Target.Parent.GetAttribute("name")) Then
          If e.Target.Parent.GetAttribute("name") = "THUMBURL" Then
            If Not String.IsNullOrEmpty(e.Target.Parent.GetAttribute("href")) AndAlso Not e.Target.Parent.GetAttribute("href") = "#" AndAlso Not e.Target.Parent.GetAttribute("href").StartsWith("##") Then RaiseEvent HyperlinkClick(Me, New LinkClickEventArgs(e.Target.Parent.GetAttribute("href").Substring(1), New MouseEventArgs(e.Button, 1, e.ClientX, e.ClientY, 0)))
          Else
            RaiseEvent UserNameClick(Me, New NameClickEventArgs(e.Target.Parent.GetAttribute("name"), New MouseEventArgs(e.Button, 1, e.ClientX, e.ClientY, 0)))
            Exit Sub
          End If
        End If
      ElseIf (e.Target.TagName.ToLower = "iframe" AndAlso e.Target.GetAttribute("class") = "youtube-player") Or e.Target.OwnerDocument.Url.Host = "www.youtube.com" Then
        'YouTube video
        Exit Sub
      ElseIf e.Target.TagName.ToLower = "input" Then
        Select Case e.Target.Id
          Case "saveLogin"
            Dim gUser As Gecko.GeckoElement = gwBrowse.Document.GetElementById("username")
            Dim gPass As Gecko.GeckoElement = gwBrowse.Document.GetElementById("password")
            BadPassUser = CType(gUser, Gecko.DOM.GeckoInputElement).Value
            BadPassOldPass = CType(gPass, Gecko.DOM.GeckoInputElement).Value
            DontFocus = False
            EndBadPass(3)
          Case "savePass"
            Dim gOld As Gecko.GeckoElement = gwBrowse.Document.GetElementById("oldpassword")
            Dim gNew As Gecko.GeckoElement = gwBrowse.Document.GetElementById("newpassword")
            BadPassOldPass = CType(gOld, Gecko.DOM.GeckoInputElement).Value
            BadPassPass = CType(gNew, Gecko.DOM.GeckoInputElement).Value
            DontFocus = False
            EndBadPass(5)
          Case "noSaveLogin", "noSavePass"
            DontFocus = False
            UpdateBadPass()
          Case "togglePass"
            Dim gPass As Gecko.GeckoElement = gwBrowse.Document.GetElementById("password")
            If gPass.GetAttribute("type") = "password" Then
              gPass.SetAttribute("type", "text")
            Else
              gPass.SetAttribute("type", "password")
            End If
          Case "toggleOldPass"
            Dim gPass As Gecko.GeckoElement = gwBrowse.Document.GetElementById("oldpassword")
            If gPass.GetAttribute("type") = "password" Then
              gPass.SetAttribute("type", "text")
            Else
              gPass.SetAttribute("type", "password")
            End If
          Case "toggleNewPass"
            Dim gPass As Gecko.GeckoElement = gwBrowse.Document.GetElementById("newpassword")
            If gPass.GetAttribute("type") = "password" Then
              gPass.SetAttribute("type", "text")
            Else
              gPass.SetAttribute("type", "password")
            End If
          Case "cmdSetEMail"
            Dim gTE As Gecko.DOM.GeckoInputElement = gwBrowse.Document.GetElementById("txtEMail")
            Dim sEMail As String = gTE.Value
            Dim gE As Gecko.GeckoHtmlElement = gwBrowse.Document.GetElementById("CHANGE_E")
            gE.Parent.RemoveChild(gE)
            DontFocus = False
            RaiseEvent EMailChange(sEMail)
          Case "cmdNoEMail"
            Dim gE As Gecko.GeckoHtmlElement = gwBrowse.Document.GetElementById("CHANGE_E")
            gE.Parent.RemoveChild(gE)
            DontFocus = False
          Case "cmdSetPassword"
            Dim gTE As Gecko.DOM.GeckoInputElement = gwBrowse.Document.GetElementById("txtPassword")
            Dim sPassword As String = gTE.Value
            Dim gP As Gecko.GeckoHtmlElement = gwBrowse.Document.GetElementById("CHANGE_P")
            gP.Parent.RemoveChild(gP)
            DontFocus = False
            RaiseEvent PassChange(sPassword)
          Case "cmdNoPassword"
            Dim gP As Gecko.GeckoHtmlElement = gwBrowse.Document.GetElementById("CHANGE_P")
            gP.Parent.RemoveChild(gP)
            DontFocus = False
        End Select
      End If
    End If
    RaiseEvent MouseUp(Me, New MouseEventArgs(e.Button, 1, e.ClientX, e.ClientY, 0))
  End Sub
#End Region
#Region "Title Grabber Events"
  Private Delegate Sub titleGrabber_UpdateHTMLObjectCallBack(URL As String, ContentType As String, ContentLength As UInt32)
  Private Sub titleGrabber_UpdateHTMLObject(URL As String, ContentType As String, ContentLength As UInt32) Handles titleGrabber.UpdateHTMLObject
    If gwBrowse.InvokeRequired Then
      gwBrowse.BeginInvoke(New titleGrabber_UpdateHTMLObjectCallBack(AddressOf titleGrabber_UpdateHTMLObject), URL, ContentType, ContentLength)
    Else
      If gwBrowse Is Nothing Then Exit Sub
      If gwBrowse.Document Is Nothing Then Exit Sub
      Try
        For Each el In gwBrowse.Document.GetElementsByName("URL")
          If String.IsNullOrEmpty(el.GetAttribute("href")) Then Continue For
          Dim sHREF As String = el.GetAttribute("href")
          sHREF = sHREF.Substring(1)
          If Not sHREF.Contains("://") Then sHREF = "http://" & sHREF
          If String.Compare(sHREF, URL, True) = 0 Then
            Dim rndID As String
            Do
              rndID = String.Empty
              For I As Integer = 0 To (Int(Rnd() * 4) + 8)
                rndID &= Chr(Int(Rnd() * 26) + 65)
              Next
            Loop While gwBrowse.Document.GetHtmlElementById(rndID) IsNot Nothing
            el.SetAttribute("href", "##" & URL)
            el.SetAttribute("name", "URL")
            If ContentLength > 0 Then
              el.SetAttribute("title", ContentType & " (" & ByteSize(ContentLength) & ")")
            Else
              el.SetAttribute("title", ContentType)
            End If
            el.SetAttribute("onclick", "toggleObject('" & rndID & "');")
            Dim elP = el.Parent
            Select Case ContentType
              Case "image/gif", "image/jpeg", "image/png", "image/svg+xml", "image/tiff", "image/vnd.microsoft.icon", "image/*"
                elP.InnerHtml &= "<div id=""" & rndID & """ style=""display: none; width: 100%; text-align: center;""><br><a href=""#" & URL & """ name=""THUMBURL""><img src=""http://rcb.realityripple.com/thumbs/upload.php?url=" & IIf(URL.Contains("://"), URL.Replace("&", "%26"), "http://" & URL.Replace("&", "%26")) & """ title=""" & ContentType & " (" & ByteSize(ContentLength) & ")"" alt=""" & URL & """ style=""border: 0px;""></a></div>"
              Case "audio/wave", "audio/wav", "audio/x-wav", "audio/x-pn-wav", "audio/webm", "audio/ogg", "audio/*"
                elP.InnerHtml &= "<div id=""" & rndID & """ style=""display: none; width: 100%; text-align: center;""><br><audio src=""" & URL & """ controls=""controls"" preload=""metadata"">Unable to load!</audio></div>"
              Case "video/webm", "video/ogg", "application/ogg", "video/*"
                elP.InnerHtml &= "<div id=""" & rndID & """ style=""display: none; width: 100%; text-align: center;""><br><video controls=""controls""><source src=""" & URL & """ type=""" & ContentType & """>Unable to load!</video></div>"
              Case Else
                Dim eURI As Uri
                If URL.Contains("://") Then
                  eURI = New Uri(URL)
                Else
                  eURI = New Uri("http://" & URL)
                End If
                If ContentType.ToLower.Contains("youtube") Then
                  Dim sVid As String = String.Empty
                  If Not String.IsNullOrEmpty(eURI.Query) Then
                    Dim eQuery() As String = Split(eURI.Query.Substring(1), "&")
                    For I As Integer = 0 To eQuery.Length - 1
                      If eQuery(I).ToLower.StartsWith("v=", True, Nothing) Then
                        sVid = eQuery(I).Substring(2)
                        Exit For
                      End If
                    Next
                  End If
                  If String.IsNullOrEmpty(sVid) Then
                    If eURI.AbsolutePath.StartsWith("/embed/", True, Nothing) Then
                      sVid = eURI.AbsolutePath.Substring(7)
                    ElseIf eURI.AbsolutePath.StartsWith("/v/", True, Nothing) Then
                      sVid = eURI.AbsolutePath.Substring(3)
                    ElseIf eURI.Host.EndsWith("youtu.be", True, Nothing) Then
                      sVid = eURI.AbsolutePath.Substring(1)
                    End If
                  End If
                  If String.IsNullOrEmpty(sVid) Then
                    elP.InnerHtml &= "<div id=""" & rndID & """ style=""display: none; width: 100%; text-align: center;""><br><a href=""#" & URL & """><object data=""" & URL & """ type=""" & ContentType & """ style=""border: 0px;""></a></div>"
                  Else
                    If sVid.Contains("/") Then sVid = sVid.Substring(0, sVid.IndexOf("/"))
                    If sVid.Contains("?") Then sVid = sVid.Substring(0, sVid.IndexOf("?"))
                    'Dim imgURL As String = "http://i3.ytimg.com/vi/" & sVid & "/hqdefault.jpg"
                    Dim vidTitle As String = ContentType.Replace("""", "&quot;")
                    Dim embedURL = "http://www.youtube.com/embed/" & sVid & "?modestbranding=1&amp;html5=1&amp;showinfo=0&amp;showsearch=0&amp;rel=0&amp;iv_load_policy=3&amp;hd=0"
                    elP.InnerHtml &= "<div id=""" & rndID & """ style=""display: none; width: 100%; text-align: center;""><br><iframe class=""youtube-player"" style=""background-color: black;"" type=""text/html"" src=""" & embedURL & """ frameborder=""0""></iframe></div>"
                  End If
                Else
                  elP.InnerHtml &= "<div id=""" & rndID & """ style=""display: none; width: 100%; text-align: center;""><br><a href=""#" & URL & """><object data=""" & URL & """ type=""" & ContentType & """ style=""border: 0px;""></a></div>"
                End If
            End Select
          End If
        Next
      Catch

      End Try
    End If
  End Sub
  Private Delegate Sub titleGrabber_UpdateHTMLTitleCallBack(sID As String, sMessage As String)
  Private Sub titleGrabber_UpdateHTMLTitle(URL As String, Title As String) Handles titleGrabber.UpdateHTMLTitle
    If gwBrowse.InvokeRequired Then
      gwBrowse.BeginInvoke(New titleGrabber_UpdateHTMLTitleCallBack(AddressOf titleGrabber_UpdateHTMLTitle), URL, Title)
    Else
      If gwBrowse Is Nothing Then Exit Sub
      If gwBrowse.Document Is Nothing Then Exit Sub
      For Each el In gwBrowse.Document.GetElementsByName("URL")
        If String.IsNullOrEmpty(el.GetAttribute("href")) Then Continue For
        Dim sHREF As String = el.GetAttribute("href")
        'sHREF = sHREF.Substring(sHREF.IndexOf("#") + 1)
        'If Not sHREF.StartsWith("http://") Then sHREF = "http://" & sHREF
        sHREF = sHREF.Substring(1)
        If Not sHREF.Contains("://") Then sHREF = "http://" & sHREF
        If String.Compare(sHREF, URL, True) = 0 Then
          If String.IsNullOrEmpty(Title) Then
            el.SetAttribute("title", "[No Title] " & URL)
          Else
            el.SetAttribute("title", Title)
          End If
        End If
      Next
    End If
  End Sub
#End Region
#Region "Time Stamps"
  Public Property TimeStampFormat As String
    Get
      Return sTimeStampFormat
    End Get
    Set(value As String)
      sTimeStampFormat = value
      RedoTimestamps()
    End Set
  End Property
  Public Sub ToggleTimestamps()
    Try
      bTimeStampEnabled = Not bTimeStampEnabled
      ToggleTimestamps(bTimeStampEnabled)
    Catch ex As Exception

    End Try
  End Sub
  Public Sub ToggleTimestamps(Enable As Boolean)
    Try
      bTimeStampEnabled = Enable
      If gwBrowse Is Nothing Then Exit Sub
      If Not gwBrowse.Created Then Exit Sub
      If gwBrowse.Document Is Nothing Then Exit Sub
      If gwBrowse.Document.DocumentElement Is Nothing Then Exit Sub
      Dim bScroll As Boolean = (CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollHeight - CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop < CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).OffsetHeight + ScrollGive)
      SetCSS(sCSS)
      If bScroll AndAlso gwBrowse.Document.GetElementsByTagName("tr").Count > 0 Then gwBrowse.Document.GetElementsByTagName("tr").Last.ScrollIntoView(False)
    Catch ex As Exception

    End Try
  End Sub
  Private Sub RedoTimestamps()
    Try
      If gwBrowse Is Nothing Then Exit Sub
      If Not gwBrowse.Created Then Exit Sub
      If gwBrowse.Document Is Nothing Then Exit Sub
      If gwBrowse.Document.DocumentElement Is Nothing Then Exit Sub
      Dim bScroll As Boolean = (CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollHeight - CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop < CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).OffsetHeight + ScrollGive)
      If String.IsNullOrEmpty(sTimeStampFormat) Then
        For Each el In gwBrowse.Document.GetElementsByName("timestamp")
          el.TextContent = String.Empty
        Next
      Else
        For Each el In gwBrowse.Document.GetElementsByName("timestamp")
          el.TextContent = TimeValue(el.GetAttribute("time")).ToString(sTimeStampFormat)
        Next
      End If
      If bScroll AndAlso gwBrowse.Document.GetElementsByTagName("tr").Count > 0 Then gwBrowse.Document.GetElementsByTagName("tr").Last.ScrollIntoView(False)
    Catch ex As Exception
    End Try
  End Sub
#End Region
#Region "Join/Leave Messages"
  Private Delegate Sub ToggleJoinLeaveCallBack()
  Public Sub ToggleJoinLeave()
    If Me.InvokeRequired Then
      If gwBrowse Is Nothing Then Exit Sub
      Me.Invoke(New ToggleJoinLeaveCallBack(AddressOf ToggleJoinLeave))
    Else
      bJoinLeave = Not bJoinLeave
      If gwBrowse Is Nothing Then Exit Sub
      If Not gwBrowse.Created Then Exit Sub
      ToggleJoinLeave(bJoinLeave)
    End If
  End Sub
  Private Delegate Sub ToggleJoinLeave2CallBack(Enable As Boolean)
  Public Sub ToggleJoinLeave(Enable As Boolean)
    If Me.InvokeRequired Then
      If gwBrowse Is Nothing Then Exit Sub
      Me.Invoke(New ToggleJoinLeave2CallBack(AddressOf ToggleJoinLeave), Enable)
    Else
      bJoinLeave = Enable
      If gwBrowse Is Nothing Then Exit Sub
      If gwBrowse.Document Is Nothing Then Exit Sub
      Dim bScroll As Boolean = (CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollHeight - CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop < CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).OffsetHeight + ScrollGive)
      SetCSS(sCSS)
      If bScroll AndAlso gwBrowse.Document.GetElementsByTagName("tr").Count > 0 Then gwBrowse.Document.GetElementsByTagName("tr").Last.ScrollIntoView(False)
    End If
  End Sub
#End Region
#Region "Bottom"
  Public ReadOnly Property AtBottom As Boolean
    Get
      Try
        If gwBrowse Is Nothing Then Return False
        If gwBrowse.InvokeRequired Then
          Return gwBrowse.Invoke(New AtBottomCallBack(AddressOf isAtBottom))
        Else
          Return isAtBottom()
        End If
      Catch ex As Exception
        Return False
      End Try
    End Get
  End Property
  Public Sub ToBottom()
    If gwBrowse Is Nothing Then Exit Sub
    If gwBrowse.InvokeRequired Then
      gwBrowse.BeginInvoke(New MethodInvoker(AddressOf ToBottom))
    Else
      Try
        If gwBrowse.Document Is Nothing Then Exit Sub
        Dim DocEl As Gecko.DOM.GeckoHtmlHtmlElement = gwBrowse.Document.DocumentElement
        If DocEl.ScrollHeight = DocEl.OffsetHeight Then
          'DAMN YOU ANNOYING BULLSHIT
          GoDownOnFocus = True
        Else
          DocEl.ScrollTop = DocEl.ScrollHeight - DocEl.OffsetHeight
        End If
      Catch

      End Try
    End If
  End Sub
  Private Delegate Function AtBottomCallBack() As Boolean
  Private Function isAtBottom() As Boolean
    If gwBrowse Is Nothing Then Return False
    SyncLock gwBrowse
      If gwBrowse.Document Is Nothing Then Return False
      If gwBrowse.Document.DocumentElement Is Nothing Then Return False
      Return (CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollHeight - CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop < CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).OffsetHeight + ScrollGive)
    End SyncLock
  End Function
#End Region
#Region "Emoticons"
  Public Property Emoticons As Boolean
    Get
      Return bEmoticons
    End Get
    Set(value As Boolean)
      bEmoticons = value
      RedoEmoticons()
    End Set
  End Property
  Private Sub RedoEmoticons()
    If gwBrowse Is Nothing Then Exit Sub
    If Not gwBrowse.Created Then Exit Sub
    Try
      If CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).GetElementsByTagName("span").Count > 0 Then
        Dim bScroll As Boolean = (CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollHeight - CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop < CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).OffsetHeight + ScrollGive)
        Dim els = (From elItems In gwBrowse.Document.GetElementsByTagName("span") Where InStr(elItems.ClassName, "usertext") > 0)
        If els.Count > 0 Then
          For Each el In els
            If bEmoticons Then
              el.InnerHtml = AddEmotes(el.InnerHtml)
            Else
              el.InnerHtml = RemoveEmotes(el.InnerHtml)
            End If
          Next
        Else
          els = (From elItems In gwBrowse.Document.GetElementsByTagName("div") Where InStr(elItems.ClassName, "contents") > 0)
          For Each el In els
            If bEmoticons Then
              el.InnerHtml = AddEmotes(el.InnerHtml)
            Else
              el.InnerHtml = RemoveEmotes(el.InnerHtml)
            End If
          Next
        End If
        If bScroll AndAlso gwBrowse.Document.GetElementsByTagName("tr").Count > 0 Then gwBrowse.Document.GetElementsByTagName("tr").Last.ScrollIntoView(False)
      End If
    Catch ex As Exception
    End Try
  End Sub
  Private Function AddEmotes(sMessage As String) As String
    Dim sEmotes() As String = Split(My.Resources.EMOTICONS, vbNewLine)
    For Each sEmote In sEmotes
      Dim sEmoticon As String = sEmote.Split(vbTab)(0)
      Dim sFile As String = sEmote.Split(vbTab)(1)
      sEmoticon = sEmoticon.Replace("<", "&lt;")
      sEmoticon = sEmoticon.Replace(">", "&gt;")
      EmoteCheck(sMessage, sEmoticon, sFile)
    Next
    Return sMessage
  End Function
  Private Sub EmoteCheck(ByRef Message As String, sEmote As String, sFile As String)
    Dim hasNBSP As Boolean = Message.StartsWith("&nbsp;", True, Nothing)
    If hasNBSP Then Message = " " & Message.Substring(6)
    If Message = sEmote Then
      Message = "<img src=""chrome://entelechy/skin/emote/" & sFile & ".svg"" class=""emoticon"" title=""" & sEmote & """ alt=""" & sEmote & """>"
    ElseIf Message.Length > sEmote.Length Then
      If Message.Substring(0, sEmote.Length + 1) = sEmote & " " Then
        Message = "<img src=""chrome://entelechy/skin/emote/" & sFile & ".svg"" class=""emoticon"" title=""" & sEmote & """ alt=""" & sEmote & """>" & Message.Substring(sEmote.Length)
      End If
      While Message.Contains(" " & sEmote & " ")
        Message = Message.Replace(" " & sEmote & " ", " <img src=""chrome://entelechy/skin/emote/" & sFile & ".svg"" class=""emoticon"" title=""" & sEmote & """ alt=""" & sEmote & """> ")
      End While
      If Message.Substring(Message.Length - sEmote.Length - 1) = " " & sEmote Then
        Message = Message.Substring(0, Message.Length - sEmote.Length - 1) & " <img src=""chrome://entelechy/skin/emote/" & sFile & ".svg"" class=""emoticon"" title=""" & sEmote & """ alt=""" & sEmote & """>"
      End If
    End If
    If hasNBSP Then Message = "&nbsp;" & Message.Substring(1)
  End Sub
  Private Function RemoveEmotes(sMessage As String) As String
    If InStr(sMessage, "img") > 0 Then
      Dim regx As New Regex("<img src=""chrome://entelechy/skin/emote/\S+\.svg"" class=""emoticon"" title=""[^"" <>]+"" alt=""[^"" <>]+"">", RegexOptions.IgnoreCase)
      Dim mactches As MatchCollection = regx.Matches(sMessage)
      For Each match As Match In mactches
        sMessage = sMessage.Replace(match.Value, match.Value.Substring(match.Value.LastIndexOf("alt=""") + 5, match.Value.LastIndexOf(""">") - (match.Value.LastIndexOf("alt=""") + 5)))
      Next
    End If
    Return sMessage
  End Function
#End Region
#Region "Logging"
  Public Property LogFile As String
    Get
      Return sLogFile
    End Get
    Set(value As String)
      If String.IsNullOrEmpty(sLogFile) And Not String.IsNullOrEmpty(value) Then
        sLogFile = value
        SaveLog("<tr><td style=""display: table-cell;"" time=""" & Now & """ name=""timestamp"" class=""timestamp"">" & Now.ToString(sTimeStampFormat) & "&nbsp;</td><td class=""chat""><table class=""message""><tr><td><div class=""contents""><span class=""info"">Logging Enabled - " & Now.ToString("D") & ".</span></div></td></tr></table></td></tr>")
        SaveLog("<tr><td colspan=""2""><hr></td></tr>")
      ElseIf Not String.IsNullOrEmpty(sLogFile) And String.IsNullOrEmpty(value) Then
        SaveLog("<tr><td colspan=""2""><hr></td></tr>")
        SaveLog("<tr><td style=""display: table-cell;"" time=""" & Now & """ name=""timestamp"" class=""timestamp"">" & Now.ToString(sTimeStampFormat) & "&nbsp;</td><td class=""chat""><table class=""message""><tr><td><div class=""contents""><span class=""info"">Logging Disabled - " & Now.ToString("D") & ".</span></div></td></tr></table></td></tr>")
        sLogFile = String.Empty
      Else
        sLogFile = value
      End If
    End Set
  End Property
  Private Sub SaveLog(Line As String)
    If Not My.Computer.FileSystem.FileExists(sLogFile) Then
      If Not My.Computer.FileSystem.DirectoryExists(IO.Path.GetDirectoryName(sLogFile)) Then My.Computer.FileSystem.CreateDirectory(IO.Path.GetDirectoryName(sLogFile))
      My.Computer.FileSystem.WriteAllText(sLogFile, "<!DOCTYPE html>" & vbNewLine &
                                                   "<html lang=""en"">" & vbNewLine &
                                                   " <head>" & vbNewLine &
                                                   "  <title>" & IO.Path.GetFileNameWithoutExtension(sLogFile) & " Chat Log</title>" & vbNewLine &
                                                   "  <meta http-equiv=""Content-Type"" content=""text/html; charset=utf-8"" />" & vbNewLine &
                                                   "  <style type=""text/css"">" & vbNewLine &
                                                   "   " & DefaultCSS.Replace("\n", String.Empty) & vbNewLine &
                                                   "  </style>" & vbNewLine &
                                                   " </head>" & vbNewLine &
                                                   " <body>" & vbNewLine &
                                                   "  <table class=""chat"">" & vbNewLine &
                                                   "  </table>" & vbNewLine &
                                                   " </body>" & vbNewLine &
                                                   "</html>", False)
    End If
    If Not sLogFile.Contains(Now.ToString("yyyy'-'MM'-'dd")) Then
      LogFile = IO.Path.GetDirectoryName(sLogFile) & "\" & Now.ToString("yyyy'-'MM'-'dd") & ".html"
      SaveLog(Line)
      Exit Sub
    End If
    Dim sText As String = My.Computer.FileSystem.ReadAllText(sLogFile)
    If sText.Contains("  </table>") Then
      Dim sBegin As String = sText.Substring(0, sText.LastIndexOf("  </table>") - 1)
      Dim sEnd As String = sText.Substring(sText.LastIndexOf("  </table>"))
      If Line.Contains("style=""display: none;"" ") Then Line = Line.Replace("style=""display: none;"" ", String.Empty)
      If Line.Contains("href=""#") Then Line = Line.Replace("href=""#", "href=""")
      If Line.Contains("time=") And Line.Contains(" name=""timestamp""") Then Line = Line.Substring(0, Line.IndexOf("time=") - 1) & Line.Substring(Line.IndexOf("name=""timestamp""") + 16)
      Line = RemoveEmotes(Line)
      sText = sBegin & vbNewLine & "   " & Line & vbNewLine & sEnd
      My.Computer.FileSystem.WriteAllText(sLogFile, sText, False)
    Else
      My.Computer.FileSystem.DeleteFile(sLogFile)
      SaveLog(Line)
    End If
  End Sub
#End Region
#Region "Line Limits"
  Public Property MaxLines As UInt32
    Get
      Return lMaxLines
    End Get
    Set(value As UInt32)
      lMaxLines = value
      TrimLines()
    End Set
  End Property
  Private Sub TrimLines()
    If gwBrowse Is Nothing Then Exit Sub
    If Not gwBrowse.Created Then Exit Sub
    Dim tTable As Gecko.DOM.GeckoTableElement = gwBrowse.Document.Body.GetElementsByTagName("table").FirstOrDefault
    If tTable IsNot Nothing And lMaxLines > 0 Then
      If GetRows(tTable) > lMaxLines Then
        Do While GetRows(tTable) > lMaxLines - (lMaxLines / 10)
          If Not bJoinLeave Then
            Dim TRList = tTable.GetElementsByTagName("tr")
            'Dim iTable As Gecko.nsIDOMHTMLTableElement = tTable
            Dim JLList = gwBrowse.DomDocument.GetElementsByClassName("joinleave") 'iTable.GetElementsByClassName(New Gecko.nsAString("joinleave"))
            If JLList.Count > TRList.Count / 3 Then
              'More than a third join/leave messages, wipe them out first
              Dim fItem As Gecko.GeckoNode = JLList.Item(0)
              If fItem IsNot Nothing Then tTable.RemoveChild(fItem)
            Else
              Dim fItem As Gecko.GeckoHtmlElement = TRList.FirstOrDefault
              If fItem IsNot Nothing Then tTable.RemoveChild(fItem)
            End If
          Else
            Dim TRList = tTable.GetElementsByTagName("tr")
            Dim fItem As Gecko.GeckoHtmlElement = TRList.FirstOrDefault
            If fItem IsNot Nothing Then tTable.RemoveChild(fItem)
          End If
        Loop
      End If
    End If
  End Sub
#End Region
#Region "Properties"
  Public ReadOnly Property IsLoaded As Boolean
    Get
      If gwBrowse Is Nothing Then Return False
      If Not gwBrowse.Created Then Return False
      If gwBrowse.Document Is Nothing Then Return False
      'If gwBrowse.Url.AbsoluteUri.StartsWith("chrome://entelechy/content/box.html", True, Nothing) Then Return True
      'Debug.Print("BAD URL: " & gwBrowse.Url.ToString)
      'Clear()
      Return True
    End Get
  End Property
  Public Property RichText As Boolean
    Get
      Return bRichText
    End Get
    Set(value As Boolean)
      bRichText = value
    End Set
  End Property
#End Region
#Region "Functions and Subs"
  Public Sub SetCSS(StyleSheet As String)
    sCSS = Replace(StyleSheet, "\n", vbNewLine)
    If String.IsNullOrEmpty(sCSS) Then sCSS = DefaultCSS

    Dim sStyle As String = sCSS
    If Not bJoinLeave Then sStyle = Replace(sStyle & "\n.joinleave\n{\n display: none;\n}", "\n", vbNewLine)
    If Not bTimeStampEnabled Then sStyle = Replace(sStyle & "\n.timestamp\n{\n display: none;\n}", "\n", vbNewLine)

    If gwBrowse Is Nothing Then Exit Sub
    If gwBrowse.Document Is Nothing Then Exit Sub
    If gwBrowse.Document.StyleSheets.Count > 0 Then
      CType(gwBrowse.Document.DocumentElement.FirstChild, Gecko.GeckoHtmlElement).InnerHtml = "   <title>Entelechy ChatBox</title>   <style type=""text/css"">" & sStyle & "</style>   <meta http-equiv=""Content-Type"" content=""text/html; charset=utf-8"">"
    Else
      CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).Style.CssText = sStyle
    End If
    If Me.Parent IsNot Nothing AndAlso
         Me.Parent.Parent IsNot Nothing AndAlso
         Me.Parent.Parent.Parent IsNot Nothing AndAlso
         Me.Parent.Parent.Parent.Parent IsNot Nothing Then If Me.Parent.Parent.Parent.Parent.Name = "BNUI" Then CType(Me.Parent.Parent.Parent.Parent, BNUI).ParseCSS()
  End Sub
  Public Sub Clear()
    Dim iStart As Integer = Environment.TickCount
    Do Until IsLoaded
      Application.DoEvents()
      If Me.Disposing Or Me.IsDisposed Then Exit Sub
      If Environment.TickCount - iStart > 10000 Then
        GeckoChat_Load(Me, New EventArgs)
        If Not IsLoaded Then Exit Sub
        iStart = Environment.TickCount
      End If
    Loop
    gwBrowse.Navigate("chrome://entelechy/content/box.html")
  End Sub
  Public Sub ScrollTo(Delta As Integer)
    GoDownOnFocus = isAtBottom()
    If gwBrowse Is Nothing Then Exit Sub
    If gwBrowse.Document Is Nothing Then Exit Sub
    If gwBrowse.Document.DocumentElement Is Nothing Then Exit Sub
    Dim lY As Integer = CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop
    CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop = lY - ((Delta / 120) * 20 * 3)
  End Sub
#Region "Message Actions"
  Private Delegate Sub AddChatCallBack(ctType As ChatType, sName As String, sMessage As String, sMsgID As String, sNameToolTip As String, sMessageToolTip As String)
  Public Sub AddChat(ctType As ChatType, sName As String, sMessage As String, Optional sMsgID As String = Nothing, Optional sNameToolTip As String = Nothing, Optional sMessageToolTip As String = Nothing)
    'If gwBrowse Is Nothing Then Exit Sub
    If Me.InvokeRequired Then
      Me.BeginInvoke(New AddChatCallBack(AddressOf AddChat), ctType, sName, sMessage, sMsgID, sNameToolTip, sMessageToolTip)
    Else
      Do Until IsLoaded
        Application.DoEvents()
        If Me.Disposing Or Me.IsDisposed Then Exit Sub
      Loop
      'If Not gwBrowse.Created Then Exit Sub
      'Debug.Print(gwBrowse.Url.AbsoluteUri)
      If Not gwBrowse.Url.AbsoluteUri.StartsWith("chrome://entelechy/content/box.html", True, Nothing) Then Clear()
      If gwBrowse.IsBusy Then
        If tmrRetry.Tag Is Nothing Then tmrRetry.Tag = New ArrayList
        CType(tmrRetry.Tag, ArrayList).Add({ctType, sName, sMessage, sMsgID, sNameToolTip, sMessageToolTip})
        If Not tmrRetry.Enabled Then tmrRetry.Start()
        Exit Sub
      End If
      'Do While gwBrowse.IsBusy
      '  Application.DoEvents()
      'Loop
      Dim bScroll As Boolean = AtBottom
      Dim nTmp As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("tr")
      If ctType = ChatType.JoinLeave_Join Or ctType = ChatType.JoinLeave_Leave Then nTmp.ClassName = "joinleave"
      Dim nTimeStamp As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("td")
      nTimeStamp.ClassName = "timestamp"
      nTimeStamp.TextContent = Now.ToString(sTimeStampFormat)
      nTimeStamp.InnerHtml &= "&nbsp;"
      nTimeStamp.SetAttribute("name", "timestamp")
      nTimeStamp.SetAttribute("time", Now)
      nTmp.AppendChild(nTimeStamp)
      Dim nCtd As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("td")
      nCtd.ClassName = "chat"
      Dim nMessageTable As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("table")
      nMessageTable.ClassName = "message"
      If Not String.IsNullOrEmpty(sMessageToolTip) Then nMessageTable.SetAttribute("title", sMessageToolTip)
      Dim nMessageTR As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("tr")
      Dim nMessageTD As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("td")
      Dim nChat As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("div")
      nChat.ClassName = "contents"
      Select Case ctType
        Case ChatType.None
          HTMLizeMessage(sMessage)
          nChat.InnerHtml = sMessage
        Case ChatType.UserChat
          Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("a")
          nUser.ClassName = "user"
          If InStr(sName, ": ") > 0 Then
            nUser.SetAttribute("name", sName.Substring(sName.IndexOf(": ") + 2))
          Else
            nUser.SetAttribute("name", sName)
          End If
          nUser.TextContent = "<" & sName & ">"
          If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
          nChat.AppendChild(nUser)
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "text usertext"
          HTMLizeMessage(sMessage)
          nText.InnerHtml = "&nbsp;" & sMessage
          nChat.AppendChild(nText)
        Case ChatType.UserWhisper
          Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("a")
          nUser.ClassName = "user"
          If InStr(sName, ": ") > 0 Then
            nUser.SetAttribute("name", sName.Substring(sName.IndexOf(": ") + 2))
          Else
            nUser.SetAttribute("name", sName)
          End If
          nUser.TextContent = "<" & sName & ">"
          If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
          nChat.AppendChild(nUser)
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "whisper usertext"
          HTMLizeMessage(sMessage)
          nText.InnerHtml = "&nbsp;" & sMessage
          nChat.AppendChild(nText)
        Case ChatType.SelfChat
          Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("a")
          nUser.ClassName = "self"
          If InStr(sName, ": ") > 0 Then
            nUser.SetAttribute("name", sName.Substring(sName.IndexOf(": ") + 2))
          Else
            nUser.SetAttribute("name", sName)
          End If
          nUser.TextContent = "<" & sName & ">"
          If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
          nChat.AppendChild(nUser)
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "text usertext"
          HTMLizeMessage(sMessage)
          nText.InnerHtml = "&nbsp;" & sMessage
          nChat.AppendChild(nText)
        Case ChatType.FriendChat
          Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("a")
          nUser.ClassName = "friend"
          If InStr(sName, ": ") > 0 Then
            nUser.SetAttribute("name", sName.Substring(sName.IndexOf(": ") + 2))
          Else
            nUser.SetAttribute("name", sName)
          End If
          nUser.TextContent = "<" & sName & ">"
          If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
          nChat.AppendChild(nUser)
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "text usertext"
          HTMLizeMessage(sMessage)
          nText.InnerHtml = "&nbsp;" & sMessage
          nChat.AppendChild(nText)
        Case ChatType.StatChat
          Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("a")
          nUser.ClassName = "user"
          If InStr(sName, ": ") > 0 Then
            nUser.SetAttribute("name", sName.Substring(sName.IndexOf(": ") + 2))
          Else
            nUser.SetAttribute("name", sName)
          End If
          nUser.TextContent = "<" & sName & " (StatChat)>"
          If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
          nChat.AppendChild(nUser)
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "whisper usertext"
          HTMLizeMessage(sMessage)
          nText.InnerHtml = "&nbsp;" & sMessage
          nChat.AppendChild(nText)
        Case ChatType.Emote
          Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("a")
          nUser.ClassName = "user"
          nUser.SetAttribute("name", sName)
          nUser.TextContent = "<" & sName
          If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
          nChat.AppendChild(nUser)
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "emote usertext"
          HTMLizeMessage(sMessage)
          nText.InnerHtml = "&nbsp;" & sMessage & "&gt;"
          nChat.AppendChild(nText)
        Case ChatType.D2Emote
          Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("a")
          nUser.ClassName = "d2emote"
          nUser.SetAttribute("name", sName)
          nUser.TextContent = "*" & sName
          If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
          nChat.AppendChild(nUser)
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "d2emote usertext"
          HTMLizeMessage(sMessage)
          nText.InnerHtml = "&nbsp;" & sMessage & "*"
          nChat.AppendChild(nText)
        Case ChatType.ServiceInfo
          If Not String.IsNullOrEmpty(sName) Then
            Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
            nUser.ClassName = "protocol"
            nUser.TextContent = "[" & sName & "]"
            If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
            nChat.AppendChild(nUser)
          End If
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "info"
          HTMLizeMessage(sMessage)
          nText.InnerHtml = IIf(Not String.IsNullOrEmpty(sName), "&nbsp;", "") & sMessage
          nChat.AppendChild(nText)
        Case ChatType.ServiceError
          If Not String.IsNullOrEmpty(sName) Then
            Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
            nUser.ClassName = "protocol"
            nUser.TextContent = "[" & sName & "]"
            If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
            nChat.AppendChild(nUser)
          End If
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "error"
          HTMLizeMessage(sMessage)
          nText.InnerHtml = IIf(Not String.IsNullOrEmpty(sName), "&nbsp;", "") & sMessage
          nChat.AppendChild(nText)
        Case ChatType.ServiceSuccess
          If Not String.IsNullOrEmpty(sName) Then
            Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
            nUser.ClassName = "protocol"
            nUser.TextContent = "[" & sName & "]"
            If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
            nChat.AppendChild(nUser)
          End If
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "success"
          HTMLizeMessage(sMessage)
          nText.InnerHtml = IIf(Not String.IsNullOrEmpty(sName), "&nbsp;", "") & sMessage
          nChat.AppendChild(nText)
        Case ChatType.ServiceBroadcast
          If Not String.IsNullOrEmpty(sName) Then
            Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
            nUser.ClassName = "protocol"
            nUser.TextContent = "[" & sName & "]"
            If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
            nChat.AppendChild(nUser)
          End If
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "broadcast"
          HTMLizeMessage(sMessage)
          nText.InnerHtml = IIf(Not String.IsNullOrEmpty(sName), "&nbsp;", "") & sMessage
          nChat.AppendChild(nText)
        Case ChatType.VerboseInfo
          If Not String.IsNullOrEmpty(sName) Then
            Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
            nUser.ClassName = "protocol"
            nUser.TextContent = "{" & sName & "}"
            If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
            nChat.AppendChild(nUser)
          End If
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "whisper"
          nText.InnerHtml = IIf(Not String.IsNullOrEmpty(sName), "&nbsp;", "") & sMessage
          nChat.AppendChild(nText)
        Case ChatType.HelpInfo
          Dim nCommand As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nCommand.ClassName = "info"
          nCommand.TextContent = sName & " - "
          nChat.AppendChild(nCommand)
          If InStr(sMessage, "|") > 0 Then
            Dim sParts() As String = sMessage.Split("|")
            Dim nDescription As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
            nDescription.ClassName = "text"
            nDescription.InnerHtml = sParts(0)
            nChat.AppendChild(nDescription)
            Dim nExtra As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
            nExtra.ClassName = "whisper"
            nExtra.InnerHtml = sParts(1)
            nChat.AppendChild(nExtra)
          Else
            Dim nDescription As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
            nDescription.ClassName = "text"
            nDescription.InnerHtml = sMessage
            nChat.AppendChild(nDescription)
          End If
        Case ChatType.JoinLeave_Join
          Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("a")
          nUser.ClassName = "user success"
          nUser.SetAttribute("name", sName)
          nUser.TextContent = sName
          If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
          nChat.AppendChild(nUser)
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "success"
          HTMLizeMessage(sMessage)
          nText.InnerHtml = "&nbsp;" & sMessage
          nChat.AppendChild(nText)
        Case ChatType.JoinLeave_Leave
          Dim nUser As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("a")
          nUser.ClassName = "user error"
          nUser.SetAttribute("name", sName)
          nUser.TextContent = sName
          If Not String.IsNullOrEmpty(sNameToolTip) Then nUser.SetAttribute("title", sNameToolTip)
          nChat.AppendChild(nUser)
          Dim nText As Gecko.GeckoHtmlElement = gwBrowse.Document.CreateElement("span")
          nText.ClassName = "error"
          HTMLizeMessage(sMessage)
          nText.InnerHtml = "&nbsp;" & sMessage
          nChat.AppendChild(nText)
      End Select
      'For Each item In TraverseTextContent(nChat)
      '  If item.NodeValue.Length > 20 And Not item.NodeValue.Contains(" ") Then
      '    item.ParentElement.InnerHtml = InsertSoftHyphens(item.ParentElement.InnerHtml)
      '  End If
      'Next
      nMessageTD.AppendChild(nChat)
      nMessageTR.AppendChild(nMessageTD)
      nMessageTable.AppendChild(nMessageTR)
      nCtd.AppendChild(nMessageTable)
      nTmp.AppendChild(nCtd)
      If Not String.IsNullOrEmpty(LogFile) Then SaveLog("<tr>" & nTmp.InnerHtml & "</tr>")
      If Not String.IsNullOrEmpty(sMsgID) Then nTmp.SetAttribute("id", sMsgID)
      gwBrowse.Document.Body.GetElementsByTagName("table")(0).AppendChild(nTmp)
      TrimLines()
      If bScroll Then ToBottom()
      SelectUser(SelectedUsername)
      If Me.Parent IsNot Nothing AndAlso Me.Parent.Parent IsNot Nothing AndAlso Me.Parent.Parent.Parent IsNot Nothing AndAlso Me.Parent.Parent.Parent.Parent IsNot Nothing Then
        If Me.Parent.Parent.Parent.Parent.Name = "BNUI" Then
          Static lastUpdate As Integer
          If Environment.TickCount - lastUpdate > 1000 Then
            frmMain.UpdatePreviewBitmap(Me.Parent.Parent.Parent.Parent.Tag)
            lastUpdate = Environment.TickCount
          End If
        End If
      End If
    End If
  End Sub
  Private Sub tmrRetry_Tick(sender As System.Object, e As System.EventArgs) Handles tmrRetry.Tick
    tmrRetry.Stop()
    If tmrRetry.Tag IsNot Nothing Then
      Dim sItems As ArrayList = tmrRetry.Tag
      sItems = sItems.Clone
      tmrRetry.Tag = Nothing
      For Each item In sItems
        Dim ctType As ChatType = item(0)
        Dim sName As String = item(1)
        Dim sMessage As String = item(2)
        Dim sMsgID As String = item(3)
        Dim sNameToolTip As String = item(4)
        Dim sMessageToolTip As String = item(5)
        AddChat(ctType, sName, sMessage, sMsgID, sNameToolTip, sMessageToolTip)
      Next
    End If
  End Sub
  Private SelectedUsername As String
  Public Sub SelectUser(Username As String)
    SelectedUsername = Username
    If gwBrowse Is Nothing Then Exit Sub
    If gwBrowse.Document Is Nothing Then Exit Sub
    If gwBrowse.Document.GetElementsByTagName("tr").Count > 0 Then
      For Each contents In gwBrowse.Document.GetElementsByClassName("contents")
        'If row.ChildNodes.Count > 1 Then Debug.Print(row.ChildNodes(1).TextContent)
        If contents.ChildNodes.Count > 0 Then
          Try
            If contents.FirstChild.NodeType = Gecko.NodeType.Text Then
              'nada
            Else
              Dim nFirst As Gecko.GeckoHtmlElement = contents.FirstChild
              If nFirst.TagName.ToLower = "a" Then
                If Not String.IsNullOrEmpty(Username) AndAlso String.Compare(nFirst.GetAttribute("name"), Username, True) = 0 Then
                  nFirst.SetAttribute("style", "outline: thin dotted white; outline-offset: -3px;")
                Else
                  If nFirst.HasAttribute("style") Then nFirst.RemoveAttribute("style")
                End If
              End If
            End If

          Catch ex As Exception

          End Try
        End If
      Next
    End If
  End Sub
#Region "Progress"
  Private Delegate Sub UpdateProgressCallBack(sID As String, sMessage As String)
  Public Sub UpdateProgress(sID As String, sMessage As String)
    If gwBrowse Is Nothing Then Exit Sub
    If Me.InvokeRequired Then
      Dim d As New UpdateProgressCallBack(AddressOf UpdateProgress)
      Me.BeginInvoke(d, New Object() {sID, sMessage})
    Else
      If gwBrowse Is Nothing Then Exit Sub
      If gwBrowse.Document Is Nothing Then Exit Sub
      Dim nTmp As Gecko.GeckoHtmlElement = gwBrowse.Document.GetHtmlElementById(sID)
      If nTmp IsNot Nothing Then
        HTMLizeMessage(sMessage)
        If sID = "FULL" Then sMessage &= " [<a name=""FULL"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL") & """>" & ResMan.GetString("CMD_CANCEL") & "</a>]"
        nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = sMessage
      End If
    End If
  End Sub
  Private Delegate Sub TerminateProgressCallBack(sID As String, sMessage As String)
  Public Sub TerminateProgress(sID As String, Optional sFinalMessage As String = Nothing)
    If gwBrowse Is Nothing Then Exit Sub
    If Me.InvokeRequired Then
      Dim d As New TerminateProgressCallBack(AddressOf TerminateProgress)
      Me.BeginInvoke(d, New Object() {sID, sFinalMessage})
    Else
      Do
        If gwBrowse.Document Is Nothing Then Exit Do
        Dim nTmp As Gecko.GeckoHtmlElement = gwBrowse.Document.GetHtmlElementById(sID)
        If nTmp IsNot Nothing Then
          If sFinalMessage IsNot Nothing Then
            HTMLizeMessage(sFinalMessage)
            nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = sFinalMessage
          End If
          nTmp.Id = Nothing
        Else
          Exit Do
        End If
      Loop
    End If
  End Sub
#End Region
#Region "Reconnect"
  Private Delegate Sub ReconnectAlertCallBack(Message As String, Left As UShort)
  Public Sub ReconnectAlert(Message As String, Left As UShort)
    If gwBrowse Is Nothing Then Exit Sub
    If Me.InvokeRequired Then
      Me.BeginInvoke(New ReconnectAlertCallBack(AddressOf ReconnectAlert), Message, Left)
    Else
      Dim nTmp As Gecko.GeckoHtmlElement = gwBrowse.Document.GetHtmlElementById("CONRET")
      If nTmp IsNot Nothing Then
        tmrReconnect.Stop()
        EndReconnect(False)
      End If
      ReconnectMessage = Message
      ReconnectLeft = Left
      AddChat(ChatType.ServiceError, My.Resources.PROTOCOL_BNCS, ReconnectMessage, "CONRET")
      tmrReconnect.Start()
    End If
  End Sub
  Private Sub UpdateReconnect(Optional ar As IAsyncResult = Nothing)
    If gwBrowse.InvokeRequired Then
      'Try
      gwBrowse.BeginInvoke(New AsyncCallback(AddressOf UpdateReconnect), ar)
      'Catch ex As Exception
      'Exit Sub
      'End Try
    Else
      If ar IsNot Nothing Then
        Dim someObj = gwBrowse.EndInvoke(ar)
        Stop
      End If
      Try
        If gwBrowse.Document Is Nothing Then Exit Sub
        Dim nTmp As Gecko.GeckoHtmlElement = gwBrowse.Document.GetHtmlElementById("CONRET")
        If nTmp IsNot Nothing Then
          HTMLizeMessage(ReconnectMessage)
          nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = ReconnectMessage & " [<a name=""CONRET"" href=""#OK"">" & ResMan.GetString("CMD_RECONNECT") & "</a> (" & ConvertTime(ReconnectLeft * 1000, True) & ")] [<a name=""CONRET"" href=""#CANCEL"">" & ResMan.GetString("CMD_CANCEL") & "</a>]"
          If ReconnectLeft = 0 Then
            EndReconnect(True)
          Else
            ReconnectLeft -= 1
          End If
        End If
      Catch ex As Exception
        Exit Sub
      End Try
    End If
  End Sub
  Private Delegate Sub EndReconnectCallBack(Ret As Boolean)
  Public Sub EndReconnect(Ret As Boolean)
    If Me.InvokeRequired Then
      Me.BeginInvoke(New EndReconnectCallBack(AddressOf EndReconnect), Ret)
    Else
      tmrReconnect.Stop()
      Dim nTmp As Gecko.GeckoHtmlElement = gwBrowse.Document.GetHtmlElementById("CONRET")
      If nTmp IsNot Nothing Then
        If Not String.IsNullOrEmpty(ReconnectMessage) Then nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = ReconnectMessage
        nTmp.Id = Nothing
      End If
      ReconnectMessage = Nothing
      ReconnectLeft = 0
      'If nTmp IsNot Nothing Then
      'gwBrowse.Document.Body.GetElementsByTagName("table")(0).RemoveChild(nTmp)
      'End If
      RaiseEvent ReconnectResult(Me, Ret)
    End If
  End Sub
  Private Sub tmrReconnect_Elapsed(sender As Object, e As System.Timers.ElapsedEventArgs) Handles tmrReconnect.Elapsed
    UpdateReconnect()
  End Sub
#End Region
#Region "Error"
#Region "Bad Password"
  Private Delegate Sub BadPassAlertCallBack(ctType As ChatType, sName As String, sMessage As String, iIDs As Integer, sUsername As String, sPassword As String, sNewPassword As String)
  Public Sub BadPassAlert(ctType As ChatType, sName As String, sMessage As String, iID As Integer, sUsername As String, sPassword As String, sNewPassword As String)
    If gwBrowse Is Nothing Then Exit Sub
    If Me.InvokeRequired Then
      Me.BeginInvoke(New BadPassAlertCallBack(AddressOf BadPassAlert), ctType, sName, sMessage, iID, sUsername, sPassword, sNewPassword)
    Else
      Dim nTmp As Gecko.GeckoHtmlElement = gwBrowse.Document.GetHtmlElementById("BADPASS")
      If nTmp IsNot Nothing Then
        tmrBadPass.Stop()
        EndBadPass(0)
        'EndReconnect(False)
      End If
      BadPassMessage = sMessage
      BadPassLeft = 30
      BadPassID = iID
      BadPassUser = sUsername
      BadPassOldPass = sPassword
      BadPassPass = sNewPassword
      AddChat(ctType, sName, sMessage, "BADPASS")
      tmrBadPass.Start()
    End If
  End Sub
  Private Sub UpdateBadPass()
    If Me.InvokeRequired Then
      Try
        Me.BeginInvoke(New MethodInvoker(AddressOf UpdateBadPass))
      Catch ex As Exception
        Exit Sub
      End Try
    Else
      Try
        If gwBrowse.Document Is Nothing Then Exit Sub
        Dim nTmp As Gecko.GeckoHtmlElement = gwBrowse.Document.GetHtmlElementById("BADPASS")
        If nTmp IsNot Nothing Then
          HTMLizeMessage(BadPassMessage)
          If BadPassLeft > 0 Then
            Select Case BadPassID
              Case 10, 30
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#CREATE"" title=""" & ResMan.GetString("CMD_CREATEACCOUNT_TT_D") & """>" & ResMan.GetString("CMD_CREATEACCOUNT") & "</a> (" & ConvertTime(BadPassLeft * 1000, True) & ")]" &
                  " [<a name=""BADPASS"" href=""#RESET"" title=""" & ResMan.GetString("CMD_RESETPASSWORD_TT") & """>" & ResMan.GetString("CMD_RESETPASSWORD") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CHANGE"" title=""" & ResMan.GetString("CMD_CHANGELOGIN_TT") & """>" & ResMan.GetString("CMD_CHANGELOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT") & """>" & ResMan.GetString("CMD_LOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT") & """>" & ResMan.GetString("CMD_CANCEL") & "</a>]"
              Case 20, 23
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#CREATE"" title=""" & ResMan.GetString("CMD_CREATEACCOUNT_TT_D") & """>" & ResMan.GetString("CMD_CREATEACCOUNT") & "</a> (" & ConvertTime(BadPassLeft * 1000, True) & ")]" &
                  " [<a name=""BADPASS"" href=""#CHANGE"" title=""" & ResMan.GetString("CMD_CHANGELOGIN_TT") & """>" & ResMan.GetString("CMD_CHANGELOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT") & """>" & ResMan.GetString("CMD_LOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT") & """>" & ResMan.GetString("CMD_CANCEL") & "</a>]"
              Case 21, 50
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#RESET"" title=""" & ResMan.GetString("CMD_RESETPASSWORD_TT") & """>" & ResMan.GetString("CMD_RESETPASSWORD") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CHANGE"" title=""" & ResMan.GetString("CMD_CHANGELOGIN_TT") & """>" & ResMan.GetString("CMD_CHANGELOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT") & """>" & ResMan.GetString("CMD_LOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT_D") & ")"">" & ResMan.GetString("CMD_CANCEL") & "</a> (" & ConvertTime(BadPassLeft * 1000, True) & ")]"
              Case 22, 51
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#CHANGE"" title=""" & ResMan.GetString("CMD_CHANGELOGIN_TT") & """>" & ResMan.GetString("CMD_CHANGELOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT") & """>" & ResMan.GetString("CMD_LOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT_D") & ")"">" & ResMan.GetString("CMD_CANCEL") & "</a> (" & ConvertTime(BadPassLeft * 1000, True) & ")]"
              Case 31
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#CREATE"" title=""" & ResMan.GetString("CMD_CREATEACCOUNT_TT") & """>" & ResMan.GetString("CMD_CREATEACCOUNT") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CHANGE"" title=""" & ResMan.GetString("CMD_CHANGELOGIN_TT") & """>" & ResMan.GetString("CMD_CHANGELOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT") & """>" & ResMan.GetString("CMD_LOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT_D") & ")"">" & ResMan.GetString("CMD_CANCEL") & "</a> (" & ConvertTime(BadPassLeft * 1000, True) & ")]"
              Case 40, 11
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#RESET"" title=""" & ResMan.GetString("CMD_RESETPASSWORD_TT") & """>" & ResMan.GetString("CMD_RESETPASSWORD") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CHANGEP"" title=""" & ResMan.GetString("CMD_CHANGEPASSES_TT") & """>" & ResMan.GetString("CMD_CHANGEPASS") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT") & """>" & ResMan.GetString("CMD_LOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT_D") & ")"">" & ResMan.GetString("CMD_CANCEL") & "</a> (" & ConvertTime(BadPassLeft * 1000, True) & ")]"
              Case 41
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT_D") & """>" & ResMan.GetString("CMD_CONTINUELOGIN") & "</a> (" & ConvertTime(BadPassLeft * 1000, True) & ")]" &
                  " [<a name=""BADPASS"" href=""#CHANGEP"" title=""" & ResMan.GetString("CMD_CHANGEPASSES_TT") & """>" & ResMan.GetString("CMD_CHANGEPASS") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT") & """>" & ResMan.GetString("CMD_CANCEL") & "</a>]"
            End Select
            BadPassLeft -= 1
          Else
            Select Case BadPassID
              Case 10, 30
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#CREATE"" title=""" & ResMan.GetString("CMD_CREATEACCOUNT_TT") & """>" & ResMan.GetString("CMD_CREATEACCOUNT") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#RESET"" title=""" & ResMan.GetString("CMD_RESETPASSWORD_TT") & """>" & ResMan.GetString("CMD_RESETPASSWORD") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CHANGE"" title=""" & ResMan.GetString("CMD_CHANGELOGIN_TT") & """>" & ResMan.GetString("CMD_CHANGELOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT") & """>" & ResMan.GetString("CMD_LOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT") & """>" & ResMan.GetString("CMD_CANCEL") & "</a>]"
              Case 20, 23
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#CREATE"" title=""" & ResMan.GetString("CMD_CREATEACCOUNT_TT") & """>" & ResMan.GetString("CMD_CREATEACCOUNT") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CHANGE"" title=""" & ResMan.GetString("CMD_CHANGELOGIN_TT") & """>" & ResMan.GetString("CMD_CHANGELOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT") & """>" & ResMan.GetString("CMD_LOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT") & """>" & ResMan.GetString("CMD_CANCEL") & "</a>]"
              Case 21, 50
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#RESET"" title=""" & ResMan.GetString("CMD_RESETPASSWORD_TT") & """>" & ResMan.GetString("CMD_RESETPASSWORD") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CHANGE"" title=""" & ResMan.GetString("CMD_CHANGELOGIN_TT") & """>" & ResMan.GetString("CMD_CHANGELOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT") & """>" & ResMan.GetString("CMD_LOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT") & """>" & ResMan.GetString("CMD_CANCEL") & "</a>]"
              Case 22, 51
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#CHANGE"" title=""" & ResMan.GetString("CMD_CHANGELOGIN_TT") & """>" & ResMan.GetString("CMD_CHANGELOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT") & """>" & ResMan.GetString("CMD_LOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT") & """>" & ResMan.GetString("CMD_CANCEL") & "</a>]"
              Case 31
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#CREATE"" title=""" & ResMan.GetString("CMD_CREATEACCOUNT_TT") & """>" & ResMan.GetString("CMD_CREATEACCOUNT") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CHANGE"" title=""" & ResMan.GetString("CMD_CHANGELOGIN_TT") & """>" & ResMan.GetString("CMD_CHANGELOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT") & """>" & ResMan.GetString("CMD_LOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT") & """>" & ResMan.GetString("CMD_CANCEL") & "</a>]"
              Case 40, 11
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#RESET"" title=""" & ResMan.GetString("CMD_RESETPASSWORD_TT") & """>" & ResMan.GetString("CMD_RESETPASSWORD") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CHANGEP"" title=""" & ResMan.GetString("CMD_CHANGEPASSES_TT") & """>" & ResMan.GetString("CMD_CHANGEPASS") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT") & """>" & ResMan.GetString("CMD_LOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT") & """>" & ResMan.GetString("CMD_CANCEL") & "</a>]"
              Case 41
                nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage &
                  " [<a name=""BADPASS"" href=""#LOGIN"" title=""" & ResMan.GetString("CMD_LOGINAGAIN_TT") & """>" & ResMan.GetString("CMD_CONTINUELOGIN") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CHANGEP"" title=""" & ResMan.GetString("CMD_CHANGEPASSES_TT") & """>" & ResMan.GetString("CMD_CHANGEPASS") & "</a>]" &
                  " [<a name=""BADPASS"" href=""#CANCEL"" title=""" & ResMan.GetString("CMD_CANCEL_TT") & """>" & ResMan.GetString("CMD_CANCEL") & "</a>]"
            End Select
            If BadPassLeft = 0 Then
              Select Case BadPassID
                Case 10, 20, 23, 30 : EndBadPass(1)
                Case 40, 50 : EndBadPass(2)
                Case 41 : EndBadPass(3)
                Case 21, 22, 31, 51 : EndBadPass(4)
              End Select
            End If
          End If
        End If
      Catch ex As Exception
        Exit Sub
      End Try
    End If
  End Sub
  Private Delegate Sub EndBadPassCallBack(Ret As Integer)
  Public Sub EndBadPass(Ret As Integer)
    If Me.InvokeRequired Then
      Me.BeginInvoke(New EndBadPassCallBack(AddressOf EndBadPass), Ret)
    Else
      tmrBadPass.Stop()
      Dim nTmp As Gecko.GeckoHtmlElement = gwBrowse.Document.GetHtmlElementById("BADPASS")
      If nTmp IsNot Nothing Then
        If Not String.IsNullOrEmpty(BadPassMessage) Then nTmp.GetElementsByTagName("div").Last.GetElementsByTagName("span").Last.InnerHtml = BadPassMessage
        nTmp.Id = Nothing
      End If
      BadPassMessage = Nothing
      BadPassLeft = 0
      RaiseEvent BadPassResult(Me, New BadPassEventArgs(BadPassID, Ret, BadPassUser, BadPassPass, BadPassOldPass))
      BadPassID = 0
    End If
  End Sub
  Private Sub tmrBadPass_Elapsed(sender As Object, e As System.Timers.ElapsedEventArgs) Handles tmrBadPass.Elapsed
    UpdateBadPass()
  End Sub
#End Region
#Region "Change EMail"
  Public Sub ShowChangeEMail(ctType As ChatType, sName As String, sMessage As String, sDefault As String)
    If gwBrowse Is Nothing Then Exit Sub
    AddChat(ctType, sName, sMessage, "CHANGE_E")
    Dim nE As Gecko.GeckoHtmlElement = gwBrowse.Document.GetHtmlElementById("CHANGE_E")
    Dim nSpan As Gecko.GeckoHtmlElement = nE.LastChild.LastChild.LastChild.LastChild.LastChild.LastChild
    Dim bScroll As Boolean = (CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollHeight - CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop < CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).OffsetHeight + ScrollGive)
    Dim bpCSS As New clsCSS
    bpCSS.Elements.Add(".promptTable", New clsCSS.StyleList(
                       {
                         New clsCSS.StyleList.Style("display", "inline-block"),
                         New clsCSS.StyleList.Style("vertical-align", "middle"),
                         New clsCSS.StyleList.Style("font-size", "11px"),
                         New clsCSS.StyleList.Style("color", "white")
                       }))
    bpCSS.Elements.Add(".promptText", New clsCSS.StyleList(
                       {
                         New clsCSS.StyleList.Style("background-color", "black"),
                         New clsCSS.StyleList.Style("border", "1px solid white"),
                         New clsCSS.StyleList.Style("color", "white"),
                         New clsCSS.StyleList.Style("font-size", "10px")
                       }))
    bpCSS.Elements.Add(".promptText:hover, .promptText:focus", New clsCSS.StyleList({New clsCSS.StyleList.Style("background-color", "#202020")}))
    bpCSS.Elements.Add(".promptButton", New clsCSS.StyleList(
                       {
                         New clsCSS.StyleList.Style("background-color", "black"),
                         New clsCSS.StyleList.Style("border", "1px solid white"),
                         New clsCSS.StyleList.Style("border-radius", "2px"),
                         New clsCSS.StyleList.Style("color", "white"),
                         New clsCSS.StyleList.Style("font-size", "10px")
                       }))
    bpCSS.Elements.Add(".promptButton:hover", New clsCSS.StyleList({New clsCSS.StyleList.Style("background-color", "#404040")}))
    bpCSS.Elements.Add(".promptButton:hover:active", New clsCSS.StyleList(
                       {
                         New clsCSS.StyleList.Style("background-color", "black"),
                         New clsCSS.StyleList.Style("outline", "none")
                       }))
    bpCSS.Elements.Add(".promptButton:focus", New clsCSS.StyleList({New clsCSS.StyleList.Style("outline", "dotted thin white")}))
    bpCSS.Elements.Add(".passButton", New clsCSS.StyleList({New clsCSS.StyleList.Style("width", "20px")}))
    bpCSS.Elements.Add("#txtEMail", New clsCSS.StyleList(
                       {
                         New clsCSS.StyleList.Style("width", "150px"),
                         New clsCSS.StyleList.Style("margin-right", "2px")
                       }))
    bpCSS.Elements.Add("#cmdSetEMail, #cmdNoEMail", New clsCSS.StyleList({New clsCSS.StyleList.Style("width", "50px")}))
    Dim sPrompt As String = "<input type=""text"" class=""promptText"" id=""txtEMail"" value=""" & sDefault & """ /><span id=""spanEButtons"" class=""promptTable""><input type=""submit"" class=""promptButton"" id=""cmdSetEMail"" value=""" & ResMan.GetString("CMD_CHANGE") & """ /><br><input type=""submit"" class=""promptButton"" id=""cmdNoEMail"" value=""" & ResMan.GetString("CMD_CANCEL") & """ /></span>"
    nSpan.InnerHtml &= "<style type=""text/css"">" & vbNewLine & bpCSS.ToString & vbNewLine & "</style>" & vbNewLine & sPrompt
    If bScroll AndAlso gwBrowse.Document.GetElementsByTagName("tr").Count > 0 Then gwBrowse.Document.GetElementsByTagName("tr").Last.ScrollIntoView(False)
  End Sub
#End Region
#Region "Change Password"
  Public Sub ShowChangePassword(ctType As ChatType, sName As String, sMessage As String, sDefault As String)
    If gwBrowse Is Nothing Then Exit Sub
    AddChat(ctType, sName, sMessage, "CHANGE_P")
    Dim nP As Gecko.GeckoHtmlElement = gwBrowse.Document.GetHtmlElementById("CHANGE_P")
    Dim nSpan As Gecko.GeckoHtmlElement = nP.LastChild.LastChild.LastChild.LastChild.LastChild.LastChild
    Dim bpCSS As New clsCSS
    bpCSS.Elements.Add(".promptTable", New clsCSS.StyleList(
                       {
                         New clsCSS.StyleList.Style("display", "inline-block"),
                         New clsCSS.StyleList.Style("vertical-align", "middle"),
                         New clsCSS.StyleList.Style("font-size", "11px"),
                         New clsCSS.StyleList.Style("color", "white")
                       }))
    bpCSS.Elements.Add(".promptText", New clsCSS.StyleList(
                       {
                         New clsCSS.StyleList.Style("background-color", "black"),
                         New clsCSS.StyleList.Style("border", "1px solid white"),
                         New clsCSS.StyleList.Style("color", "white"),
                         New clsCSS.StyleList.Style("font-size", "10px")
                       }))
    bpCSS.Elements.Add(".promptText:hover, .promptText:focus", New clsCSS.StyleList({New clsCSS.StyleList.Style("background-color", "#202020")}))
    bpCSS.Elements.Add(".promptButton", New clsCSS.StyleList(
                       {
                         New clsCSS.StyleList.Style("background-color", "black"),
                         New clsCSS.StyleList.Style("border", "1px solid white"),
                         New clsCSS.StyleList.Style("border-radius", "2px"),
                         New clsCSS.StyleList.Style("color", "white"),
                         New clsCSS.StyleList.Style("font-size", "10px")
                       }))
    bpCSS.Elements.Add(".promptButton:hover", New clsCSS.StyleList({New clsCSS.StyleList.Style("background-color", "#404040")}))
    bpCSS.Elements.Add(".promptButton:hover:active", New clsCSS.StyleList(
                       {
                         New clsCSS.StyleList.Style("background-color", "black"),
                         New clsCSS.StyleList.Style("outline", "none")
                       }))
    bpCSS.Elements.Add(".promptButton:focus", New clsCSS.StyleList({New clsCSS.StyleList.Style("outline", "dotted thin white")}))
    bpCSS.Elements.Add(".passButton", New clsCSS.StyleList({New clsCSS.StyleList.Style("width", "20px")}))
    bpCSS.Elements.Add("#txtPassword", New clsCSS.StyleList(
                       {
                         New clsCSS.StyleList.Style("width", "80px"),
                         New clsCSS.StyleList.Style("margin-right", "2px")
                       }))
    bpCSS.Elements.Add("#cmdSetPassword, #cmdNoPassword", New clsCSS.StyleList({New clsCSS.StyleList.Style("width", "50px")}))
    Dim bScroll As Boolean = (CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollHeight - CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop < CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).OffsetHeight + ScrollGive)
    Dim sPrompt As String = "<input type=""password"" class=""promptText"" id=""txtPassword"" value=""" & sDefault & """ /><span id=""spanPButtons"" class=""promptTable""><input type=""submit"" class=""promptButton"" id=""cmdSetPassword"" value=""" & ResMan.GetString("CMD_CHANGE") & """ /><br><input type=""submit"" class=""promptButton"" id=""cmdNoPassword"" value=""" & ResMan.GetString("CMD_CANCEL") & """ /></span>"
    nSpan.InnerHtml &= "<style type=""text/css"">" & vbNewLine & bpCSS.ToString & vbNewLine & "</style>" & vbNewLine & sPrompt
    If bScroll AndAlso gwBrowse.Document.GetElementsByTagName("tr").Count > 0 Then gwBrowse.Document.GetElementsByTagName("tr").Last.ScrollIntoView(False)
  End Sub
#End Region
#End Region
  Private Sub HTMLizeMessage(ByRef sMessage As String)
    If String.IsNullOrEmpty(sMessage) Then Exit Sub
    sMessage = Replace(sMessage, "&", "&amp;")
    Dim regx As New Regex("(aaa://|aaas://|acap://|cap://|cid:|crid://|data:|dav:|dict://|dns:|dns://|fax:|file://|ftp://|geo:|go:|go://|gopher://|h323:|http://|https://|iax:|icap://|im:|imap://|info://|ipp://|iris\.|ldap://|urn:lsid:|mailto:|mid:|modem:|msrp://|msrps://|mtqp://|mupdate://|news:|nfs://|nntp://|opaquelocktoken:|pop://|pres:|prospero://|rstp://|service:|shttp://|sieve://|sip:|sips:|sms:|snmp://|soap\.|tag:|tel:|telnet://|tftp://|thismessage:/|tip://|tv:|urn:|vemmi://|wais://|xmlrpc\.|xmpp:|z39.50r://|z39.50s://|about:|adiumxtra://|aim:|apt:|apf://|aw://|bolo://|callto:|chrome:|content://|cvs://|doi:10\.|ed2k://|facetime://|feed:|finger://|fish://|gg:|gizmoproject://call\?id=|gtalk:chat\?jid=|irc://|ircs://|irc6://|itms:|jar:|javascript:|keyparc://|lastfm://|ldaps://|magnet:|maps:q=|mms://|msnim:|mumble://|mvn:|notes://|palm:|paparazzi:|psyc:|psyc://|rmi://|rsync://|rmtp://|secondlife://|sgn://|skype:|spotify:|ssh://|sftp://|smb://|soldat://|steam:|steam://|svn://|svn\+ssh://|teamspeak://|unreal://|ut2004://|ventrilo://|view-source:|webcal://|ws:|wtai://|wyciwyg://|xfire:|xri://|ymsgr:sendIM\?|bnftp://|www\.)([\w+?\.\w+])+([a-zA-Z0-9\~\!\@\#\$\%\^\&amp;\*\(\)_\-\=\+\\\/\?\.\:\;\'\,]*)?([a-zA-Z0-9/\?])", RegexOptions.IgnoreCase)
    Dim matches As MatchCollection = regx.Matches(sMessage)
    sMessage = sMessage.Replace("<", "&lt;")
    sMessage = sMessage.Replace(">", "&gt;")
    Dim matchItems = (From mItem As Match In matches Select mItem.Value).Distinct
    For Each match As String In matchItems
      sMessage = sMessage.Replace(match, "<a href=""#" & match & """ name=""URL"" title=""" & titleGrabber.GetHTMLTitle(match) & """>" & match & "</a>")
    Next
    If bEmoticons Then sMessage = AddEmotes(sMessage)
    Do While InStr(sMessage, "  ") > 0
      sMessage = sMessage.Replace("  ", "&nbsp;&nbsp;")
    Loop
    If bRichText Then
      If sMessage.Contains("Á") Then
        sMessage = sMessage.Replace("ÁQ", "ÿc5")
        sMessage = sMessage.Replace("ÁR", "ÿc:")

        sMessage = sMessage.Replace("ÁS", "ÿc9")
        sMessage = sMessage.Replace("ÁX", "ÿc9")
        sMessage = sMessage.Replace("ÁZ", "ÿc9")

        sMessage = sMessage.Replace("ÁT", "ÿc.")
        sMessage = sMessage.Replace("ÁU", "ÿc.")
        sMessage = sMessage.Replace("ÁV", "ÿc.")

        sMessage = sMessage.Replace("ÁW", "ÿc/")
        sMessage = sMessage.Replace("ÁP", "ÿc/")

        sMessage = sMessage.Replace("ÁY", "ÿc1")
      End If
      If sMessage.Contains("ÿc") Then
        Dim sHTML As String = String.Empty
        Dim bC, bB, bI, bS, bU As Boolean
        For I As Integer = 0 To sMessage.Length - 1
          If sMessage(I) = "ÿ"c Then
            If I < sMessage.Length - 1 AndAlso sMessage(I + 1) = "c"c Then
              I += 1
              If I < sMessage.Length - 1 Then
                Dim colorVal As Color = Color.Transparent
                Select Case sMessage(I + 1)
                  Case "0"c, "/"c : colorVal = Color.White
                  Case "1"c : colorVal = Color.Red
                  Case "2"c, "<"c : colorVal = Color.Lime
                  Case "3"c : colorVal = Color.FromArgb(&HFFAC00FF)
                  Case "4"c, "7"c : colorVal = Color.FromArgb(&HFFD5AC00)
                  Case "5"c, "&"c : colorVal = Color.Gray
                  Case "6"c : colorVal = Color.Black
                  Case "8"c : colorVal = Color.FromArgb(&HFFFF7F00)
                  Case "9"c, "%"c : colorVal = Color.Yellow
                  Case "*"c, """"c : colorVal = Color.Blue
                  Case "("c : colorVal = Color.Silver
                  Case ")"c, "."c : colorVal = Color.Aqua
                  Case "+"c : colorVal = Color.FromArgb(&HFFB2FFFF)
                  Case ":" : colorVal = Color.FromArgb(&HFF00C000)
                  Case ";" : colorVal = Color.Fuchsia
                  Case "b"
                    bB = Not bB
                    If bB Then
                      sHTML &= "<span style=""font-weight: bold;"">"
                    Else
                      sHTML &= "</span>"
                    End If
                    I += 1
                  Case "i"
                    bI = Not bI
                    If bI Then
                      sHTML &= "<span style=""font-style: italic;"">"
                    Else
                      sHTML &= "</span>"
                    End If
                    I += 1
                  Case "u"
                    bU = Not bU
                    If bU Then
                      sHTML &= "<span style=""text-decoration: underline;"">"
                    Else
                      sHTML &= "</span>"
                    End If
                    I += 1
                  Case "s"
                    bS = Not bS
                    If bS Then
                      sHTML &= "<span style=""text-decoration: line-through;"">"
                    Else
                      sHTML &= "</span>"
                    End If
                    I += 1
                  Case Else
                    sHTML &= "ÿc"
                End Select
                If colorVal <> Color.Transparent Then
                  If bB Then sHTML &= "</span>"
                  If bI Then sHTML &= "</span>"
                  If bS Then sHTML &= "</span>"
                  If bU Then sHTML &= "</span>"
                  If bC Then sHTML &= "</span>"
                  sHTML &= "<span style=""color: #" & PadHex(colorVal.ToArgb And Not &HFF000000, 6) & ";"">"
                  If bB Then sHTML &= "<span style=""font-weight: bold;"">"
                  If bI Then sHTML &= "<span style=""font-style: italic;"">"
                  If bS Then sHTML &= "<span style=""text-decoration: line-through;"">"
                  If bU Then sHTML &= "<span style=""text-decoration: underline;"">"
                  bC = True
                  I += 1
                End If
              Else
                sHTML &= "ÿc"
              End If
            Else
              sHTML &= sMessage(I)
            End If
          Else
            sHTML &= sMessage(I)
          End If
        Next
        If bB Then sHTML &= "</span>"
        If bI Then sHTML &= "</span>"
        If bS Then sHTML &= "</span>"
        If bU Then sHTML &= "</span>"
        If bC Then sHTML &= "</span>"
        sMessage = sHTML
      End If
    End If
  End Sub
  Private Function GetRows(tTable As Gecko.GeckoHtmlElement) As Integer
    'If bJoinLeave Then
    Return tTable.GetElementsByTagName("tr").Count
    'Else
    'Return Array.FindAll(tTable.GetElementsByTagName("tr").ToArray, Function(tr As Gecko.GeckoHtmlElement) Not tr.ClassName = "joinleave").Count
    'End If
  End Function
  Private Function TraverseTextContent(ByRef Node As Gecko.GeckoNode) As Gecko.GeckoNode()
    Dim gNodes As New ArrayList
    For Each child As Gecko.GeckoNode In Node.ChildNodes
      If child.NodeType = Gecko.NodeType.Text Then
        gNodes.Add(child)
      Else
        gNodes.AddRange(TraverseTextContent(child))
      End If
    Next
    Return gNodes.ToArray(GetType(Gecko.GeckoNode))
  End Function
  Private Delegate Sub HideMessagesCallBack(Username As String, Hide As Boolean)
  Public Sub HideMessages(Username As String, Hide As Boolean)
    If gwBrowse Is Nothing Then Exit Sub
    Debug.Print(IIf(Hide, "Hide", "Show") & " messages from " & Username & "...")
    If Me.InvokeRequired Then
      Me.BeginInvoke(New HideMessagesCallBack(AddressOf HideMessages), Username, Hide)
    Else
      If gwBrowse.Document Is Nothing Then Exit Sub
      If gwBrowse.Document.GetElementsByTagName("tr").Count > 0 Then
        Dim bScroll As Boolean = (CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollHeight - CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).ScrollTop < CType(gwBrowse.Document.DocumentElement, Gecko.DOM.GeckoHtmlHtmlElement).OffsetHeight + ScrollGive)
        For Each contents In gwBrowse.Document.GetElementsByClassName("contents")
          If contents.ChildNodes.Count > 0 Then
            Dim nFirst As Gecko.GeckoHtmlElement = contents.ChildNodes(0)
            If nFirst.TagName.ToLower = "a" Then
              If Not String.IsNullOrEmpty(Username) AndAlso String.Compare(nFirst.GetAttribute("name"), Username, True) = 0 Then
                Dim nPar = nFirst.ParentElement.ParentElement.ParentElement.ParentElement.ParentElement.ParentElement
                If nPar.TagName.ToLower = "tr" And Not nPar.ClassName.Contains("joinleave") Then
                  If Hide Then
                    nPar.SetAttribute("style", "display: none;")
                  Else
                    nPar.SetAttribute("style", "display: table-row;")
                  End If
                End If
              End If
            End If
          End If
        Next
        If bScroll AndAlso gwBrowse.Document.GetElementsByTagName("tr").Count > 0 Then gwBrowse.Document.GetElementsByTagName("tr").Last.ScrollIntoView(False)
      End If
    End If
  End Sub
#End Region
#End Region
End Class