﻿Public Class frmChessBoard
  Private Delegate Sub SetTabValueCallback([Page] As TabPage, [Alert] As Boolean)
  Private ResMan As New Resources.ResourceManager("Entelechy.frmChessBoard", Reflection.[Assembly].GetExecutingAssembly)
  Private Sub SetTabValue([Page] As TabPage, [Alert] As Boolean)
    If Me.tbsChess.InvokeRequired Then
      Dim d As New SetTabValueCallback(AddressOf SetTabValue)
      Me.BeginInvoke(d, New Object() {[Page], [Alert]})
    Else
      If Alert Then
        If Not tbsChess.SelectedTab Is Page Then If Not Page.Text.StartsWith("[*] ") Then Page.Text = "[*] " & Page.Text
        If ActiveForm IsNot Me Then
          Dim fl As New NativeMethods.FLASHWINFO
          fl.cbSize = System.Runtime.InteropServices.Marshal.SizeOf(fl)
          fl.hwnd = Me.Handle
          fl.dwFlags = NativeMethods.FLASHW_ALL
          fl.uCount = 2
          fl.dwTimeout = 500
          NativeMethods.FlashWindowEx(fl)
        End If
      Else
        If Page.Text.StartsWith("[*] ") Then Page.Text = Page.Text.Substring(4)
      End If
    End If
  End Sub
  Public Sub AddGame(ByRef UI As BNUI, Opponent As String, asWhite As Boolean)
    For Each tabItem As TabPage In tbsChess.TabPages
      If String.Compare(Opponent, CType(tabItem.Controls(0), ChessBoard).sOpponent) = 0 Then
        tbsChess.SelectedTab = tabItem
        CType(tabItem.Controls(0), ChessBoard).StartGame(asWhite)
        Exit Sub
      End If
    Next
    Dim newTab As New TabPage
    Dim newUI As New ChessBoard
    newTab.Tag = UI
    newUI.Tag = UI
    tbsChess.Controls.Add(newTab)
    If Not tbsChess.Visible Then tbsChess.Visible = True
    newTab.Controls.Add(newUI)
    AddHandler newUI.MadeMove, AddressOf Chess_MadeMove
    AddHandler newUI.NewGame, AddressOf Chess_NewGame
    AddHandler newUI.Resign, AddressOf Chess_Closed
    AddHandler newUI.Draw, AddressOf Chess_Draw
    AddHandler newUI.SaveAndQuit, AddressOf Chess_SaveAndQuit
    'newUI.Anchor = AnchorStyles.None
    newTab.Text = Opponent '& " (" & GetGatewayName(UI.Config.Server, UI.Config.Account.Client.Product = BNUI.GameType.WAR3 Or UI.Config.Account.Client.Product = BNUI.GameType.W3XP) & ")"
    newTab.ToolTipText = ResString(ResMan.GetString("BOARD_TAB_TOOLTIP"), Opponent)
    newTab.BackColor = Color.Black
    tbsChess.SelectedTab = newTab
    newUI.sOpponent = Opponent
    newUI.StartGame(asWhite)
    Dim iSize As Integer
    Select Case cmbSize.SelectedIndex
      Case 0 : iSize = 32
      Case 1 : iSize = 48
      Case 2 : iSize = 64
      Case 3 : iSize = 96
      Case 4 : iSize = 128
      Case Else : iSize = 32
    End Select
    newUI.SquareSize = iSize
    newUI.Dock = DockStyle.Fill
  End Sub
  Public Sub RemoveTab(Opponent As String)
    For Each tabItem As TabPage In tbsChess.TabPages
      If String.Compare(Opponent, CType(tabItem.Controls(0), ChessBoard).sOpponent) = 0 Then
        tbsChess.TabPages.Remove(tabItem)
        CType(tabItem.Tag, BNUI).sChessOpponents.Remove(Opponent)
        Exit For
      End If
    Next
    If tbsChess.TabPages.Count = 0 Then
      tbsChess.Visible = False
      Me.Close()
    End If
  End Sub
  Public Sub ResumeGame(ByRef UI As BNUI, Opponent As String, Optional BoardData As String = Nothing)
    For Each tabItem As TabPage In tbsChess.TabPages
      If String.Compare(Opponent, CType(tabItem.Controls(0), ChessBoard).sOpponent) = 0 Then
        tbsChess.SelectedTab = tabItem
        If String.IsNullOrEmpty(BoardData) Then
          CType(tabItem.Controls(0), ChessBoard).ResumeGame()
          SendResumeData(Opponent)
        Else
          CType(tabItem.Controls(0), ChessBoard).FromString(BoardData)
        End If
        Exit Sub
      End If
    Next
    Dim newTab As New TabPage
    Dim newUI As New ChessBoard
    newTab.Tag = UI
    newUI.Tag = UI
    tbsChess.Controls.Add(newTab)
    If Not tbsChess.Visible Then tbsChess.Visible = True
    newTab.Controls.Add(newUI)
    AddHandler newUI.MadeMove, AddressOf Chess_MadeMove
    AddHandler newUI.NewGame, AddressOf Chess_NewGame
    AddHandler newUI.Resign, AddressOf Chess_Closed
    AddHandler newUI.Draw, AddressOf Chess_Draw
    AddHandler newUI.SaveAndQuit, AddressOf Chess_SaveAndQuit
    'newUI.Anchor = AnchorStyles.None
    newTab.Text = Opponent '& " (" & GetGatewayName(UI.Config.Server, UI.Config.Account.Client.Product = BNUI.GameType.WAR3 Or UI.Config.Account.Client.Product = BNUI.GameType.W3XP) & ")"
    newTab.ToolTipText = ResString(ResMan.GetString("BOARD_TAB_TOOLTIP"), Opponent)
    newTab.BackColor = Color.Black
    tbsChess.SelectedTab = newTab
    newUI.sOpponent = Opponent
    If String.IsNullOrEmpty(BoardData) Then
      newUI.ResumeGame()
    Else
      newUI.FromString(BoardData)
    End If
    Dim iSize As Integer
    Select Case cmbSize.SelectedIndex
      Case 0 : iSize = 32
      Case 1 : iSize = 48
      Case 2 : iSize = 64
      Case 3 : iSize = 96
      Case 4 : iSize = 128
      Case Else : iSize = 32
    End Select
    newUI.SquareSize = iSize
    newUI.Dock = DockStyle.Fill
    If String.IsNullOrEmpty(BoardData) Then SendResumeData(Opponent)
  End Sub
  Private Sub SendResumeData(Opponent As String)
    For Each tabItem As TabPage In tbsChess.TabPages
      If String.Compare(Opponent, CType(tabItem.Controls(0), ChessBoard).sOpponent) = 0 Then
        Dim cBoard As ChessBoard = tabItem.Controls(0)
        Dim cUI As BNUI = cBoard.Tag
        cUI.SendMessage("/w " & Opponent & " Board Setup: " & cBoard.ToString & ". You are " & IIf(cBoard.MyColor = Color.White, "Black", "White") & ". It is " & IIf(cBoard.MyTurn, IIf(cBoard.MyColor = Color.White, "White's", "Black's"), "your") & " turn.")
        cUI.SendMessage("/w " & Opponent & " Notation: p = Pawn, u = Unmoved King or Rook (can castle), e = En Passant (target squares)")
      End If
    Next
  End Sub
  Private Sub frmChessBoard_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
    If e.CloseReason = CloseReason.UserClosing Then
      Dim OpenGames As Boolean = False
      For Each tabChess As TabPage In tbsChess.TabPages
        If CType(tabChess.Controls(0), ChessBoard).IsPlaying Then
          OpenGames = True
          Exit For
        End If
      Next
      If OpenGames Then
        Using mFrame As New MessageFrame
          If mFrame.MsgBox(Me, ResString(ResMan.GetString("MSG_RESIGN_ALL"), Nothing), MsgBoxStyle.Question Or MsgBoxStyle.YesNo, ResMan.GetString("MSG_RESIGN_ALL_TITLE")) = MsgBoxResult.No Then e.Cancel = True : Exit Sub
        End Using
        For Each tabChess As TabPage In tbsChess.TabPages
          Dim selBoard As ChessBoard = tabChess.Controls(0)
          CType(selBoard.Tag, BNUI).SendMessage("/w " & selBoard.sOpponent & " " & IIf(selBoard.MyColor = Color.White, "0-1", "1-0"))
          If selBoard.IsPlaying Then RemoveTab(selBoard.sOpponent)
        Next
      End If
    Else
      For Each tabChess As TabPage In tbsChess.TabPages
        Dim selBoard As ChessBoard = tabChess.Controls(0)
        CType(selBoard.Tag, BNUI).SendMessage("/w " & selBoard.sOpponent & " " & IIf(selBoard.MyColor = Color.White, "0-1", "1-0"))
        If selBoard.IsPlaying Then RemoveTab(selBoard.sOpponent)
      Next
    End If
  End Sub
  Private Sub frmBoard_Load(sender As Object, e As System.EventArgs) Handles Me.Load
    If Me.Location.X > My.Computer.Screen.WorkingArea.Width Or Me.Location.X < 0 Then Me.Location = New Point(0, Me.Location.Y)
    If Me.Location.Y > My.Computer.Screen.WorkingArea.Height Or Me.Location.Y < 0 Then Me.Location = New Point(Me.Location.X, 0)
    Dim scrHeight As Integer = Screen.FromRectangle(Me.DisplayRectangle).Bounds.Height
    cmbSize.Items.Clear()
    cmbSize.Items.Add(ResMan.GetString("BOARD_SIZE_256"))
    If scrHeight >= 384 + (Me.Height - Me.DisplayRectangle.Height) + 110 Then cmbSize.Items.Add(ResMan.GetString("BOARD_SIZE_384"))
    If scrHeight >= 512 + (Me.Height - Me.DisplayRectangle.Height) + 110 Then cmbSize.Items.Add(ResMan.GetString("BOARD_SIZE_512"))
    If scrHeight >= 768 + (Me.Height - Me.DisplayRectangle.Height) + 110 Then cmbSize.Items.Add(ResMan.GetString("BOARD_SIZE_768"))
    If scrHeight >= 1024 + (Me.Height - Me.DisplayRectangle.Height) + 110 Then cmbSize.Items.Add(ResMan.GetString("BOARD_SIZE_1024"))
    If cmbSize.Items.Count > My.Settings.Board_Size Then
      cmbSize.SelectedIndex = My.Settings.Board_Size
    Else
      cmbSize.SelectedIndex = 0
    End If
  End Sub
  Private Sub tbsChess_MouseUp(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles tbsChess.MouseUp
    Dim selTab As TabPage = Nothing
    Dim selBoard As ChessBoard = Nothing
    If tbsChess.TabCount > 0 Then
      Dim lLen As Long = 1
      For I As Integer = 0 To tbsChess.TabCount - 1
        If tbsChess.GetTabRect(I).Contains(e.Location) Then
          selTab = tbsChess.TabPages(I)
          selBoard = selTab.Controls(0)
          SetTabValue(selTab, False)
        End If
      Next
      If e.Button = Windows.Forms.MouseButtons.Middle Then
        If selBoard.IsPlaying Then
          Using mFrame As New MessageFrame
            If mFrame.MsgBox(selBoard, ResString(ResMan.GetString("MSG_RESIGN"), selBoard.sOpponent), MsgBoxStyle.Question Or MsgBoxStyle.YesNo, ResMan.GetString("MSG_RESIGN_TITLE")) = MsgBoxResult.Yes Then
              CType(selBoard.Tag, BNUI).SendMessage("/w " & selBoard.sOpponent & " " & IIf(selBoard.MyColor = Color.White, "0-1", "1-0"))
              RemoveTab(selBoard.sOpponent)
            End If
          End Using
        Else
          RemoveTab(selBoard.sOpponent)
        End If
      End If
    End If
  End Sub
  Public Function MovePiece(Opponent As String, Move As String) As Byte
    Dim selTab As TabPage = Nothing
    Dim selItem As ChessBoard = Nothing
    For Each tabItem As TabPage In tbsChess.TabPages
      If String.Compare(Opponent, CType(tabItem.Controls(0), ChessBoard).sOpponent) = 0 Then
        selTab = tabItem
        selItem = tabItem.Controls(0)
        Exit For
      End If
    Next
    If selItem IsNot Nothing And selTab IsNot Nothing Then
      If selItem.OpponentMove(Move) Then
        SetTabValue(selTab, True)
        Return 1
      Else
        Return 0
      End If
    Else
      Return 2
    End If
  End Function
  Public Function MyTurn(Opponent As String) As Boolean
    Dim selTab As TabPage = Nothing
    Dim selItem As ChessBoard = Nothing
    For Each tabItem As TabPage In tbsChess.TabPages
      If String.Compare(Opponent, CType(tabItem.Controls(0), ChessBoard).sOpponent) = 0 Then
        selTab = tabItem
        selItem = tabItem.Controls(0)
        Exit For
      End If
    Next
    If selItem IsNot Nothing And selTab IsNot Nothing Then
      Return selItem.MyTurn
    Else
      Return False
    End If
  End Function
  Public Function AskForDraw(Opponent As String) As Boolean
    Dim selTab As TabPage = Nothing
    Dim selItem As ChessBoard = Nothing
    For Each tabItem As TabPage In tbsChess.TabPages
      If String.Compare(Opponent, CType(tabItem.Controls(0), ChessBoard).sOpponent) = 0 Then
        selTab = tabItem
        selItem = tabItem.Controls(0)
        Exit For
      End If
    Next
    If selItem IsNot Nothing And selTab IsNot Nothing Then
      Using mFrame As New MessageFrame
        If mFrame.MsgBox(selItem, ResString(ResMan.GetString("MSG_DRAW_ACCEPT"), Opponent), MsgBoxStyle.Question Or MsgBoxStyle.YesNo, ResMan.GetString("MSG_DRAW_ACCEPT_TITLE")) = MsgBoxResult.Yes Then
          Return True
        Else
          Return False
        End If
      End Using
    Else
      Return True
    End If
  End Function
  Public Sub DeclareDraw(Opponent As String)
    Dim selTab As TabPage = Nothing
    Dim selItem As ChessBoard = Nothing
    For Each tabItem As TabPage In tbsChess.TabPages
      If String.Compare(Opponent, CType(tabItem.Controls(0), ChessBoard).sOpponent) = 0 Then
        selTab = tabItem
        selItem = tabItem.Controls(0)
        Exit For
      End If
    Next
    If selItem IsNot Nothing And selTab IsNot Nothing Then
      selItem.HandleMove(clsChess.MoveTypes.Draw, False)
    End If
  End Sub
  Public Sub DenyDraw(Opponent As String)
    Dim selTab As TabPage = Nothing
    Dim selItem As ChessBoard = Nothing
    For Each tabItem As TabPage In tbsChess.TabPages
      If String.Compare(Opponent, CType(tabItem.Controls(0), ChessBoard).sOpponent) = 0 Then
        selTab = tabItem
        selItem = tabItem.Controls(0)
        Exit For
      End If
    Next
    If selItem IsNot Nothing And selTab IsNot Nothing Then
      Using mFrame As New MessageFrame : mFrame.MsgBox(selItem, ResString(ResMan.GetString("MSG_DRAW_DENIED"), Opponent), MsgBoxStyle.Exclamation, ResMan.GetString("MSG_DRAW_DENIED_TITLE")) : End Using
    End If
  End Sub
  Public Function AskForRematch(Opponent As String) As Boolean
    Dim selTab As TabPage = Nothing
    Dim selItem As ChessBoard = Nothing
    For Each tabItem As TabPage In tbsChess.TabPages
      If String.Compare(Opponent, CType(tabItem.Controls(0), ChessBoard).sOpponent) = 0 Then
        selTab = tabItem
        selItem = tabItem.Controls(0)
        Exit For
      End If
    Next
    If selItem IsNot Nothing And selTab IsNot Nothing Then
      Using mFrame As New MessageFrame
        If mFrame.MsgBox(selItem, ResString(ResMan.GetString("MSG_REMATCH"), Opponent), MsgBoxStyle.Question Or MsgBoxStyle.YesNo, ResMan.GetString("MSG_REMATCH_TITLE")) = MsgBoxResult.Yes Then
          Return True
        Else
          RemoveTab(Opponent)
          Return False
        End If
      End Using
    Else
      Using mFrame As New MessageFrame
        If mFrame.MsgBox(frmMain, ResString(ResMan.GetString("MSG_REMATCH"), Opponent), MsgBoxStyle.Question Or MsgBoxStyle.YesNo, ResMan.GetString("MSG_REMATCH_TITLE")) = MsgBoxResult.Yes Then
          Return True
        Else
          RemoveTab(Opponent)
          Return False
        End If
      End Using
    End If
  End Function
  Public Sub DeclareResign(Opponent As String)
    Dim selTab As TabPage = Nothing
    Dim selItem As ChessBoard = Nothing
    For Each tabItem As TabPage In tbsChess.TabPages
      If String.Compare(Opponent, CType(tabItem.Controls(0), ChessBoard).sOpponent) = 0 Then
        selTab = tabItem
        selItem = tabItem.Controls(0)
        Exit For
      End If
    Next
    If selItem IsNot Nothing And selTab IsNot Nothing Then
      Using mFrame As New MessageFrame : mFrame.MsgBox(selItem, ResString(ResMan.GetString("MSG_WIN_RESIGN"), Opponent), MsgBoxStyle.Exclamation, ResMan.GetString("MSG_WIN_RESIGN_TITLE")) : End Using
      RemoveTab(Opponent)
    End If
  End Sub
  Private Sub Chess_MadeMove(sender As Object, e As ChessBoard.MoveArgs)
    Dim cBoard As ChessBoard = sender
    CType(cBoard.Tag, BNUI).SendMessage("/w " & cBoard.sOpponent & " " & e.sMove)
  End Sub
  Private Sub Chess_NewGame(sender As Object, e As EventArgs)
    Dim cBoard As ChessBoard = sender
    CType(cBoard.Tag, BNUI).SendMessage("/w " & cBoard.sOpponent & " Play again? (Y/N)")
  End Sub
  Private Sub Chess_Closed(sender As Object, e As EventArgs)
    Dim cBoard As ChessBoard = sender
    CType(cBoard.Tag, BNUI).SendMessage("/w " & cBoard.sOpponent & " " & IIf(cBoard.MyColor = Color.White, "0-1", "1-0"))
    RemoveTab(cBoard.sOpponent)
  End Sub
  Private Sub Chess_Draw(sender As Object, e As EventArgs)
    Dim cBoard As ChessBoard = sender
    CType(cBoard.Tag, BNUI).SendMessage("/w " & cBoard.sOpponent & " Draw? (""1/2-1/2"" for Yes, ""No Draw"" for No)")
  End Sub
  Private Sub Chess_SaveAndQuit(sender As Object, e As EventArgs)
    Dim cBoard As ChessBoard = sender
    CType(cBoard.Tag, BNUI).SendMessage("/w " & cBoard.sOpponent & " The chess game has been saved for a later date.")
    RemoveTab(cBoard.sOpponent)
  End Sub
  Private Sub cmbSize_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles cmbSize.SelectedIndexChanged
    Dim iSize As Integer
    Select Case cmbSize.SelectedIndex
      Case 0 : iSize = 32
      Case 1 : iSize = 48
      Case 2 : iSize = 64
      Case 3 : iSize = 96
      Case 4 : iSize = 128
      Case Else : iSize = 32
    End Select
    If tbsChess.TabPages.Count > 0 Then
      For Each tabGame As TabPage In tbsChess.TabPages
        Dim cBoard As ChessBoard = tabGame.Controls(0)
        cBoard.SquareSize = iSize
        cBoard.Dock = DockStyle.Fill
      Next
    End If
    Dim iBox As Integer = iSize * 8
    Me.Size = New Size(iBox + (Me.Width - Me.DisplayRectangle.Width) + 14, iBox + (Me.Height - Me.DisplayRectangle.Height) + 110)
    My.Settings.Board_Size = cmbSize.SelectedIndex
  End Sub
End Class