﻿Public Class frmPromote
  Private bWhite As Boolean
  Private cWhite, cBlack As Color
  Private bSize As Byte
  Sub New(IsWhite As Boolean, BlackTiles As Color, WhiteTiles As Color, Size As Byte)
    InitializeComponent()
    bWhite = IsWhite
    cBlack = BlackTiles
    cWhite = WhiteTiles
    bSize = Size
  End Sub
  Private Sub frmPromote_Load(sender As Object, e As System.EventArgs) Handles Me.Load
    If bWhite Then
      pctQueen.Image = GetPieceIco(Color.White, clsChess.PieceType.Queen).ToBitmap
      pctQueen.BackColor = cWhite
      pctBishop.Image = GetPieceIco(Color.White, clsChess.PieceType.Bishop).ToBitmap
      pctBishop.BackColor = cBlack
      pctRook.Image = GetPieceIco(Color.White, clsChess.PieceType.Rook).ToBitmap
      pctRook.BackColor = cBlack
      pctKnight.Image = GetPieceIco(Color.White, clsChess.PieceType.Knight).ToBitmap
      pctKnight.BackColor = cWhite
    Else
      pctQueen.Image = GetPieceIco(Color.Black, clsChess.PieceType.Queen).ToBitmap
      pctQueen.BackColor = cBlack
      pctBishop.Image = GetPieceIco(Color.Black, clsChess.PieceType.Bishop).ToBitmap
      pctBishop.BackColor = cWhite
      pctRook.Image = GetPieceIco(Color.Black, clsChess.PieceType.Rook).ToBitmap
      pctRook.BackColor = cWhite
      pctKnight.Image = GetPieceIco(Color.Black, clsChess.PieceType.Knight).ToBitmap
      pctKnight.BackColor = cBlack
    End If
  End Sub
  Private Sub pctQueen_Click(sender As System.Object, e As System.EventArgs) Handles pctQueen.Click
    Me.DialogResult = Windows.Forms.DialogResult.Yes
    Me.Close()
  End Sub
  Private Sub pctBishop_Click(sender As System.Object, e As System.EventArgs) Handles pctBishop.Click
    Me.DialogResult = Windows.Forms.DialogResult.Abort
    Me.Close()
  End Sub
  Private Sub pctRook_Click(sender As System.Object, e As System.EventArgs) Handles pctRook.Click
    Me.DialogResult = Windows.Forms.DialogResult.Retry
    Me.Close()
  End Sub
  Private Sub pctKnight_Click(sender As System.Object, e As System.EventArgs) Handles pctKnight.Click
    Me.DialogResult = Windows.Forms.DialogResult.Ignore
    Me.Close()
  End Sub
  Private Sub cmdCancel_Click(sender As System.Object, e As System.EventArgs) Handles cmdCancel.Click
    Me.DialogResult = Windows.Forms.DialogResult.Cancel
    Me.Close()
  End Sub
  Private Function GetPieceIco(pColor As Color, pType As clsChess.PieceType) As Icon
    Dim PieceDLL As Reflection.Assembly = Reflection.Assembly.LoadFile(Application.StartupPath & "\ChessPieces.dll")
    Dim pStream As IO.Stream = PieceDLL.GetManifestResourceStream("ChessPieces.I" & bSize & "_" & IIf(pColor = Color.White, "W", "B") & "_" & pType.ToString & ".ico")
    Return New Icon(pStream)
  End Function
End Class