﻿Imports Microsoft.WindowsAPICodePack.Taskbar
Imports System.Xml.Linq
Imports Microsoft.WindowsAPICodePack.Shell
Public Class frmMain
  Private cfgProfiles() As BNUI.cConfig
  Public selProfile As Integer = -1
  Private bThumbs As Boolean
  Private Delegate Sub SelectTabCallBack([Tab] As TabPage)
  Private WithEvents ttbConnect As New ThumbnailToolBarButton(My.Resources.connect, "Connect")
  Private WithEvents ttbDisconnect As New ThumbnailToolBarButton(My.Resources.disconnect, "Disconnect")
  Private ResMan As Resources.ResourceManager
  Private bBottoms() As Boolean
  Private DREAMS As MCIPlayer
  Private dTimer As Threading.Timer
  Private gwError As Gecko.ChromeDialog
  Public ReadOnly Property myProfileCount As Integer
    Get
      If cfgProfiles Is Nothing Then Return 0
      Return cfgProfiles.Count
    End Get
  End Property
  Public Property myProfile(Index As Integer) As BNUI.cConfig
    Get
      Return cfgProfiles(Index)
    End Get
    Set(value As BNUI.cConfig)
      cfgProfiles(Index) = value
    End Set
  End Property
  Private Sub SelectTab([Tab] As TabPage)
    If Me.InvokeRequired Then
      Dim d As New SelectTabCallBack(AddressOf SelectTab)
      Me.BeginInvoke(d, New Object() {[Tab]})
    Else
      tbsProfiles.SelectTab(Tab)
    End If
  End Sub
  Private Sub frmMain_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
    Try
      If Me.Tag = "LOADED" Then SaveAllSettings(True)
      tmrMouse.Enabled = False
      tmrPreviews.Enabled = False
      tmrTrayRefresh.Enabled = False
      tmrUpdate.Enabled = False
      'Gecko.Xpcom.Shutdown()
    Finally
      Application.Exit()
    End Try
  End Sub
  Private Sub SaveAllSettings(Optional bClose As Boolean = False)
    Try
      If My.Computer.FileSystem.FileExists(AppData & "\Settings.xml") Then My.Computer.FileSystem.CopyFile(AppData & "\Settings.xml", AppData & "\Settings.bak")
      ClearSettings()
      For I As Integer = 0 To tbsProfiles.TabPages.Count - 1
        Dim UI As BNUI = tbsProfiles.TabPages(I).Tag
        SaveSettings(I, UI.Config)
        If bClose Then If UI.Status > 1 Then UI.BNCS_Disconnect()
      Next I
      If My.Computer.FileSystem.FileExists(AppData & "\Settings.bak") Then My.Computer.FileSystem.DeleteFile(AppData & "\Settings.bak")
    Catch ex As Exception
      If My.Computer.FileSystem.FileExists(AppData & "\Settings.bak") Then
        If My.Computer.FileSystem.FileExists(AppData & "\Settings.xml") Then
          Dim sCustom As String = "You shouldn't see this text."
          Dim xSet = System.Xml.Linq.XElement.Load(AppData & "\Settings.xml")
          Dim xBak = Xml.Linq.XElement.Load(AppData & "\Settings.bak")
          If xSet.Elements("PROFILES") IsNot Nothing AndAlso xSet.Elements("PROFILES").Elements IsNot Nothing Then
            If xBak.Elements("PROFILES") IsNot Nothing AndAlso xBak.Elements("PROFILES").Elements IsNot Nothing Then
              sCustom = "Current Settings has " & xSet.Elements("PROFILES").Elements.Count & " profiles." & vbNewLine &
                        "Backup Settings has " & xBak.Elements("PROFILES").Elements.Count & " profiles."
            Else
              sCustom = "Current Settings has " & xSet.Elements("PROFILES").Elements.Count & " profiles." & vbNewLine &
                        "Backup Settings has no profiles."
            End If
          Else
            If xBak.Elements("PROFILES") IsNot Nothing AndAlso xBak.Elements("PROFILES").Elements IsNot Nothing Then
              sCustom = "Current Settings has no profiles." & vbNewLine &
                        "Backup Settings has " & xBak.Elements("PROFILES").Elements.Count & " profiles."
            Else
              sCustom = "Both a current and backup Settings file exist, but neither have profile data."
            End If
          End If
          Select Case MsgBox("There was an error saving your settings..." & vbNewLine &
                             sCustom & vbNewLine & vbNewLine &
                             ex.Message & vbNewLine & vbNewLine &
                             "Would you like to restore the backup?" & vbNewLine &
                             "(Yes to replace current with backup, No to delete backup, Cancel to leave both untouched [advanced].)",
                             MsgBoxStyle.Exclamation Or MsgBoxStyle.YesNoCancel Or MsgBoxStyle.DefaultButton2,
                             "Settings Failure")
            Case MsgBoxResult.Yes
              My.Computer.FileSystem.DeleteFile(AppData & "\Settings.xml")
              My.Computer.FileSystem.RenameFile(AppData & "\Settings.bak", "Settings.xml")
            Case MsgBoxResult.No
              My.Computer.FileSystem.DeleteFile(AppData & "\Settings.bak")
            Case MsgBoxResult.Cancel
              mnuHelpConfig.PerformClick()
          End Select
        Else
          MsgBox("There was an error saving your settings..." & vbNewLine &
                 "The backup will be restored. Please check your settings and try saving them again." & vbNewLine & vbNewLine &
                 ex.Message, MsgBoxStyle.Exclamation, "Settings Failure")
          My.Computer.FileSystem.RenameFile(AppData & "\Settings.bak", "Settings.xml")
        End If
      Else
        MsgBox("There was an error saving your settings..." & vbNewLine &
               "No backup file exists. Please check your settings and try saving them again." & vbNewLine & vbNewLine &
               ex.Message, MsgBoxStyle.Exclamation, "Settings Failure")
      End If
    End Try
  End Sub
  Private Sub frmMain_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
    If My.Settings.Splash Then frmSplash.SetStatus(My.Resources.SPLASH_INIT)
    ResMan = New Resources.ResourceManager("Entelechy.frmMain", Reflection.[Assembly].GetExecutingAssembly)
    Randomize()
    If My.Settings.Splash Then frmSplash.SetStatus(My.Resources.SPLASH_GECKO)
    If My.Computer.FileSystem.FileExists(XULRunnerZip) Then
      Dim Overwrite As Boolean = True
      If My.Computer.FileSystem.DirectoryExists(XULRunnerDir) Then
        If DateDiff(DateInterval.Second, My.Computer.FileSystem.GetDirectoryInfo(XULRunnerDir).CreationTime, My.Computer.FileSystem.GetFileInfo(XULRunnerZip).LastWriteTime) > 0 Then
          My.Computer.FileSystem.DeleteDirectory(XULRunnerDir, FileIO.DeleteDirectoryOption.DeleteAllContents)
          Overwrite = True
        Else
          Overwrite = False
        End If
      Else
        Overwrite = True
      End If
      Try
        Using zXUL As New Ionic.Zip.ZipFile(XULRunnerZip)
          If Overwrite Then
            zXUL.ExtractAll(XULRunnerDir, Ionic.Zip.ExtractExistingFileAction.OverwriteSilently)
          Else
            zXUL.ExtractAll(XULRunnerDir, Ionic.Zip.ExtractExistingFileAction.DoNotOverwrite)
          End If
          My.Computer.FileSystem.GetDirectoryInfo(XULRunnerDir).CreationTime = Now
        End Using
      Catch ex As Exception
        MsgBox("XULRunner was not extracted to " & XULRunnerDir & vbNewLine & vbNewLine & ex.Message, MsgBoxStyle.Critical, "Extraction Failed")
      End Try
      Try
        Gecko.Xpcom.Initialize(XULRunnerDir)
      Catch ex As Exception
        MsgBox("XULRunner was not correctly extracted to " & XULRunnerDir & vbNewLine & vbNewLine & "Please ensure you have an up-to-date copy of XULRunner before running Entelechy.", MsgBoxStyle.Critical, "Missing Gecko")
        End
      End Try
    Else
      MsgBox("XULRunner ZIP file was not found at " & XULRunnerZip & vbNewLine & vbNewLine & "Please ensure you have an up-to-date copy of XULRunner before running Entelechy.", MsgBoxStyle.Critical, "Missing Gecko")
    End If
    'ShowErrorConsole()
    Try
      Gecko.GeckoPreferences.User("general.useragent.override") = UserAgent
      Gecko.GeckoPreferences.User("browser.startup.homepage") = "chrome://entelechy/content/box.html"
      'Gecko.GeckoPreferences.User("media.opus.enabled") = True
    Catch ex As Exception
      Debug.Print("Failed to set preferences")
    End Try
    Using geckoINI As New INIReader(XULRunnerDir & "platform.ini")
      frmSplash.SetMozVer(geckoINI.GetValue("Build", "Milestone"))
    End Using
    If My.Settings.Splash Then frmSplash.SetStatus(My.Resources.SPLASH_ICONS)
    Try
      If String.IsNullOrEmpty(FreeImageAPI.FreeImageEngine.Version) Then
        MsgBox("No FreeImage Version!" & vbNewLine & vbNewLine & "FreeImage.dll must be installed.", MsgBoxStyle.Critical, "Missing FreeImage Version")
        End
      End If
    Catch ex As Exception
      MsgBox("FreeImage Failed to Load!" & vbNewLine & vbNewLine & Err.Description, MsgBoxStyle.Critical, "FreeImage Failure")
      End
    End Try
    ParseAllIcons()
    If My.Settings.Splash Then frmSplash.SetStatus(My.Resources.SPLASH_SERVERS)
    LoadBNServer()
    If My.Settings.Splash Then frmSplash.SetStatus(My.Resources.SPLASH_PROFILES)
    Me.Size = My.Settings.Main_Size
    LoadProfiles()
    Dim Init As Boolean = True
    If My.Settings.StartupUpdates Then
      If My.Settings.Splash Then frmSplash.SetStatus(My.Resources.SPLASH_UPDATE)
      If CheckUpdates(False) Then Init = False
    End If
    If My.Settings.Splash Then frmSplash.SetStatus(My.Resources.SPLASH_COMPLETE)
    tmrUpdate.Enabled = True
    StartTime = Environment.TickCount
    If String.IsNullOrEmpty(My.Settings.PlayerPath) Then
      Select Case My.Settings.MediaPlayer
        Case "Winamp" : My.Settings.PlayerPath = My.Computer.FileSystem.SpecialDirectories.ProgramFiles & "\Winamp\Winamp.exe"
        Case "WMP" : My.Settings.PlayerPath = My.Computer.FileSystem.SpecialDirectories.ProgramFiles & "\Windows Media Player\wmplayer.exe"
        Case "iTunes" : My.Settings.PlayerPath = My.Computer.FileSystem.SpecialDirectories.ProgramFiles & "\iTunes\iTunes.exe"
        Case "LimeLight" : My.Settings.PlayerPath = My.Computer.FileSystem.SpecialDirectories.ProgramFiles & "\RealityRipple Software\Lime Light Media Player\LLMP.exe"
      End Select
    End If
    MPControls = New clsMediaControls
    Me.Location = My.Settings.Main_Location
    If Me.Location.X > My.Computer.Screen.WorkingArea.Width Or Me.Location.X < 0 Then Me.Location = New Point(0, Me.Location.Y)
    If Me.Location.Y > My.Computer.Screen.WorkingArea.Height Or Me.Location.Y < 0 Then Me.Location = New Point(Me.Location.X, 0)
    Me.WindowState = My.Settings.Main_State
    Me.Tag = "LOADED"
    trayIcon.Visible = My.Settings.TrayIcon
    If tbsProfiles.TabCount > 0 Then
      tbsProfiles.SelectedIndex = 0
    Else
      mnuOptionsAccounts.PerformClick()
    End If
    tmrInit.Enabled = Init
    tmrMouse.Enabled = My.Settings.MouseTabSwitch
    tmrPreviews.Tag = 0
    tmrPreviews.Enabled = True
  End Sub
  Private Function CheckUpdates(Passive As Boolean) As Boolean
    Dim xPath As String = AppTemp & "\ver.xml"
    If Now.Subtract(My.Computer.FileSystem.GetFileInfo(xPath).CreationTime).TotalHours >= 4 Then
      Dim wsXML As New Net.WebClient
      wsXML.CachePolicy = New Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.NoCacheNoStore)
      Try
        wsXML.DownloadFile(New Uri(UpdateURL), xPath)
      Catch ex As Exception
        Return False
      End Try
      If My.Computer.FileSystem.ReadAllText(xPath).Contains("Error 404") Then Return False
      Dim xVer As XDocument = XDocument.Load(xPath)
      Dim xVerFile As XElement = xVer.Element("verfile")
      Dim xUpdates As XElement = xVerFile.Element("updates")
      If xUpdates IsNot Nothing Then
        Dim bUpdate As Boolean = False
        For Each File In xUpdates.Elements("file")
          Dim sLocalPath As String = Application.StartupPath & "\" & File.Element("path").Value
          If My.Computer.FileSystem.FileExists(sLocalPath) Then
            Dim sLocal As String = FileVersionInfo.GetVersionInfo(sLocalPath).FileVersion
            If String.IsNullOrEmpty(sLocal) Then
              Using MD5 As New System.Security.Cryptography.HMACMD5({31, 41, 59, 26, 53, 58, 97, 93, 238, 46, 26, 43, 38, 32, 79, 50, 28, 84, 197, 16, 93, 99, 37, 5, 105, 8, 20, 97, 4, 94, 45, 92, 30, 78, 16, 40, 62, 86, 208, 9, 98, 62, 80, 34, 82, 53, 42, 11, 70, 67, 98, 214, 80, 86, 51, 32, 82, 30, 66, 4, 70, 93, 84, 46})
                If BitConverter.ToString(MD5.ComputeHash(My.Computer.FileSystem.ReadAllBytes(sLocalPath))) <> File.Element("hash").Value Then
                  bUpdate = True
                  Exit For
                End If
              End Using
            Else
              Dim LocalVer(3) As String
              If sLocal.Contains(".") Then
                For I As Integer = 1 To 3
                  If sLocal.Split(".").Count > I Then
                    Dim sTmp As String = sLocal.Split(".")(I).Trim
                    If IsNumeric(sTmp) And sTmp.Length < 4 Then sTmp &= StrDup(4 - sTmp.Length, "0"c)
                    LocalVer(I) = sTmp
                  Else
                    LocalVer(I) = "0000"
                  End If
                Next
              ElseIf sLocal.Contains(",") Then
                For I As Integer = 1 To 3
                  If sLocal.Split(",").Count > I Then
                    Dim sTmp As String = sLocal.Split(",")(I).Trim
                    If IsNumeric(sTmp) And sTmp.Length < 4 Then sTmp &= StrDup(4 - sTmp.Length, "0"c)
                    LocalVer(I) = sTmp
                  Else
                    LocalVer(I) = "0000"
                  End If
                Next
              End If
              Dim RemoteVer(3) As String
              If File.Element("ver").Value.Contains(".") Then
                For I As Integer = 1 To 3
                  If File.Element("ver").Value.Split(".").Count > I Then
                    Dim sTmp As String = File.Element("ver").Value.Split(".")(I).Trim
                    If IsNumeric(sTmp) And sTmp.Length < 4 Then sTmp &= StrDup(4 - sTmp.Length, "0"c)
                    RemoteVer(I) = sTmp
                  Else
                    RemoteVer(I) = "0000"
                  End If
                Next
              ElseIf File.Element("ver").Value.Contains(",") Then
                For I As Integer = 1 To 3
                  If File.Element("ver").Value.Split(",").Count > I Then
                    Dim sTmp As String = File.Element("ver").Value.Split(",")(I).Trim
                    If IsNumeric(sTmp) And sTmp.Length < 4 Then sTmp &= StrDup(4 - sTmp.Length, "0"c)
                    RemoteVer(I) = sTmp
                  Else
                    RemoteVer(I) = "0000"
                  End If
                Next
              End If
              If Val(LocalVer(0)) > Val(RemoteVer(0)) Then
                'Local's OK
              ElseIf Val(LocalVer(0)) = Val(RemoteVer(0)) Then
                If Val(LocalVer(1)) > Val(RemoteVer(1)) Then
                  'Local's OK
                ElseIf Val(LocalVer(1)) = Val(RemoteVer(1)) Then
                  If Val(LocalVer(2)) > Val(RemoteVer(2)) Then
                    'Local's OK
                  ElseIf Val(LocalVer(2)) = Val(RemoteVer(2)) Then
                    If Val(LocalVer(3)) >= Val(RemoteVer(3)) Then
                      'Local's OK
                    Else
                      bUpdate = True
                    End If
                  Else
                    bUpdate = True
                  End If
                Else
                  bUpdate = True
                End If
              Else
                bUpdate = True
              End If
            End If
          Else
            bUpdate = True
            Exit For
          End If
          If bUpdate Then Exit For
        Next
        If bUpdate Then
          If Passive Then
            trayIcon.Tag = "UPDATE"
            If Not trayIcon.Visible Then trayIcon.Visible = True
            trayIcon.ShowBalloonTip(60000, String.Empty, My.Resources.INFO_UPDATE_AVAILABLE, ToolTipIcon.Info)
            Return True
          Else
            If MsgBox(My.Resources.SPLASH_UPDATE_AVAILABLE, MsgBoxStyle.Question Or MsgBoxStyle.YesNo Or MsgBoxStyle.ApplicationModal) = MsgBoxResult.Yes Then
              mnuHelpAbout.PerformClick()
              Return True
            End If
          End If
        End If
      End If
    End If
    Return False
  End Function
  Private Sub mnuProfileConnect_Click(sender As System.Object, e As System.EventArgs) Handles mnuProfileConnect.Click
    If tbsProfiles.TabPages.Count > 0 Then
      Dim UI As BNUI = tbsProfiles.SelectedTab.Tag
      If UI.Status > 1 Then UI.BNCS_Disconnect()
      UI.BNCS_Connect()
    Else
      Using mFrame As New MessageFrame : mFrame.MsgBox(Me, My.Resources.MAIN_NOPROFILES, MsgBoxStyle.Critical) : End Using
    End If
  End Sub
  Private Sub mnuOptionsAccounts_Click(sender As System.Object, e As System.EventArgs) Handles mnuOptionsAccounts.Click
    selProfile = -1
    If Not frmAccountOptions.Visible Then frmAccountOptions.Show(Me)
  End Sub
  Private Sub AddProfile(ProfileID As Integer)
    Dim NewUI As New BNUI
    Dim NewTab As New TabPage
    'NewUI.Initialize()
    NewUI.Config = cfgProfiles(ProfileID)
    NewUI.Config.Parent = NewUI
    NewUI.TabIndex = 99
    NewUI.TabStop = False
    NewTab.TabIndex = 99
    NewTab.TabStop = False
    NewUI.Tag = NewTab
    NewTab.Tag = NewUI
    tbsProfiles.TabPages.Add(NewTab)
    tbsProfiles.Visible = tbsProfiles.TabPages.Count > 0
    NewTab.Controls.Add(NewUI)
    NewUI.Dock = DockStyle.Fill
    NewTab.Text = cfgProfiles(ProfileID).Account.ProfileName
    NewUI.Index = ProfileID
    NewTab.BackColor = Color.Black
    AddPreviewBitmap(NewTab)
    tbsProfiles.SelectedTab = NewTab
    UpdatePreviewBitmap(NewTab)
  End Sub
  Private Sub preview_TabbedThumbnailMinimized(sender As Object, e As TabbedThumbnailEventArgs)
    tmrTrayRefresh.Tag = {"Minimized", e.WindowHandle}
    tmrTrayRefresh.Enabled = True
  End Sub
  Private Sub preview_TabbedThumbnailMaximized(sender As Object, e As TabbedThumbnailEventArgs)
    tmrTrayRefresh.Tag = {"Maximized", e.WindowHandle}
    tmrTrayRefresh.Enabled = True
  End Sub
  Private Sub preview_TabbedThumbnailClosed(sender As Object, e As TabbedThumbnailEventArgs)
    If bThumbs Then
      tmrTrayRefresh.Tag = {"Closed", e.WindowHandle}
      tmrTrayRefresh.Enabled = True
    End If
  End Sub
  Private Sub preview_TabbedThumbnailActivated(sender As Object, e As TabbedThumbnailEventArgs)
    If bThumbs Then
      tmrTrayRefresh.Tag = {"Activated", e.WindowHandle}
      tmrTrayRefresh.Enabled = True
    End If
  End Sub
  Public Sub RemoveProfile(ProfileID As Integer)
    Dim UI As BNUI = tbsProfiles.TabPages(ProfileID).Tag
    RemovePreviewBitmap(tbsProfiles.TabPages(ProfileID))
    UI.Terminate()
    tbsProfiles.TabPages(ProfileID).Controls.Remove(UI)
    UI.Dispose()
    UI = Nothing
    tbsProfiles.TabPages(ProfileID).Tag = Nothing
    tbsProfiles.TabPages.Remove(tbsProfiles.TabPages(ProfileID))
    RemoveSettings(ProfileID)
    tbsProfiles.Visible = tbsProfiles.TabPages.Count > 0
  End Sub
  Public Sub LoadProfiles()
    Dim bChangeCount As Boolean
    If cfgProfiles Is Nothing Then
      ReDim cfgProfiles(ProfileCount() - 1)
      bChangeCount = True
    Else
      If UBound(cfgProfiles) <> ProfileCount() - 1 Then
        bChangeCount = True
        ReDim cfgProfiles(ProfileCount() - 1)
      End If
    End If
    For I As Integer = 0 To UBound(cfgProfiles)
      LoadSettings(I, cfgProfiles(I))
      Application.DoEvents()
      If tbsProfiles.TabPages.Count - 1 < I Then
        AddProfile(I)
      Else
        Dim UI As BNUI = tbsProfiles.TabPages(I).Tag
        UI.Config = cfgProfiles(I)
        UI.Config.Parent = UI
      End If
      Application.DoEvents()
    Next
    For I As Integer = 0 To tbsProfiles.TabPages.Count - 1
      If UBound(cfgProfiles) < I Then RemoveProfile(I)
    Next
    For I As Integer = 0 To tbsProfiles.TabCount - 1
      tbsProfiles.TabPages(I).Text = cfgProfiles(I).Account.ProfileName
    Next
    tbsProfiles.Visible = tbsProfiles.TabPages.Count > 0
  End Sub
  Private Sub mnuProfileDisconnect_Click(sender As System.Object, e As System.EventArgs) Handles mnuProfileDisconnect.Click
    If tbsProfiles.TabPages.Count > 0 Then
      Dim UI As BNUI = tbsProfiles.SelectedTab.Tag
      If UI.Status > 1 Then UI.BNCS_Disconnect()
    Else
      Using mFrame As New MessageFrame : mFrame.MsgBox(Me, My.Resources.MAIN_NOPROFILES, MsgBoxStyle.Critical) : End Using
    End If
  End Sub
  Private Sub tmrUpdate_Tick(sender As System.Object, e As System.EventArgs) Handles tmrUpdate.Tick
    If tbsProfiles.TabCount > 0 Then
      For I As Integer = 0 To tbsProfiles.TabCount - 1
        Dim UIt As BNUI = tbsProfiles.TabPages(I).Tag
        Dim sTip As String
        If UIt.IsOnline Then
          sTip = ResString(My.Resources.MAIN_TAB_TOOLTIP, UIt.BNetData.UniqueName, GetGatewayName(UIt.Config.Server, UIt.Config.Account.Client.Product = BNUI.GameType.WAR3 Or UIt.Config.Account.Client.Product = UIt.Config.Account.Client.Product = BNUI.GameType.W3XP), GameStringToName(UIt.Config.Account.Client.Product.ToString), UIt.Channel)
        Else
          sTip = My.Resources.MAIN_TAB_TOOLTIP_OFFLINE
        End If
        If Not tbsProfiles.TabPages(I).ToolTipText = sTip Then
          tbsProfiles.TabPages(I).ToolTipText = sTip
          If bThumbs Then
            UIt.ThumbView.Title = tbsProfiles.TabPages(I).Text & IIf(UIt.IsOnline, " - " & UIt.Channel, String.Empty)
            UIt.ThumbView.Tooltip = sTip
          End If
        End If
        If String.IsNullOrEmpty(tbsProfiles.TabPages(I).ImageKey) OrElse Not IsNumeric(tbsProfiles.TabPages(I).ImageKey) Then
          tbsProfiles.TabPages(I).ImageKey = 0
          Using bmpIcon As New Bitmap(imlStatus.Images.Item(tbsProfiles.TabPages(I).ImageKey))
            If bThumbs Then UIt.ThumbView.SetWindowIcon(bmpIcon.GetHicon)
          End Using
        Else
          If I = tbsProfiles.SelectedIndex Then UIt.ReadMessages()
          'If UIt.ContainsFocus Then UIt.ReadMessages()
          If Not tbsProfiles.TabPages(I).ImageKey = UIt.Status Then
            tbsProfiles.TabPages(I).ImageKey = UIt.Status
            Using bmpIcon As New Bitmap(imlStatus.Images.Item(tbsProfiles.TabPages(I).ImageKey))
              If bThumbs Then UIt.ThumbView.SetWindowIcon(bmpIcon.GetHicon)
            End Using
          End If
        End If
      Next
      mnuProfileAll.Enabled = True
      Dim UI As BNUI = tbsProfiles.SelectedTab.Tag
      If UI.Status > 1 Then
        mnuProfileConnect.Enabled = True
        mnuProfileConnect.Text = ResMan.GetString("mnuProfileReconnect.Text")
        mnuProfileDisconnect.Enabled = True
      Else
        mnuProfileConnect.Enabled = True
        mnuProfileConnect.Text = ResMan.GetString("mnuProfileConnect.Text")
        mnuProfileDisconnect.Enabled = False
      End If
    Else
      mnuProfileAll.Enabled = False
      mnuProfileConnect.Enabled = False
      mnuProfileDisconnect.Enabled = False
    End If
    Static LastUpdate As Date
    If LastUpdate = New Date Then LastUpdate = Now
    If Math.Abs(DateDiff(DateInterval.Hour, LastUpdate, Now)) > 23 Then
      LastUpdate = Now
      CheckUpdates(True)
    End If
  End Sub
  Private Sub mnuProfileExit_Click(sender As System.Object, e As System.EventArgs) Handles mnuProfileExit.Click
    Me.Close()
  End Sub
  Private Sub mnuProfileAllConnect_Click(sender As System.Object, e As System.EventArgs) Handles mnuProfileAllConnect.Click
    If tbsProfiles.TabCount > 0 Then
      For I As Integer = 0 To tbsProfiles.TabCount - 1
        Dim UI As BNUI = tbsProfiles.TabPages(I).Tag
        If UI.Status = 0 Or UI.Status = 1 Then UI.BNCS_Connect()
      Next
    Else
      Using mFrame As New MessageFrame : mFrame.MsgBox(Me, My.Resources.MAIN_NOPROFILES, MsgBoxStyle.Critical) : End Using
    End If
  End Sub
  Private Sub mnuProfileAllDisconnect_Click(sender As System.Object, e As System.EventArgs) Handles mnuProfileAllDisconnect.Click
    If tbsProfiles.TabCount > 0 Then
      For I As Integer = 0 To tbsProfiles.TabCount - 1
        Dim UI As BNUI = tbsProfiles.TabPages(I).Tag
        If UI.Status > 1 Then UI.BNCS_Disconnect()
      Next
    Else
      Using mFrame As New MessageFrame : mFrame.MsgBox(Me, My.Resources.MAIN_NOPROFILES, MsgBoxStyle.Critical) : End Using
    End If
  End Sub
  Private Sub mnuTabConnect_Click(sender As System.Object, e As System.EventArgs) Handles mnuTabConnect.Click
    If selProfile > -1 Then
      Dim UI As BNUI = tbsProfiles.TabPages(selProfile).Tag
      If UI.Status > 1 Then UI.BNCS_Disconnect()
      UI.BNCS_Connect()
      selProfile = -1
    End If
  End Sub
  Private Sub mnuTabDisconnect_Click(sender As System.Object, e As System.EventArgs) Handles mnuTabDisconnect.Click
    If selProfile > -1 Then
      Dim UI As BNUI = tbsProfiles.TabPages(selProfile).Tag
      If UI.Status > 1 Then UI.BNCS_Disconnect()
      selProfile = -1
    End If
  End Sub
  Private Sub mnuTabOptions_Click(sender As System.Object, e As System.EventArgs) Handles mnuTabOptions.Click
    If frmAccountOptions.Visible Then
      frmAccountOptions.frmAccountOptions_Load(New Object, New EventArgs)
    Else
      frmAccountOptions.Show(Me)
    End If
  End Sub
  Private Sub mnuTabDelete_Click(sender As System.Object, e As System.EventArgs) Handles mnuTabDelete.Click
    Using mFrame As New MessageFrame
      If mFrame.MsgBox(Me, ResString(My.Resources.DELETE_CONFIRM, tbsProfiles.TabPages(selProfile).Text), MsgBoxStyle.Question + MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
        RemoveProfile(selProfile)
        SaveAllSettings()
      End If
    End Using
    selProfile = -1
  End Sub
  Private Sub tbsProfiles_MouseDown(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles tbsProfiles.MouseDown
    If e.Button = Windows.Forms.MouseButtons.Left And tbsProfiles.TabCount > 0 Then
      For I As Integer = 0 To tbsProfiles.TabCount - 1
        If tbsProfiles.GetTabRect(I).Contains(e.Location) Then
          'Me.Cursor = Cursors.SizeAll
          selProfile = I
          Exit For
        End If
      Next
    End If
  End Sub
  Private Sub tbsProfiles_MouseMove(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles tbsProfiles.MouseMove
    If e.Button = Windows.Forms.MouseButtons.Left And tbsProfiles.TabCount > 0 Then
      Static iLast As Integer
      Dim iSel As Integer = -1
      For I As Integer = 0 To tbsProfiles.TabCount - 1
        If tbsProfiles.GetTabRect(I).Contains(e.Location) Then
          iSel = I
          Exit For
        End If
      Next
      If iSel = -1 Then
        Dim tRect As Rectangle = tbsProfiles.GetTabRect(tbsProfiles.TabCount - 1)
        If tRect.Right < e.Location.X And tRect.Top < e.Location.Y And tRect.Bottom > e.Location.Y Then
          iSel = tbsProfiles.TabCount - 1
        Else
          iSel = selProfile
        End If
      End If
      If selProfile = -1 Then Exit Sub
      If selProfile <> iSel Then
        If iLast <> iSel Then
          tbsProfiles.Refresh()
          Me.Cursor = Cursors.SizeAll
          Dim X, Y As Integer
          If selProfile < iSel Then
            X = tbsProfiles.GetTabRect(iSel).Right
          Else
            X = tbsProfiles.GetTabRect(iSel).Left
          End If
          Y = tbsProfiles.GetTabRect(iSel).Top
          Dim g As Graphics = tbsProfiles.CreateGraphics
          g.FillPolygon(New SolidBrush(Color.FromArgb(160, 255, 0, 0)), {New Point(X - 1, Y + 18), New Point(X - 4, Y + 18), New Point(X - 4, Y + 17), New Point(X - 6, Y + 17), New Point(X - 6, Y + 20),
                                      New Point(X + 6, Y + 20), New Point(X + 6, Y + 17), New Point(X + 4, Y + 17), New Point(X + 4, Y + 18), New Point(X + 1, Y + 18), New Point(X + 1, Y + 2),
                                      New Point(X + 4, Y + 2), New Point(X + 4, Y + 3), New Point(X + 6, Y + 3), New Point(X + 6, Y), New Point(X - 6, Y),
                                      New Point(X - 6, Y + 3), New Point(X - 4, Y + 3), New Point(X - 4, Y + 2), New Point(X - 1, Y + 2), New Point(X - 1, Y + 18)})
          g.Dispose()
        End If
      Else
        If iLast <> iSel Then
          tbsProfiles.Refresh()
          Me.Cursor = Cursors.No
        End If
      End If
      iLast = iSel
    End If
  End Sub
  Private Sub tbsProfiles_MouseUp(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles tbsProfiles.MouseUp
    If e.Button = Windows.Forms.MouseButtons.Right And tbsProfiles.TabCount > 0 Then
      tbsProfiles.Refresh()
      Dim lLen As Long = 1
      For I As Integer = 0 To tbsProfiles.TabCount - 1
        If tbsProfiles.GetTabRect(I).Contains(e.Location) Then
          selProfile = I
          Exit For
        End If
      Next
      Dim UI As BNUI = tbsProfiles.TabPages(selProfile).Tag
      If UI.Status > 1 Then
        mnuTabConnect.Enabled = True
        mnuTabConnect.Text = ResMan.GetString("mnuTabReconnect.Text")
        mnuTabDisconnect.Enabled = True
      Else
        mnuTabConnect.Enabled = True
        mnuTabConnect.Text = ResMan.GetString("mnuTabConnect.Text")
        mnuTabDisconnect.Enabled = False
      End If
      mnuTab.Show(tbsProfiles, New Point(e.X, e.Y))
    ElseIf e.Button = Windows.Forms.MouseButtons.Left And tbsProfiles.TabCount > 0 Then
      Me.Cursor = Cursors.Default
      Dim iSel As Integer = -1
      For I As Integer = 0 To tbsProfiles.TabCount - 1
        If tbsProfiles.GetTabRect(I).Contains(e.Location) Then
          iSel = I
          Exit For
        End If
      Next
      If iSel = -1 Then
        Dim tRect As Rectangle = tbsProfiles.GetTabRect(tbsProfiles.TabCount - 1)
        If tRect.Right < e.Location.X And tRect.Top < e.Location.Y And tRect.Bottom > e.Location.Y Then
          iSel = tbsProfiles.TabCount - 1
        Else
          iSel = selProfile
        End If
      End If
      If selProfile = -1 Then Exit Sub
      If selProfile <> iSel Then
        InsertSettings(selProfile, iSel)
        If selProfile < iSel Then
          Dim iTab As TabPage = tbsProfiles.TabPages(selProfile)
          For I As Integer = selProfile To iSel - 1
            For Each Tab As TabPage In tbsProfiles.TabPages
              If tbsProfiles.TabPages.IndexOf(Tab) = I + 1 Then
                tbsProfiles.TabPages(I) = Tab
                Exit For
              End If
            Next Tab
          Next
          tbsProfiles.TabPages(iSel) = iTab
        ElseIf selProfile > iSel Then
          Dim iTab As TabPage = tbsProfiles.TabPages(selProfile)
          For I As Integer = selProfile - 1 To iSel Step -1
            For Each Tab As TabPage In tbsProfiles.TabPages
              If tbsProfiles.TabPages.IndexOf(Tab) = I Then
                tbsProfiles.TabPages(I + 1) = Tab
                Exit For
              End If
            Next Tab
          Next
          tbsProfiles.TabPages(iSel) = iTab
        End If
        tbsProfiles.SelectedIndex = iSel
        tmrTrayRefresh.Tag = {"Refresh", IntPtr.Zero}
        tmrTrayRefresh.Enabled = True
      End If
      selProfile = -1
    ElseIf e.Button = Windows.Forms.MouseButtons.Middle And tbsProfiles.TabCount > 0 Then
      Dim lLen As Long = 1
      Dim iTab As Integer = -1
      For I As Integer = 0 To tbsProfiles.TabCount - 1
        If tbsProfiles.GetTabRect(I).Contains(e.Location) Then
          iTab = I
          Exit For
        End If
      Next
      If iTab > -1 Then
        Dim UI As BNUI = tbsProfiles.TabPages(iTab).Tag
        If UI.Status > 1 Then
          UI.BNCS_Disconnect()
        Else
          UI.BNCS_Connect()
        End If
      End If
    End If
  End Sub
  Private Sub frmMain_Resize(sender As Object, e As System.EventArgs) Handles Me.Resize
    Static lastMax As Boolean
    Try
      If Me.Tag = "LOADED" Then
        If Me.WindowState = FormWindowState.Minimized Then
          If My.Settings.MinToTray Then mnuTrayShow.PerformClick()
        Else
          trayIcon.Visible = My.Settings.TrayIcon
          My.Settings.Main_State = Me.WindowState
        End If
        If tbsProfiles.TabPages IsNot Nothing AndAlso tbsProfiles.TabCount > 0 Then
          If Me.WindowState = FormWindowState.Maximized And Not lastMax Then
            lastMax = True
            Dim selTab As TabPage = tbsProfiles.SelectedTab
            For Each tabItem As TabPage In tbsProfiles.TabPages
              If tabItem Is selTab Then
                UpdatePreviewBitmap(tabItem)
              Else
                Dim bnItem As BNUI = tabItem.Tag
                bnItem.Dock = DockStyle.None
                bnItem.Size = selTab.Size
                UpdatePreviewBitmap(tabItem)
                bnItem.Dock = DockStyle.Fill
              End If
            Next
          ElseIf Me.WindowState = FormWindowState.Normal And lastMax Then
            lastMax = False
            Dim selTab As TabPage = tbsProfiles.SelectedTab
            For Each tabItem As TabPage In tbsProfiles.TabPages
              If tabItem Is selTab Then
                UpdatePreviewBitmap(tabItem)
              Else
                Dim bnItem As BNUI = tabItem.Tag
                bnItem.Dock = DockStyle.None
                bnItem.Size = selTab.Size
                UpdatePreviewBitmap(tabItem)
                bnItem.Dock = DockStyle.Fill
              End If
            Next
          End If
          If bBottoms IsNot Nothing Then
            For I As Integer = 0 To tbsProfiles.TabPages.Count - 1
              If bBottoms(I) Then
                Dim ui As BNUI = CType(tbsProfiles.TabPages(I).Tag, BNUI)
                ui.ToBottom()
              End If
            Next
          End If
        End If
      End If
    Catch ex As Exception
    End Try
  End Sub
  Private Sub frmMain_ResizeBegin(sender As Object, e As System.EventArgs) Handles Me.ResizeBegin
    If Me.Tag = "LOADED" Then
      ReDim bBottoms(tbsProfiles.TabPages.Count - 1)
      For I As Integer = 0 To tbsProfiles.TabPages.Count - 1
        Dim ui As BNUI = CType(tbsProfiles.TabPages(I).Tag, BNUI)
        bBottoms(I) = ui.AtBottom
      Next
    End If
  End Sub
  Private Sub frmMain_ResizeEnd(sender As Object, e As System.EventArgs) Handles Me.ResizeEnd
    If Me.Tag = "LOADED" Then
      If Me.WindowState = FormWindowState.Normal Then
        My.Settings.Main_Location = Me.Location
        My.Settings.Main_Size = Me.Size
        For I As Integer = 0 To tbsProfiles.TabPages.Count - 1
          If bBottoms(I) Then
            Dim ui As BNUI = CType(tbsProfiles.TabPages(I).Tag, BNUI)
            ui.ToBottom()
          End If
        Next
      End If
      If Not Me.WindowState = FormWindowState.Minimized Then
        Dim selTab As TabPage = tbsProfiles.SelectedTab
        For Each tabItem As TabPage In tbsProfiles.TabPages
          If tabItem Is selTab Then
            UpdatePreviewBitmap(tabItem)
          Else
            Dim bnItem As BNUI = tabItem.Tag
            bnItem.Dock = DockStyle.None
            bnItem.Size = selTab.Size
            UpdatePreviewBitmap(tabItem)
            bnItem.Dock = DockStyle.Fill
          End If
        Next
      End If
    End If
  End Sub
  Protected Overrides Sub WndProc(ByRef m As System.Windows.Forms.Message)
    Static sLast As FormWindowState
    Static bB() As Boolean
    If m.Msg = &H46 Then
      sLast = Me.WindowState
      ReDim bB(tbsProfiles.TabPages.Count - 1)
      For I As Integer = 0 To tbsProfiles.TabPages.Count - 1
        Dim ui As BNUI = CType(tbsProfiles.TabPages(I).Tag, BNUI)
        bB(I) = ui.AtBottom
      Next
    End If
    If m.Msg = &H47 Then
      If sLast <> Me.WindowState Then
        sLast = Me.WindowState
        For I As Integer = 0 To tbsProfiles.TabPages.Count - 1
          If bB(I) Then
            Dim ui As BNUI = CType(tbsProfiles.TabPages(I).Tag, BNUI)
            ui.ToBottom()
          End If
        Next
      End If
    End If
    MyBase.WndProc(m)
  End Sub
  Private Sub mnuHelpConfig_Click(sender As System.Object, e As System.EventArgs) Handles mnuHelpConfig.Click
    Process.Start(AppData)
  End Sub
  Private Sub mnuAbout_Click(sender As System.Object, e As System.EventArgs) Handles mnuHelpAbout.Click, mnuTrayAbout.Click
    If My.Computer.FileSystem.FileExists(AppTemp & "\ver.xml") Then My.Computer.FileSystem.DeleteFile(AppTemp & "\ver.xml")
    If frmAbout.Visible Then
      frmAbout.Focus()
    Else
      frmAbout.Show(Me)
    End If
  End Sub
  Private Sub mnuHelpChat_Click(sender As System.Object, e As System.EventArgs) Handles mnuHelpChat.Click
    If tbsProfiles.TabPages.Count > 0 Then
      Dim UI As BNUI = tbsProfiles.SelectedTab.Tag
      ShowHelp(UI, &H0)
    End If
  End Sub
  Private Sub tbsProfiles_Selecting(sender As Object, e As System.Windows.Forms.TabControlCancelEventArgs) Handles tbsProfiles.Selecting
    UpdatePreviewBitmap(tbsProfiles.SelectedTab)
  End Sub
  Private Sub tbsProfiles_SelectedIndexChanged(sender As Object, e As System.EventArgs) Handles tbsProfiles.SelectedIndexChanged
    If tbsProfiles.SelectedTab IsNot Nothing Then
      Dim UI As BNUI = tbsProfiles.SelectedTab.Tag
      UI.txtSend.Focus()
      UI.ReadMessages()
      If bThumbs Then If TaskbarManager.Instance.TabbedThumbnail.IsThumbnailPreviewAdded(UI.ThumbView) Then TaskbarManager.Instance.TabbedThumbnail.SetActiveTab(UI.ThumbView)
    End If
  End Sub
  Public Sub RefreshPreviews()
    For Each tmpPage As TabPage In tbsProfiles.TabPages
      RemovePreviewBitmap(tmpPage)
      AddPreviewBitmap(tmpPage)
      If bThumbs Then
        Dim UIt As BNUI = tmpPage.Tag
        If UIt.ThumbView IsNot Nothing Then
          Dim sTip As String
          If UIt.IsOnline Then
            sTip = ResString(My.Resources.MAIN_TAB_TOOLTIP, UIt.BNetData.UniqueName, UIt.Config.Server, GameStringToName(UIt.Config.Account.Client.Product.ToString), UIt.Channel)
          Else
            sTip = My.Resources.MAIN_TAB_TOOLTIP_OFFLINE
          End If
          UIt.ThumbView.Title = tmpPage.Text & IIf(UIt.IsOnline, " - " & UIt.Channel, String.Empty)
          UIt.ThumbView.Tooltip = sTip
          Using bmpIcon As New Bitmap(imlStatus.Images.Item(tmpPage.ImageKey))
            If bThumbs Then UIt.ThumbView.SetWindowIcon(bmpIcon.GetHicon)
          End Using
        End If
      End If
    Next
  End Sub
  Private Sub AddPreviewBitmap(tabPage As TabPage)
    If TaskbarManager.IsPlatformSupported And My.Settings.TaskbarThumbs Then
      Dim tabUI As BNUI = tabPage.Tag
      tabUI.ThumbView = New TabbedThumbnail(Me.Handle, tabPage.Handle)
      AddHandler tabUI.ThumbView.TabbedThumbnailActivated, AddressOf preview_TabbedThumbnailActivated
      AddHandler tabUI.ThumbView.TabbedThumbnailClosed, AddressOf preview_TabbedThumbnailClosed
      AddHandler tabUI.ThumbView.TabbedThumbnailMaximized, AddressOf preview_TabbedThumbnailMaximized
      AddHandler tabUI.ThumbView.TabbedThumbnailMinimized, AddressOf preview_TabbedThumbnailMinimized
      TaskbarManager.Instance.TabbedThumbnail.AddThumbnailPreview(tabUI.ThumbView)
      TaskbarManager.Instance.ThumbnailToolBars.AddButtons(tabPage.Handle, ttbConnect, ttbDisconnect)
      bThumbs = True
      For Each tabItem As TabPage In tbsProfiles.TabPages
        If CType(tabItem.Tag, BNUI).ThumbView Is Nothing Then
          bThumbs = False
          Exit For
        End If
      Next
    End If
  End Sub
  Public Sub UpdatePreviewBitmap(tabPage As TabPage)
    If bThumbs Then
      If TaskbarManager.IsPlatformSupported AndAlso tabPage IsNot Nothing Then
        Dim preview As TabbedThumbnail = TaskbarManager.Instance.TabbedThumbnail.GetThumbnailPreview(tabPage)
        If preview IsNot Nothing Then
          Dim UI As BNUI = tabPage.Tag
          If Not UI.Size.IsEmpty Then
            Dim bm As New Bitmap(UI.Size.Width, UI.Size.Height)
            UI.DrawToBitmap(bm, New Rectangle(Point.Empty, UI.Size))
            'Application.DoEvents()
            preview.SetImage(bm)
            'End Using
          End If
        End If
      End If
    End If
  End Sub
  Private Sub RemovePreviewBitmap(tabPage As TabPage)
    If TaskbarManager.IsPlatformSupported Then
      Dim tabUI As BNUI = tabPage.Tag
      If tabUI.ThumbView IsNot Nothing Then
        If TaskbarManager.Instance.TabbedThumbnail.IsThumbnailPreviewAdded(tabUI.ThumbView) Then TaskbarManager.Instance.TabbedThumbnail.RemoveThumbnailPreview(tabUI.ThumbView)
        RemoveHandler tabUI.ThumbView.TabbedThumbnailActivated, AddressOf preview_TabbedThumbnailActivated
        RemoveHandler tabUI.ThumbView.TabbedThumbnailClosed, AddressOf preview_TabbedThumbnailClosed
        RemoveHandler tabUI.ThumbView.TabbedThumbnailMaximized, AddressOf preview_TabbedThumbnailMaximized
        RemoveHandler tabUI.ThumbView.TabbedThumbnailMinimized, AddressOf preview_TabbedThumbnailMinimized
        tabUI.ThumbView = Nothing
      End If
    Else
      Dim tabUI As BNUI = tabPage.Tag
      If tabUI.ThumbView IsNot Nothing Then
        RemoveHandler tabUI.ThumbView.TabbedThumbnailActivated, AddressOf preview_TabbedThumbnailActivated
        RemoveHandler tabUI.ThumbView.TabbedThumbnailClosed, AddressOf preview_TabbedThumbnailClosed
        RemoveHandler tabUI.ThumbView.TabbedThumbnailMaximized, AddressOf preview_TabbedThumbnailMaximized
        RemoveHandler tabUI.ThumbView.TabbedThumbnailMinimized, AddressOf preview_TabbedThumbnailMinimized
        tabUI.ThumbView = Nothing
      End If
    End If
    bThumbs = False
    For Each tabItem As TabPage In tbsProfiles.TabPages
      If CType(tabItem.Tag, BNUI).ThumbView IsNot Nothing Then
        bThumbs = True
        Exit For
      End If
    Next
  End Sub
  Public Sub ShowErrorConsole()
    If gwError Is Nothing OrElse gwError.IsDisposed Then
      gwError = New Gecko.ChromeDialog
      gwError.FormBorderStyle = FormBorderStyle.Sizable
      gwError.ShowIcon = True
      gwError.MinimizeBox = True
      gwError.MaximizeBox = True
      gwError.ShowInTaskbar = True
      gwError.Icon = My.Resources.Icon
    End If
    gwError.Show()
    gwError.WebBrowser.Navigate("chrome://global/content/console.xul")
  End Sub
  Private Sub trayIcon_BalloonTipClicked(sender As Object, e As System.EventArgs) Handles trayIcon.BalloonTipClicked
    If trayIcon.Tag Is Nothing Then
      mnuTrayShow.PerformClick()
    Else
      trayIcon.Tag = Nothing
      If Not Me.Visible Then mnuTrayShow.PerformClick()
      If Me.WindowState = FormWindowState.Minimized Then Me.WindowState = My.Settings.Main_State
      trayIcon.Visible = My.Settings.TrayIcon
      mnuAbout_Click(sender, e)
    End If
  End Sub
  Private Sub trayIcon_BalloonTipClosed(sender As Object, e As System.EventArgs) Handles trayIcon.BalloonTipClosed
    If trayIcon.Tag IsNot Nothing Then
      trayIcon.Tag = Nothing
      If Me.Visible Then
        trayIcon.Visible = My.Settings.TrayIcon
      Else
        trayIcon.Visible = My.Settings.MinToTray Or My.Settings.TrayIcon
      End If
    End If
  End Sub
  Private Sub trayIcon_MouseClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles trayIcon.MouseClick
    If e.Button = Windows.Forms.MouseButtons.Left Then
      If Me.Visible Then Me.Activate()
      trayIcon.BalloonTipIcon = ToolTipIcon.Info
      trayIcon.BalloonTipTitle = My.Resources.MAIN_TRAY_BALLOON_TITLE
      Dim sText As String = String.Empty
      For Each tabProfile As TabPage In tbsProfiles.TabPages
        Dim UI As BNUI = tabProfile.Tag
        If UI.IsOnline Then
          sText &= ResString(My.Resources.MAIN_TRAY_BALLOON_TEXT, UI.Config.Account.ProfileName, UI.Channel)
        Else
          sText &= ResString(My.Resources.MAIN_TRAY_BALLOON_TEXT_OFFLINE, UI.Config.Account.ProfileName)
        End If
        sText &= vbNewLine
      Next
      If String.IsNullOrEmpty(sText) Then sText = My.Resources.MAIN_NOPROFILES
      trayIcon.BalloonTipText = sText
      trayIcon.ShowBalloonTip(45000)
    End If
  End Sub
  Private Sub mnuTrayShow_Click(sender As System.Object, e As System.EventArgs) Handles mnuTrayShow.Click
    Me.Visible = Not Me.Visible
    If Me.Visible Then
      Me.Activate()
      mnuTrayShow.Text = ResMan.GetString("mnuTrayHide.Text")
      trayIcon.Visible = My.Settings.TrayIcon
      If Me.WindowState = FormWindowState.Minimized Then Me.WindowState = My.Settings.Main_State
    Else
      mnuTrayShow.Text = ResMan.GetString("mnuTrayShow.Text")
      trayIcon.Visible = My.Settings.MinToTray Or My.Settings.TrayIcon
    End If
  End Sub
  Private Sub mnuTrayExit_Click(sender As System.Object, e As System.EventArgs) Handles mnuTrayExit.Click
    Me.Close()
  End Sub
  Private Sub mnuTray_Opening(sender As System.Object, e As System.ComponentModel.CancelEventArgs) Handles mnuTray.Opening
    If Me.Visible Then
      mnuTrayShow.Text = ResMan.GetString("mnuTrayHide.Text")
    Else
      mnuTrayShow.Text = ResMan.GetString("mnuTrayShow.Text")
    End If
    mnuTrayProfiles.DropDownItems.Clear()
    Dim mnuTrayAll As New ToolStripMenuItem(ResMan.GetString("mnuProfileAll.Text"))
    Dim mnuTrayAllConnect As New ToolStripMenuItem(ResMan.GetString("mnuProfileAllConnect.Text"))
    AddHandler mnuTrayAllConnect.Click, AddressOf mnuProfileAllConnect_Click
    Dim mnuTrayAllDisconnect As New ToolStripMenuItem(ResMan.GetString("mnuProfileAllDisconnect.Text"))
    AddHandler mnuTrayAllDisconnect.Click, AddressOf mnuProfileAllDisconnect_Click
    mnuTrayAll.DropDownItems.Add(mnuTrayAllConnect)
    mnuTrayAll.DropDownItems.Add(mnuTrayAllDisconnect)
    mnuTrayProfiles.DropDownItems.Add(mnuTrayAll)
    mnuTrayProfiles.DropDownItems.Add(mnuTrayProfilesSpace)
    CType(mnuTrayAll.DropDown, ToolStripDropDownMenu).ShowImageMargin = False
    For Each tabProfile As TabPage In tbsProfiles.TabPages
      Dim UI As BNUI = tabProfile.Tag
      Dim mnuTrayProfilesItem As New ToolStripMenuItem(UI.Config.Account.ProfileName)
      AddHandler mnuTrayProfilesItem.MouseHover, AddressOf mnuTrayProfilesItem_MouseHover
      mnuTrayProfilesItem.Name = UI.Index
      Dim mnuTrayProfilesItemConnect As New ToolStripMenuItem(ResMan.GetString(IIf(UI.Status > 1, "mnuTabReconnect.Text", "mnuTabConnect.Text")))
      AddHandler mnuTrayProfilesItemConnect.Click, AddressOf mnuTabConnect_Click
      mnuTrayProfilesItem.DropDownItems.Add(mnuTrayProfilesItemConnect)

      Dim mnuTrayProfilesItemDisconnect As New ToolStripMenuItem(ResMan.GetString("mnuTabDisconnect.Text"))
      AddHandler mnuTrayProfilesItemDisconnect.Click, AddressOf mnuTabDisconnect_Click
      mnuTrayProfilesItemDisconnect.Enabled = UI.Status > 1
      mnuTrayProfilesItem.DropDownItems.Add(mnuTrayProfilesItemDisconnect)

      mnuTrayProfilesItem.DropDownItems.Add(New ToolStripSeparator)

      Dim mnuTrayProfilesItemOptions As New ToolStripMenuItem(ResMan.GetString("mnuTabOptions.Text"))
      AddHandler mnuTrayProfilesItemOptions.Click, AddressOf mnuTabOptions_Click
      mnuTrayProfilesItem.DropDownItems.Add(mnuTrayProfilesItemOptions)

      mnuTrayProfilesItem.DropDownItems.Add(New ToolStripSeparator)

      Dim mnuTrayProfilesItemDelete As New ToolStripMenuItem(ResMan.GetString("mnuTabDelete.Text"))
      AddHandler mnuTrayProfilesItemDelete.Click, AddressOf mnuTabDelete_Click
      mnuTrayProfilesItem.DropDownItems.Add(mnuTrayProfilesItemDelete)
      mnuTrayProfiles.DropDownItems.Add(mnuTrayProfilesItem)
      CType(mnuTrayProfilesItem.DropDown, ToolStripDropDownMenu).ShowImageMargin = False
    Next
  End Sub
  Private Sub mnuTrayProfilesItem_MouseHover(sender As Object, e As EventArgs)
    selProfile = sender.name
  End Sub
  Private Sub mnuProfileOptionsPasswordReset_Click(sender As System.Object, e As System.EventArgs) Handles mnuProfileOptionsPasswordReset.Click
    If tbsProfiles.TabPages.Count > 0 Then
      Dim UI As BNUI = tbsProfiles.SelectedTab.Tag
      Using mFrame As New MessageFrame
        If mFrame.MsgBox(UI, "Are you sure you want to reset " & UI.Config.Account.Username & "'s Password?", MsgBoxStyle.Question Or MsgBoxStyle.YesNo, "Reset Password?") = MsgBoxResult.Yes Then
          If UI.Status > 1 Then UI.BNCS_Disconnect()
          UI.Config.Account.Change.PassReset = True
          UI.BNCS_Connect()
        End If
      End Using
    Else
      Using mFrame As New MessageFrame : mFrame.MsgBox(Me, My.Resources.MAIN_NOPROFILES, MsgBoxStyle.Critical) : End Using
    End If
  End Sub
  Private Sub mnuProfileOptionsEMail_Click(sender As System.Object, e As System.EventArgs) Handles mnuProfileOptionsEMail.Click
    If tbsProfiles.TabPages.Count > 0 Then
      Dim UI As BNUI = tbsProfiles.SelectedTab.Tag
      UI.gChat.DontFocus = True
      UI.gChat.ShowChangeEMail(GeckoChat.ChatType.ServiceInfo, My.Resources.PROTOCOL_BNCS, My.Resources.MAIN_CHANGE_EMAIL, UI.Config.Account.EMail)
    Else
      Using mFrame As New MessageFrame : mFrame.MsgBox(Me, My.Resources.MAIN_NOPROFILES, MsgBoxStyle.Critical) : End Using
    End If
  End Sub
  Private Sub mnuProfileOptionsPasswordChange_Click(sender As System.Object, e As System.EventArgs) Handles mnuProfileOptionsPasswordChange.Click
    If tbsProfiles.TabPages.Count > 0 Then
      Dim UI As BNUI = tbsProfiles.SelectedTab.Tag
      UI.gChat.DontFocus = True
      UI.gChat.ShowChangePassword(GeckoChat.ChatType.ServiceInfo, My.Resources.PROTOCOL_BNCS, My.Resources.MAIN_CHANGE_PASSWORD, UI.Config.Account.Password)
    Else
      Using mFrame As New MessageFrame : mFrame.MsgBox(Me, My.Resources.MAIN_NOPROFILES, MsgBoxStyle.Critical) : End Using
    End If
  End Sub
  Private Sub tmrMouse_Tick(sender As System.Object, e As System.EventArgs) Handles tmrMouse.Tick
    If ActiveForm Is Me And tbsProfiles.TabCount > 0 Then
      If tmrMouse.Interval = 10 Then
        tmrMouse.Interval = 350
      ElseIf tmrMouse.Interval = 350 Then
        tmrMouse.Interval = 200
      End If
      If MouseButtons = Windows.Forms.MouseButtons.XButton1 Then
        If tbsProfiles.SelectedIndex = 0 Then
          tbsProfiles.SelectedIndex = tbsProfiles.TabCount - 1
        Else
          tbsProfiles.SelectedIndex -= 1
        End If
      ElseIf MouseButtons = Windows.Forms.MouseButtons.XButton2 Then
        If tbsProfiles.SelectedIndex = tbsProfiles.TabCount - 1 Then
          tbsProfiles.SelectedIndex = 0
        Else
          tbsProfiles.SelectedIndex += 1
        End If
      Else
        tmrMouse.Interval = 10
      End If
    End If
  End Sub
  Private Sub tmrInit_Tick(sender As System.Object, e As System.EventArgs) Handles tmrInit.Tick
    tmrInit.Enabled = False
    For I As Integer = 0 To tbsProfiles.TabPages.Count - 1
      Dim UI As BNUI = tbsProfiles.TabPages(I).Tag
      If UI.Config.AutoConnect And Not Command.Contains("/offline") Then
        UI.BNCS_Connect()
        Application.DoEvents()
        Threading.Thread.Sleep(100)
      End If
    Next
  End Sub
  Private Sub SettingsToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles mnuOptionsSettings.Click
    If Not frmSettings.Visible Then frmSettings.Show(Me)
  End Sub
  Private Sub tmrTrayRefresh_Tick(sender As System.Object, e As System.EventArgs) Handles tmrTrayRefresh.Tick
    tmrTrayRefresh.Enabled = False
    If tmrTrayRefresh.Tag IsNot Nothing Then
      Dim sCommand As String = CType(tmrTrayRefresh.Tag, Array)(0)
      Dim hWnd As IntPtr
      Dim selTab As TabPage
      If CType(tmrTrayRefresh.Tag, Array)(1) = IntPtr.Zero Then
        hWnd = IntPtr.Zero
        selTab = Nothing
      Else
        hWnd = CType(tmrTrayRefresh.Tag, Array)(1)
        selTab = (From page As TabPage In tbsProfiles.TabPages Where page.Handle = hWnd).FirstOrDefault
      End If
      Select Case sCommand
        Case "Activated"
          If Me.WindowState = FormWindowState.Minimized Then Me.WindowState = FormWindowState.Normal
          If Me.Visible And Me.WindowState <> FormWindowState.Minimized Then Me.Activate()
          If selTab IsNot Nothing Then SelectTab(selTab)
          TaskbarManager.Instance.TabbedThumbnail.SetActiveTab(hWnd)
          UpdatePreviewBitmap(tbsProfiles.SelectedTab)
        Case "Minimized"
          Me.WindowState = FormWindowState.Minimized
        Case "Maximized"
          Me.WindowState = FormWindowState.Maximized
          If tbsProfiles.Size <> Size.Empty AndAlso tbsProfiles.TabPages.Count > 0 AndAlso tbsProfiles.SelectedTab IsNot Nothing Then UpdatePreviewBitmap(tbsProfiles.SelectedTab)
        Case "Closed"
          If selTab IsNot Nothing Then
            Dim UI As BNUI = selTab.Tag
            Using mFrame As New MessageFrame
              If mFrame.MsgBox(Me, ResString(My.Resources.DELETE_CONFIRM, selTab.Text), MsgBoxStyle.Question + MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                RemoveProfile(UI.Index)
                tbsProfiles.TabPages.Remove(selTab)
                SaveAllSettings()
              Else
                RefreshPreviews()
              End If
            End Using
          End If
        Case "Refresh"
          RefreshPreviews()
      End Select
    End If
    tmrTrayRefresh.Tag = Nothing
  End Sub
  Private Sub frmMain_Shown(sender As Object, e As System.EventArgs) Handles Me.Shown
    If TaskbarManager.IsPlatformSupported Then
      Dim jList As JumpList
      jList = JumpList.CreateJumpList()
      jList.ClearAllUserTasks()
      Dim jllApp As New JumpListLink(Application.StartupPath, My.Resources.JUMPLIST_BOTFOLDER) With {.IconReference = New IconReference(Application.ExecutablePath, 0)}
      Dim jllConfig As New JumpListLink(AppData, My.Resources.JUMPLIST_CONFIGFOLDER) With {.IconReference = New IconReference("explorer.exe", 0)}
      Dim jllSettings As New JumpListLink("notepad.exe", My.Resources.JUMPLIST_SETTINGS) With {.Arguments = AppData & "\Settings.xml", .IconReference = New IconReference("notepad.exe", 0)}
      Dim jllWebsite As New JumpListLink("http://e.realityripple.com/", My.Resources.JUMPLIST_WEBSITE) With {.IconReference = New IconReference("shell32.dll", 135)}
      jList.AddUserTasks(jllSettings)
      jList.AddUserTasks(jllWebsite)
      jList.AddUserTasks(New JumpListSeparator)
      jList.AddUserTasks(jllApp)
      jList.AddUserTasks(jllConfig)
      jList.KnownCategoryToDisplay = JumpListKnownCategoryType.Neither
      jList.Refresh()
    End If
  End Sub
  Private Sub ttbConnect_Click(sender As Object, e As Microsoft.WindowsAPICodePack.Taskbar.ThumbnailButtonClickedEventArgs) Handles ttbConnect.Click
    Dim selTab As TabPage = (From page As TabPage In tbsProfiles.TabPages Where page.Handle = e.WindowHandle).FirstOrDefault
    CType(selTab.Tag, BNUI).BNCS_Connect()
  End Sub
  Private Sub ttbDisconnect_Click(sender As Object, e As Microsoft.WindowsAPICodePack.Taskbar.ThumbnailButtonClickedEventArgs) Handles ttbDisconnect.Click
    Dim selTab As TabPage = (From page As TabPage In tbsProfiles.TabPages Where page.Handle = e.WindowHandle).FirstOrDefault
    CType(selTab.Tag, BNUI).BNCS_Disconnect()
  End Sub
  Private Sub mnuHelpComment_Click(sender As System.Object, e As System.EventArgs) Handles mnuHelpComment.Click
    frmComment.Show(Me)
  End Sub
  Private Sub mnuProfileHistory_Click(sender As System.Object, e As System.EventArgs) Handles mnuProfileHistory.Click
    frmHistory.Show()
  End Sub
  Private Sub mnuOptions_DropDownOpening(sender As Object, e As System.EventArgs) Handles mnuOptions.DropDownOpening
    selProfile = -1
  End Sub
  Private Sub mnuHelp_DropDownOpening(sender As Object, e As System.EventArgs) Handles mnuHelp.DropDownOpening
    If tbsProfiles.TabPages.Count > 0 Then
      mnuHelpTrouble.Enabled = True
      mnuHelpChat.Enabled = True
      mnuHelpTrouble.Text = IIf(CType(tbsProfiles.SelectedTab.Tag, BNUI).IsReadyForBan, My.Resources.MAIN_FTPBAN_MENU_GETBANNED, My.Resources.MAIN_FTPBAN_MENU_PREPARE)
    Else
      mnuHelpTrouble.Text = My.Resources.MAIN_FTPBAN_MENU_PREPARE
      mnuHelpTrouble.Enabled = False
      mnuHelpChat.Enabled = False
    End If
  End Sub
  Private Sub mnuHelpTrouble_Click(sender As System.Object, e As System.EventArgs) Handles mnuHelpTrouble.Click
    If Not CType(tbsProfiles.SelectedTab.Tag, BNUI).IsReadyForBan Then
      Using mFrame As New MessageFrame
        If mFrame.MsgBox(Me, My.Resources.MAIN_FTPBAN_PREPARE, MsgBoxStyle.Question Or MsgBoxStyle.YesNo, My.Resources.MAIN_FTPBAN_PREPARE_TITLE) = MsgBoxResult.Yes Then
          CType(tbsProfiles.SelectedTab.Tag, BNUI).ReadyBan()
          mnuHelpTrouble.Text = My.Resources.MAIN_FTPBAN_MENU_GETBANNED
        End If
      End Using
    Else
      Using mFrame As New MessageFrame
        If mFrame.MsgBox(Me, ResString(My.Resources.MAIN_FTPBAN_GETBANNED, CType(tbsProfiles.SelectedTab.Tag, BNUI).Config.Account.ProfileName), MsgBoxStyle.Question Or MsgBoxStyle.YesNo, My.Resources.MAIN_FTPBAN_GETBANNED_TITLE) = MsgBoxResult.Yes Then
          CType(tbsProfiles.SelectedTab.Tag, BNUI).GetBanned()
        End If
      End Using
    End If
  End Sub
  Private Sub tmrPreviews_Tick(sender As System.Object, e As System.EventArgs) Handles tmrPreviews.Tick
    If tbsProfiles.TabPages.Count > 0 Then
      If tmrPreviews.Tag < tbsProfiles.TabCount Then
        UpdatePreviewBitmap(tbsProfiles.TabPages(tmrPreviews.Tag))
      Else
        tmrPreviews.Interval = 5000
        tmrPreviews.Tag = 0
        UpdatePreviewBitmap(tbsProfiles.TabPages(tmrPreviews.Tag))
      End If
      tmrPreviews.Tag += 1
    End If
  End Sub
  Public Sub PlayDREAMS()
    If DREAMS Is Nothing Then
      Try
        My.Computer.FileSystem.WriteAllBytes(AppTemp & "\DREAMS.mid", My.Resources.DREAMS, False)
      Catch ex As Exception

      End Try
      If My.Computer.FileSystem.FileExists(AppTemp & "\DREAMS.mid") Then
        DREAMS = New MCIPlayer(AppTemp & "\DREAMS.mid")
        DREAMS.Play()
        dTimer = New Threading.Timer(New Threading.TimerCallback(AddressOf StopDREAMS), dTimer, 1000 * 60 * 6, Threading.Timeout.Infinite)
      End If
    End If
  End Sub
  Public Sub StopDREAMS()
    If DREAMS IsNot Nothing Then
      DREAMS.Stop()
      DREAMS.Close()
      DREAMS.CloseAll()
      DREAMS.Dispose()
      DREAMS = Nothing
    End If
    If dTimer IsNot Nothing Then dTimer = Nothing
    If My.Computer.FileSystem.FileExists(AppTemp & "\DREAMS.mid") Then
      Try
        My.Computer.FileSystem.DeleteFile(AppTemp & "\DREAMS.mid")
      Catch ex As Exception

      End Try
    End If
  End Sub
  Private Class MCIPlayer
    Implements IDisposable
    Private sAlias As String
    <Runtime.InteropServices.DllImport("winmm.dll")>
    Private Shared Function mciSendString(ByVal strCommand As String, ByVal strReturn As System.Text.StringBuilder, ByVal iReturnLength As Integer, ByVal hwndCallback As IntPtr) As Long
    End Function
    Public Sub New(ByVal sFileName As String)
      If Status() <> "" Then
        Close()
      End If
      sAlias = IO.Path.GetFileNameWithoutExtension(sFileName)
      Dim sCommand As String = "open """ & sFileName & """ alias " & sAlias
      mciSendString(sCommand, Nothing, 0, IntPtr.Zero)
    End Sub
    Public Sub Close()
      Dim sCommand As String = "close " & sAlias
      mciSendString(sCommand, Nothing, 0, IntPtr.Zero)
      sAlias = String.Empty
    End Sub
    Public Sub CloseAll()
      Dim sCommand As String = "close all wait"
      mciSendString(sCommand, Nothing, 0, IntPtr.Zero)
    End Sub
    Public Sub Pause()
      Dim sCommand As String = "pause " & sAlias
      mciSendString(sCommand, Nothing, 0, IntPtr.Zero)
    End Sub
    Public Sub Play()
      Dim sCommand As String = "play " & sAlias
      mciSendString(sCommand, Nothing, 0, IntPtr.Zero)
    End Sub
    Public Sub [Resume]()
      Dim sCommand As String = "play " & sAlias & " from " & CLng(Status())
      mciSendString(sCommand, Nothing, 0, IntPtr.Zero)
    End Sub
    Public Sub [Stop]()
      Dim sCommand As String = "stop " & sAlias
      mciSendString(sCommand, Nothing, 0, IntPtr.Zero)
    End Sub
    Public Function Status() As String
      Dim sBuffer As New System.Text.StringBuilder(128)
      mciSendString("status " & sAlias & " mode", sBuffer, sBuffer.Capacity, IntPtr.Zero)
      Return sBuffer.ToString()
    End Function
#Region "IDisposable Support"
    Private disposedValue As Boolean
    Protected Overridable Sub Dispose(disposing As Boolean)
      If Not Me.disposedValue Then
        If disposing Then
          [Stop]()
          Close()
          CloseAll()
        End If
      End If
      Me.disposedValue = True
    End Sub
    Public Sub Dispose() Implements IDisposable.Dispose
      Dispose(True)
      GC.SuppressFinalize(Me)
    End Sub
#End Region
  End Class
  Private Sub mnuProfileRefresher_Click(sender As System.Object, e As System.EventArgs) Handles mnuProfileRefresher.Click
    frmRefresher.Show(Me)
  End Sub
End Class