﻿Public Class frmRefresher
  Private Const TIMEOUT As Integer = 200
  Private Const PAUSETIME As Integer = 3000
  Private Sub cmdClear_Click(sender As System.Object, e As System.EventArgs) Handles cmdClear.Click
    txtUsername.Text = String.Empty
    txtPassword.Text = String.Empty
    cmbGateway.Text = String.Empty
    optClassic.Checked = True
    cmdAdd.Enabled = False
    txtUsername.Focus()
  End Sub
  Private Sub cmdClose_Click(sender As System.Object, e As System.EventArgs) Handles cmdClose.Click
    If cmdClose.Text = "C&lose" Then
      Me.Close()
    Else
      cmdClose.Text = "C&lose"
    End If
  End Sub
  Private Sub cmdBegin_Click(sender As System.Object, e As System.EventArgs) Handles cmdBegin.Click
    cmdBegin.Enabled = False
    cmdClose.Text = "Cance&l"
    pbAccounts.Value = 0
    pbAccounts.Maximum = lstAccounts.CheckedItems.Count
    Dim D2Key, D2XKey, W3Key As clsKey
    D2Key = Nothing
    D2XKey = Nothing
    W3Key = Nothing
    For I As Integer = 0 To lstAccounts.Items.Count - 1
      If Not Me.Visible Then Exit Sub
      If lstAccounts.Items(I).Checked Then
        pbAccounts.Value += 1
        Dim username As String = lstAccounts.Items(I).Tag(0)
        Dim password As String = lstAccounts.Items(I).Tag(1)
        Dim gateway As String = lstAccounts.Items(I).Tag(2)
        Dim Cli As Char = lstAccounts.Items(I).Tag(3)
        Select Case Cli
          Case "D"c
            ConnectToBNet(I, username, password, gateway, Cli, D2Key)
          Case "X"c
            ConnectToBNet(I, username, password, gateway, Cli, D2Key, D2XKey)
          Case "W"c
            ConnectToBNet(I, username, password, gateway, Cli, W3Key)
          Case Else
            ConnectToBNet(I, username, password, gateway, Cli)
        End Select
        If Not Me.Visible Then Exit Sub
        Threading.Thread.Sleep(2500)
        If Not Me.Visible Then Exit Sub
      End If
      If cmdClose.Text = "C&lose" Then Exit For
    Next
    pbAccounts.Value = 0
    cmdClose.Text = "C&lose"
    cmdBegin.Enabled = True
  End Sub
  Private Sub cmdAdd_Click(sender As System.Object, e As System.EventArgs) Handles cmdAdd.Click
    If String.IsNullOrEmpty(txtUsername.Text) Then
      txtUsername.Focus()
      Beep()
    ElseIf String.IsNullOrEmpty(txtPassword.Text) Then
      txtPassword.Focus()
      Beep()
    ElseIf String.IsNullOrEmpty(cmbGateway.Text) Then
      cmbGateway.Focus()
      Beep()
    Else
      Dim lvAdd As New ListViewItem(txtUsername.Text & "@" & cmbGateway.Text)
      Dim sC As Char = "0"c
      If optClassic.Checked Then
        sC = "C"c
        lvAdd.SubItems.Add("Classic")
      ElseIf optD2DV.Checked Then
        sC = "D"c
        lvAdd.SubItems.Add("D2 Realm")
      ElseIf optD2XP.Checked Then
        sC = "X"c
        lvAdd.SubItems.Add("D2 EXP Realm")
      ElseIf optWAR3.Checked Then
        sC = "W"c
        lvAdd.SubItems.Add("Warcraft III")
      End If
      lvAdd.SubItems.Add(". . .")
      lvAdd.Tag = {txtUsername.Text, txtPassword.Text, cmbGateway.Text, sC}
      If cmdAdd.Tag Is Nothing Then
        lstAccounts.Items.Add(lvAdd)
      Else
        lstAccounts.Items(cmdAdd.Tag) = lvAdd
        'cmdAdd.Text = "Add Account"
      End If
    End If
  End Sub
  Private Sub lstAccounts_DoubleClick(sender As Object, e As System.EventArgs) Handles lstAccounts.DoubleClick
    If lstAccounts.SelectedItems.Count = 1 Then
      cmdAdd.Tag = lstAccounts.SelectedItems(0).Index
      txtUsername.Text = lstAccounts.SelectedItems(0).Tag(0)
      txtPassword.Text = lstAccounts.SelectedItems(0).Tag(1)
      cmbGateway.Text = lstAccounts.SelectedItems(0).Tag(2)
      Select Case lstAccounts.SelectedItems(0).Tag(3)
        Case "C"c : optClassic.Checked = True
        Case "D"c : optD2DV.Checked = True
        Case "X"c : optD2XP.Checked = True
        Case "W"c : optWAR3.Checked = True
        Case Else : optClassic.Checked = True
      End Select
      cmdAdd.Text = "Edit &Account"
    End If
  End Sub
  Private Sub lstAccounts_KeyUp(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles lstAccounts.KeyUp
    If e.KeyCode = Keys.Delete Then
      If lstAccounts.SelectedItems.Count > 0 Then
        For Each item As ListViewItem In lstAccounts.SelectedItems
          item.Remove()
        Next
      End If
    End If
  End Sub
  Private Sub frmRefresher_Load(sender As Object, e As System.EventArgs) Handles Me.Load
    LoadGateways(optWAR3.Checked)
    Dim Usernames() As String = Nothing
    Dim Passwords() As String = Nothing
    Dim Gateways() As String = Nothing
    Dim Prods() As Char = Nothing
    LoadRefreshers(Usernames, Passwords, Prods, Gateways)
    If Usernames IsNot Nothing AndAlso Usernames.Count > 0 Then
      For I As Integer = 0 To Usernames.Count - 1
        Dim lvAdd As New ListViewItem(Usernames(I) & "@" & Gateways(I))
        Dim Prod As String = "Unknown"
        Select Case Prods(I)
          Case "C"c : Prod = "Classic"
          Case "D"c : Prod = "D2 Realm"
          Case "X"c : Prod = "D2 EXP Realm"
          Case "W"c : Prod = "Warcraft III"
        End Select
        lvAdd.SubItems.Add(Prod)
        lvAdd.SubItems.Add(". . .")
        lvAdd.Tag = {Usernames(I), Passwords(I), Gateways(I), Prods(I)}
        lstAccounts.Items.Add(lvAdd)
      Next
    End If
    frmRefresher_ResizeEnd(sender, e)
  End Sub
  Private Sub frmRefresher_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
    If lstAccounts.Items.Count > 0 Then
      Dim Usernames(lstAccounts.Items.Count - 1), Passwords(lstAccounts.Items.Count - 1), Gateways(lstAccounts.Items.Count - 1) As String, Prods(lstAccounts.Items.Count - 1) As Char
      For I As Integer = 0 To lstAccounts.Items.Count - 1
        Usernames(I) = lstAccounts.Items(I).Tag(0)
        Passwords(I) = lstAccounts.Items(I).Tag(1)
        Gateways(I) = lstAccounts.Items(I).Tag(2)
        Prods(I) = lstAccounts.Items(I).Tag(3)
      Next
      SaveRefreshers(Usernames, Passwords, Prods, Gateways)
    Else
      SaveRefreshers(Nothing, Nothing, Nothing, Nothing)
    End If
  End Sub
  Private Sub otpW3_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles optWAR3.CheckedChanged
    LoadGateways(optWAR3.Checked)
  End Sub
  Private Sub LoadGateways(W3 As Boolean)
    cmbGateway.Items.Clear()
    If GetGateways() Is Nothing Then
      cmbGateway.Items.Add("USWest.Battle.net")
      cmbGateway.Items.Add("USEast.Battle.net")
      cmbGateway.Items.Add("Asia.Battle.net")
      cmbGateway.Items.Add("Europe.Battle.net")
    Else
      For Each GatewayURL As String In GetGateways()
        cmbGateway.Items.Add(GetGatewayName(GatewayURL, W3))
      Next
    End If
  End Sub
  Private Sub ConnectToBNet(Index As Integer, Username As String, Password As String, Gateway As String, Cli As Char, Optional ByRef CDKey As clsKey = Nothing, Optional ByRef EXPKey As clsKey = Nothing)
    Try
      If CDKey IsNot Nothing Then Debug.Print("CD Key: " & CDKey.Key)
      If EXPKey IsNot Nothing Then Debug.Print("EXPKey: " & EXPKey.Key)
      Using sckBNet As New Net.Sockets.TcpClient()
        lstAccounts.Items(Index).SubItems(2).Text = "Connecting to " & Gateway & "..."
        Application.DoEvents()
        Dim servers() = GetGatewayIPs(GetGatewayURL(Gateway, Cli = "W"c))
        Dim iServer = servers(Int(Rnd() * servers.Length))
        sckBNet.Connect(iServer, 6112)
        If sckBNet.Connected Then
          lstAccounts.Items(Index).SubItems(2).Text = "Connected!"
          Application.DoEvents()
        Else
          lstAccounts.Items(Index).SubItems(2).Text = "Unable to Connect!"
          Application.DoEvents()
          Exit Sub
        End If
        Dim iLoops As Integer = 0
        sckBNet.Client.Send({&H1})
        Select Case Cli
          Case "C"c 'Classic
            sckBNet.Client.Send(CLASSIC_CLIENTID2_Send)
            sckBNet.Client.Send(CLASSIC_LOCALEINFO_Send)
            sckBNet.Client.Send(CLASSIC_STARTVERSIONING_Send)
            Dim ServerToken, ClientToken As UInt32
            Dim MPQName As String = Nothing
            Dim MPQRequest() As Byte = Nothing
            Dim bCache() As Byte = Nothing
            Dim iPos As Integer = 0
            Do
              If sckBNet.Available >= 4 Or (bCache IsNot Nothing AndAlso bCache.Count >= 4) Then
                If bCache IsNot Nothing Then iPos = bCache.Length
                If sckBNet.Available >= 4 Then
                  Dim bData(sckBNet.Available - 1) As Byte
                  sckBNet.Client.Receive(bData)
                  ReDim Preserve bCache(iPos + bData.Length - 1)
                  bData.CopyTo(bCache, iPos)
                End If
                Using pktTmp As New DataReader(bCache)
                  iLoops = 0
                  Dim bFF As Byte = pktTmp.ReadByte
                  Dim bID As Byte = pktTmp.ReadByte
                  Dim iLen As UInt16 = pktTmp.ReadUInt16
                  If bFF = &HFF And bCache.Length >= iLen Then
                    Dim bPacket(iLen - 1) As Byte
                    Array.Copy(bCache, bPacket, iLen)
                    Dim bNewCache(bCache.Length - iLen - 1) As Byte
                    Array.Copy(bCache, iLen, bNewCache, 0, bCache.Length - iLen)
                    bCache = bNewCache
                    Erase bNewCache
                    Using pktBNIn As New BNCSReader(bPacket)
                      Select Case pktBNIn.PacketID
                        Case BNCS_CLIENTID
                          CLASSIC_CLIENTID_Recv(pktBNIn)
                        Case BNCS_LOGONCHALLENGEEX
                          ServerToken = CLASSIC_LOGONCHALLENGEEX_Recv(pktBNIn)
                        Case BNCS_STARTVERSIONING
                          CLASSIC_STARTVERSIONING_Recv(pktBNIn, MPQName, MPQRequest)
                          Dim bSend() As Byte = CLASSIC_REPORTVERSION_Send(iServer, MPQName, MPQRequest)
                          If bSend IsNot Nothing Then
                            sckBNet.Client.Send(bSend)
                          Else
                            lstAccounts.Items(Index).SubItems(2).Text = "Failed REPORTVERSION. Hash or CheckRevision failure."
                            Application.DoEvents()
                            Exit Sub
                          End If
                        Case BNCS_REPORTVERSION
                          Dim sRet As String = CLASSIC_REPORTVERSION_Recv(pktBNIn)
                          If sRet = "OK" Then
                            Dim bSend() As Byte = CLASSIC_LOGONRESPONSE_Send(ClientToken, ServerToken, Username, Password)
                            If bSend IsNot Nothing Then
                              sckBNet.Client.Send(bSend)
                              lstAccounts.Items(Index).SubItems(2).Text = "Logging in..."
                              Application.DoEvents()
                            Else
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed LOGONRESPONSE. Bad ServerToken."
                              Application.DoEvents()
                              Exit Sub
                            End If
                          Else
                            lstAccounts.Items(Index).SubItems(2).Text = "Failed REPORTVERSION. " & sRet
                            Application.DoEvents()
                            Exit Sub
                          End If
                        Case BNCS_LOGONRESPONSE
                          If CLASSIC_LOGONRESPONSE_Recv(pktBNIn) Then
                            sckBNet.Client.Send(CLASSIC_ENTERCHAT_Send(Username))
                          Else
                            lstAccounts.Items(Index).SubItems(2).Text = "Failed LOGONRESPONSE. Bad Password."
                            Application.DoEvents()
                            Exit Sub
                          End If
                        Case BNCS_ENTERCHAT
                          Exit Do
                        Case BNCS_PING
                          sckBNet.Client.Send(pktBNIn.GetAllBytes)
                      End Select
                    End Using
                  End If
                End Using
              Else
                If cmdClose.Text = "C&lose" Or Not Me.Visible Then Exit Sub
                Application.DoEvents()
                Threading.Thread.Sleep(100)
                iLoops += 1
                If iLoops >= TIMEOUT Then
                  sckBNet.Close()
                  lstAccounts.Items(Index).SubItems(2).Text = "Connection Timed Out. Retrying..."
                  Application.DoEvents()
                  Threading.Thread.Sleep(PAUSETIME)
                  ConnectToBNet(Index, Username, Password, Gateway, Cli, CDKey, EXPKey)
                  Exit Sub
                End If
              End If
            Loop
          Case "D"c 'D2DV 
            sckBNet.Client.Send(DIABLO_AUTH_INFO_Send(False))
            Dim ServerToken, ClientToken As UInt32
            Dim MPQName As String = Nothing
            Dim MPQRequest() As Byte = Nothing
            Dim bCache() As Byte = Nothing
            Dim iPos As Integer = 0
            Dim sRealms() As String = Nothing
            Dim iRealm As Integer
            Do
              If sckBNet.Available >= 4 Or (bCache IsNot Nothing AndAlso bCache.Count >= 4) Then
                If bCache IsNot Nothing Then iPos = bCache.Length
                If sckBNet.Available >= 4 Then
                  Dim bData(sckBNet.Available - 1) As Byte
                  sckBNet.Client.Receive(bData)
                  ReDim Preserve bCache(iPos + bData.Length - 1)
                  bData.CopyTo(bCache, iPos)
                End If
                Using pktTmp As New DataReader(bCache)
                  iLoops = 0
                  Dim bFF As Byte = pktTmp.ReadByte
                  Dim bID As Byte = pktTmp.ReadByte
                  Dim iLen As UInt16 = pktTmp.ReadUInt16
                  If bFF = &HFF And bCache.Length >= iLen Then
                    Dim bPacket(iLen - 1) As Byte
                    Array.Copy(bCache, bPacket, iLen)
                    Dim bNewCache(bCache.Length - iLen - 1) As Byte
                    Array.Copy(bCache, iLen, bNewCache, 0, bCache.Length - iLen)
                    bCache = bNewCache
                    Erase bNewCache
                    Using pktBNIn As New BNCSReader(bPacket)
                      Select Case pktBNIn.PacketID
                        Case BNCS_AUTH_INFO
                          If DIABLO_AUTH_INFO_Recv(pktBNIn, ServerToken, MPQName, MPQRequest) Then
                            If CDKey Is Nothing Then CDKey = New clsKey(GrabKeyStruct(Array.Find(GetCDKeys(False).ToArray, Function(cKey As Xml.Linq.XElement) ProdMatch(BNUI.GameType.D2DV, GrabKeyStruct(cKey).ProductVal, False))))
                            Dim bSend() As Byte = DIABLO_AUTH_CHECK_Send(ClientToken, ServerToken, MPQName, MPQRequest, CDKey)
                            If bSend IsNot Nothing Then
                              sckBNet.Client.Send(bSend)
                            Else
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_CHECK. Bad CDKey, Hashes, or ServerToken."
                              Application.DoEvents()
                              Exit Sub
                            End If
                          Else
                            lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_INFO."
                            Application.DoEvents()
                            Exit Sub
                          End If
                        Case BNCS_AUTH_CHECK
                          Select Case DIABLO_AUTH_CHECK_Recv(pktBNIn)
                            Case &H0
                              Dim bSend() As Byte = DIABLO_LOGONRESPONSE2_Send(ClientToken, ServerToken, Username, Password)
                              If bSend IsNot Nothing Then
                                sckBNet.Client.Send(bSend)
                              Else
                                lstAccounts.Items(Index).SubItems(2).Text = "Failed LOGONRESPONSE2. Bad ServerToken."
                                Application.DoEvents()
                                Exit Sub
                              End If
                            Case &H100
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_CHECK - " & My.Resources.VERSION_UPGRADE
                              Application.DoEvents()
                              Exit Sub
                            Case &H101
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_CHECK - " & My.Resources.VERSION_FAIL
                              Application.DoEvents()
                              Exit Sub
                            Case &H102
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_CHECK - " & My.Resources.VERSION_DOWNGRADE
                              Application.DoEvents()
                              Exit Sub
                            Case &H200, &H201, &H202, &H203
                              If CDKey Is Nothing Then
                                CDKey = New clsKey(GrabKeyStruct(Array.Find(GetCDKeys(False).ToArray, Function(cKey As Xml.Linq.XElement) ProdMatch(BNUI.GameType.D2DV, GrabKeyStruct(cKey).ProductVal, False))))
                              Else
                                TryNextKey(False, BNUI.GameType.D2DV, CDKey.Key, CDKey)
                              End If
                              sckBNet.Close()
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed Login. Trying next CDKey..."
                              Application.DoEvents()
                              Threading.Thread.Sleep(PAUSETIME)
                              ConnectToBNet(Index, Username, Password, Gateway, Cli, CDKey, EXPKey)
                              Exit Sub
                          End Select
                        Case BNCS_LOGONRESPONSE2
                          If DIABLO_LOGONRESPONSE2_Recv(pktBNIn) Then
                            sckBNet.Client.Send(DIABLO_QUERYREALMS2_Send)
                          Else
                            lstAccounts.Items(Index).SubItems(2).Text = "Failed LOGONRESPONSE2. Bad Login."
                            Application.DoEvents()
                            Exit Sub
                          End If
                        Case BNCS_QUERYREALMS2
                          sRealms = DIABLO_QUERYREALMS2_Recv(pktBNIn)
                          If sRealms IsNot Nothing AndAlso sRealms.Count > 0 Then
                            iRealm = 0
                            Dim bSend() As Byte = DIABLO_LOGONREALMEX_Send(sRealms(iRealm), ClientToken, ServerToken)
                            If bSend IsNot Nothing Then
                              sckBNet.Client.Send(bSend)
                            Else
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed LOGONREALMEX. Bad Server Name, ClientToken, or ServerToken."
                              Application.DoEvents()
                              Exit Sub
                            End If
                          Else
                            lstAccounts.Items(Index).SubItems(2).Text = "No Realms to connect to!"
                            Application.DoEvents()
                            Exit Sub
                          End If
                        Case BNCS_LOGONREALMEX
                          Dim oMCP As Object = DIABLO_LOGONREALMEX_Recv(pktBNIn, ClientToken)
                          If oMCP IsNot Nothing Then
                            Dim MCP As BNUI.MCPData = oMCP
                            Using sckMCP As New Net.Sockets.TcpClient
                              sckMCP.Connect(New Net.IPEndPoint(MCP.MCPIP, MCP.MCPPort))
                              If sckMCP.Connected Then
                                lstAccounts.Items(Index).SubItems(2).Text = "Realm Connected!"
                                Application.DoEvents()
                              Else
                                lstAccounts.Items(Index).SubItems(2).Text = "Unable to Connect to Realm!"
                                Application.DoEvents()
                                Exit Do
                              End If
                              sckMCP.Client.Send({&H1})
                              Dim bSend() As Byte = DIABLO_MCP_STARTUP_Send(MCP, ClientToken, Username)
                              If bSend IsNot Nothing Then
                                sckMCP.Client.Send(bSend)
                              Else
                                lstAccounts.Items(Index).SubItems(2).Text = "Failed MCP_STARTUP."
                                Application.DoEvents()
                                Exit Do
                              End If
                              Dim Chars() As String = Nothing
                              Dim iChar As Integer
                              Dim bMCPCache() As Byte = Nothing
                              Dim iMCPPos As Integer = 0
                              Do
                                If sckMCP.Available >= 3 Or (bMCPCache IsNot Nothing AndAlso bMCPCache.Count >= 4) Then
                                  If bMCPCache IsNot Nothing Then iMCPPos = bMCPCache.Length
                                  If sckMCP.Available >= 3 Then
                                    Dim bData(sckMCP.Available - 1) As Byte
                                    sckMCP.Client.Receive(bData)
                                    ReDim Preserve bMCPCache(iMCPPos + bData.Length - 1)
                                    bData.CopyTo(bMCPCache, iMCPPos)
                                  End If
                                  Using pktMCPTmp As New DataReader(bMCPCache)
                                    Dim iMCPLen As UInt16 = pktMCPTmp.ReadUInt16
                                    Dim bMCPID As Byte = pktMCPTmp.ReadByte
                                    If bMCPCache.Length >= iMCPLen Then
                                      Dim bMCPPacket(iMCPLen - 1) As Byte
                                      Array.Copy(bMCPCache, bMCPPacket, iMCPLen)
                                      Dim bNewMCPCache(bMCPCache.Length - iMCPLen - 1) As Byte
                                      Array.Copy(bMCPCache, iMCPLen, bNewMCPCache, 0, bMCPCache.Length - iMCPLen)
                                      bMCPCache = bNewMCPCache
                                      Erase bNewMCPCache
                                      Using pktMCPIn As New MCPReader(bMCPPacket)
                                        Select Case pktMCPIn.PacketID
                                          Case MCP_STARTUP
                                            If DIABLO_MCP_STARTUP_Recv(pktMCPIn) Then
                                              sckMCP.Client.Send(DIABLO_MCP_CHARLIST2_Send())
                                            Else
                                              lstAccounts.Items(Index).SubItems(2).Text = "Failed MCP_STARTUP. Realm Unavailable, Bad CDKey, or Realm Restricted."
                                              Application.DoEvents()
                                              Exit Do
                                            End If
                                          Case MCP_CHARLIST2
                                            Chars = DIABLO_MCP_CHARLIST2_Recv(pktMCPIn, False)
                                            If Chars IsNot Nothing AndAlso Chars.Count > 0 Then
                                              lstAccounts.Items(Index).SubItems(2).Text = "Refreshing " & Chars.Count & " Realm Character(s)..."
                                              Application.DoEvents()
                                              iChar = 0
                                              sckMCP.Client.Send(DIABLO_MCP_CHARLOGON_Send(Chars(iChar)))
                                            Else
                                              lstAccounts.Items(Index).SubItems(2).Text = "No Realm Characters to Refresh!"
                                              Application.DoEvents()
                                              Exit Do
                                            End If
                                          Case MCP_CHARLOGON
                                            If DIABLO_MCP_CHARLOGON_Recv(pktMCPIn) Then
                                              iChar += 1
                                              lstAccounts.Items(Index).SubItems(2).Text = "Refreshed " & iChar & "/" & Chars.Count & " Realm Character(s)..."
                                              Application.DoEvents()
                                              If iChar = Chars.Count Then Exit Do
                                            Else
                                              iChar += 1
                                              lstAccounts.Items(Index).SubItems(2).Text = "Failed to refresh " & Chars(iChar - 1) & "!"
                                              Application.DoEvents()
                                              If iChar = Chars.Count Then Exit Do
                                            End If
                                            sckMCP.Client.Send(DIABLO_MCP_CHARLOGON_Send(Chars(iChar)))
                                        End Select
                                      End Using
                                    End If
                                  End Using
                                Else
                                  If cmdClose.Text = "C&lose" Or Not Me.Visible Then Exit Sub
                                  Application.DoEvents()
                                  Threading.Thread.Sleep(100)
                                End If
                              Loop
                              sckMCP.Close()
                            End Using
                          Else
                            lstAccounts.Items(Index).SubItems(2).Text = "Failed LOGONREALMEX. Realm Unavailable or other Failure."
                            Application.DoEvents()
                            Exit Do
                          End If
                          iRealm += 1
                          If iRealm = sRealms.Count Then sckBNet.Client.Send(DIABLO_ENTERCHAT_Send(Username))
                        Case BNCS_ENTERCHAT
                          Exit Do
                        Case BNCS_PING
                          sckBNet.Client.Send(pktBNIn.GetAllBytes)
                      End Select
                    End Using
                  End If
                End Using
              Else
                If cmdClose.Text = "C&lose" Or Not Me.Visible Then Exit Sub
                Application.DoEvents()
                Threading.Thread.Sleep(100)
                iLoops += 1
                If iLoops >= TIMEOUT Then
                  sckBNet.Close()
                  lstAccounts.Items(Index).SubItems(2).Text = "Connection Timed Out. Retrying..."
                  Application.DoEvents()
                  Threading.Thread.Sleep(PAUSETIME)
                  ConnectToBNet(Index, Username, Password, Gateway, Cli, CDKey, EXPKey)
                  Exit Sub
                End If
              End If
            Loop
          Case "X"c 'D2XP 
            sckBNet.Client.Send(DIABLO_AUTH_INFO_Send(True))
            Dim ServerToken, ClientToken As UInt32
            Dim MPQName As String = Nothing
            Dim MPQRequest() As Byte = Nothing
            Dim bCache() As Byte = Nothing
            Dim iPos As Integer = 0
            Dim sRealms() As String = Nothing
            Dim iRealm As Integer
            Do
              If sckBNet.Available >= 4 Or (bCache IsNot Nothing AndAlso bCache.Count >= 4) Then
                If bCache IsNot Nothing Then iPos = bCache.Length
                If sckBNet.Available >= 4 Then
                  Dim bData(sckBNet.Available - 1) As Byte
                  sckBNet.Client.Receive(bData)
                  ReDim Preserve bCache(iPos + bData.Length - 1)
                  bData.CopyTo(bCache, iPos)
                End If
                Using pktTmp As New DataReader(bCache)
                  Dim bFF As Byte = pktTmp.ReadByte
                  Dim bID As Byte = pktTmp.ReadByte
                  Dim iLen As UInt16 = pktTmp.ReadUInt16
                  If bFF = &HFF And bCache.Length >= iLen Then
                    Dim bPacket(iLen - 1) As Byte
                    Array.Copy(bCache, bPacket, iLen)
                    Dim bNewCache(bCache.Length - iLen - 1) As Byte
                    Array.Copy(bCache, iLen, bNewCache, 0, bCache.Length - iLen)
                    bCache = bNewCache
                    Erase bNewCache
                    Using pktBNIn As New BNCSReader(bPacket)
                      iLoops = 0
                      Select Case pktBNIn.PacketID
                        Case BNCS_AUTH_INFO
                          If DIABLO_AUTH_INFO_Recv(pktBNIn, ServerToken, MPQName, MPQRequest) Then
                            If CDKey Is Nothing Then CDKey = New clsKey(GrabKeyStruct(Array.Find(GetCDKeys(False).ToArray, Function(cKey As Xml.Linq.XElement) ProdMatch(BNUI.GameType.D2XP, GrabKeyStruct(cKey).ProductVal, False))))
                            If EXPKey Is Nothing Then EXPKey = New clsKey(GrabKeyStruct(Array.Find(GetCDKeys(True).ToArray, Function(cKey As Xml.Linq.XElement) ProdMatch(BNUI.GameType.D2XP, GrabKeyStruct(cKey).ProductVal, True))))
                            Dim bSend() As Byte = DIABLO_AUTH_CHECK_Send(ClientToken, ServerToken, MPQName, MPQRequest, CDKey, EXPKey)
                            If bSend IsNot Nothing Then
                              sckBNet.Client.Send(bSend)
                            Else
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_CHECK. Bad CDKey, EXPKey, Hashes, or ServerToken."
                              Application.DoEvents()
                              Exit Sub
                            End If
                          Else
                            lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_INFO."
                            Application.DoEvents()
                            Exit Sub
                          End If
                        Case BNCS_AUTH_CHECK
                          Select Case DIABLO_AUTH_CHECK_Recv(pktBNIn)
                            Case &H0
                              Dim bSend() As Byte = DIABLO_LOGONRESPONSE2_Send(ClientToken, ServerToken, Username, Password)
                              If bSend IsNot Nothing Then
                                sckBNet.Client.Send(bSend)
                              Else
                                lstAccounts.Items(Index).SubItems(2).Text = "Failed LOGONRESPONSE2. Bad ServerToken."
                                Application.DoEvents()
                                Exit Sub
                              End If
                            Case &H100
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_CHECK - " & My.Resources.VERSION_UPGRADE
                              Application.DoEvents()
                              Exit Sub
                            Case &H101
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_CHECK - " & My.Resources.VERSION_FAIL
                              Application.DoEvents()
                              Exit Sub
                            Case &H102
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_CHECK - " & My.Resources.VERSION_DOWNGRADE
                              Application.DoEvents()
                              Exit Sub
                            Case &H200, &H201, &H202, &H203
                              If CDKey Is Nothing Then
                                CDKey = New clsKey(GrabKeyStruct(Array.Find(GetCDKeys(False).ToArray, Function(cKey As Xml.Linq.XElement) ProdMatch(BNUI.GameType.D2XP, GrabKeyStruct(cKey).ProductVal, False))))
                              Else
                                TryNextKey(False, BNUI.GameType.D2XP, CDKey.Key, CDKey)
                              End If
                              sckBNet.Close()
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed Login. Trying next CDKey..."
                              Application.DoEvents()
                              Threading.Thread.Sleep(PAUSETIME)
                              ConnectToBNet(Index, Username, Password, Gateway, Cli, CDKey, EXPKey)
                              Exit Sub
                            Case &H210, &H211, &H212, &H213
                              If EXPKey Is Nothing Then
                                EXPKey = New clsKey(GrabKeyStruct(Array.Find(GetCDKeys(True).ToArray, Function(cKey As Xml.Linq.XElement) ProdMatch(BNUI.GameType.D2XP, GrabKeyStruct(cKey).ProductVal, True))))
                              Else
                                TryNextKey(True, BNUI.GameType.D2XP, EXPKey.Key, EXPKey)
                              End If
                              sckBNet.Close()
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed Login. Trying next EXPKey..."
                              Application.DoEvents()
                              Threading.Thread.Sleep(PAUSETIME)
                              ConnectToBNet(Index, Username, Password, Gateway, Cli, CDKey, EXPKey)
                              Exit Sub
                          End Select
                        Case BNCS_LOGONRESPONSE2
                          If DIABLO_LOGONRESPONSE2_Recv(pktBNIn) Then
                            sckBNet.Client.Send(DIABLO_QUERYREALMS2_Send)
                          Else
                            lstAccounts.Items(Index).SubItems(2).Text = "Failed LOGONRESPONSE2. Bad Login."
                            Application.DoEvents()
                            Exit Sub
                          End If
                        Case BNCS_QUERYREALMS2
                          sRealms = DIABLO_QUERYREALMS2_Recv(pktBNIn)
                          If sRealms IsNot Nothing AndAlso sRealms.Count > 0 Then
                            iRealm = 0
                            Dim bSend() As Byte = DIABLO_LOGONREALMEX_Send(sRealms(iRealm), ClientToken, ServerToken)
                            If bSend IsNot Nothing Then
                              sckBNet.Client.Send(bSend)
                            Else
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed LOGONREALMEX. Bad Server Name, ClientToken, or ServerToken."
                              Application.DoEvents()
                              Exit Sub
                            End If
                          Else
                            lstAccounts.Items(Index).SubItems(2).Text = "No Realms to connect to!"
                            Application.DoEvents()
                            Exit Sub
                          End If
                        Case BNCS_LOGONREALMEX
                          Dim oMCP As Object = DIABLO_LOGONREALMEX_Recv(pktBNIn, ClientToken)
                          If oMCP IsNot Nothing Then
                            Dim MCP As BNUI.MCPData = oMCP
                            Using sckMCP As New Net.Sockets.TcpClient
                              sckMCP.Connect(New Net.IPEndPoint(MCP.MCPIP, MCP.MCPPort))
                              If sckMCP.Connected Then
                                lstAccounts.Items(Index).SubItems(2).Text = "Realm Connected!"
                                Application.DoEvents()
                              Else
                                lstAccounts.Items(Index).SubItems(2).Text = "Unable to Connect to Realm!"
                                Application.DoEvents()
                                Exit Do
                              End If
                              sckMCP.Client.Send({&H1})
                              Dim bSend() As Byte = DIABLO_MCP_STARTUP_Send(MCP, ClientToken, Username)
                              If bSend IsNot Nothing Then
                                sckMCP.Client.Send(bSend)
                              Else
                                lstAccounts.Items(Index).SubItems(2).Text = "Failed MCP_STARTUP."
                                Application.DoEvents()
                                Exit Do
                              End If
                              Dim Chars() As String = Nothing
                              Dim iChar As Integer
                              Dim bMCPCache() As Byte = Nothing
                              Dim iMCPPos As Integer = 0
                              Do
                                If sckMCP.Available >= 3 Or (bMCPCache IsNot Nothing AndAlso bMCPCache.Count >= 4) Then
                                  If bMCPCache IsNot Nothing Then iMCPPos = bMCPCache.Length
                                  If sckMCP.Available >= 3 Then
                                    Dim bData(sckMCP.Available - 1) As Byte
                                    sckMCP.Client.Receive(bData)
                                    ReDim Preserve bMCPCache(iMCPPos + bData.Length - 1)
                                    bData.CopyTo(bMCPCache, iMCPPos)
                                  End If
                                  Using pktMCPTmp As New DataReader(bMCPCache)
                                    Dim iMCPLen As UInt16 = pktMCPTmp.ReadUInt16
                                    Dim bMCPID As Byte = pktMCPTmp.ReadByte
                                    If bMCPCache.Length >= iMCPLen Then
                                      Dim bMCPPacket(iMCPLen - 1) As Byte
                                      Array.Copy(bMCPCache, bMCPPacket, iMCPLen)
                                      Dim bNewMCPCache(bMCPCache.Length - iMCPLen - 1) As Byte
                                      Array.Copy(bMCPCache, iMCPLen, bNewMCPCache, 0, bMCPCache.Length - iMCPLen)
                                      bMCPCache = bNewMCPCache
                                      Erase bNewMCPCache
                                      Using pktMCPIn As New MCPReader(bMCPPacket)
                                        Select Case pktMCPIn.PacketID
                                          Case MCP_STARTUP
                                            If DIABLO_MCP_STARTUP_Recv(pktMCPIn) Then
                                              sckMCP.Client.Send(DIABLO_MCP_CHARLIST2_Send())
                                            Else
                                              lstAccounts.Items(Index).SubItems(2).Text = "Failed MCP_STARTUP. Realm Unavailable, Bad CDKey, or Realm Restricted."
                                              Application.DoEvents()
                                              Exit Do
                                            End If
                                          Case MCP_CHARLIST2
                                            Chars = DIABLO_MCP_CHARLIST2_Recv(pktMCPIn, True)
                                            If Chars IsNot Nothing AndAlso Chars.Count > 0 Then
                                              lstAccounts.Items(Index).SubItems(2).Text = "Refreshing " & Chars.Count & " Realm Character(s)..."
                                              Application.DoEvents()
                                              iChar = 0
                                              sckMCP.Client.Send(DIABLO_MCP_CHARLOGON_Send(Chars(iChar)))
                                            Else
                                              lstAccounts.Items(Index).SubItems(2).Text = "No Realm Characters to Refresh!"
                                              Application.DoEvents()
                                              Exit Do
                                            End If
                                          Case MCP_CHARLOGON
                                            If DIABLO_MCP_CHARLOGON_Recv(pktMCPIn) Then
                                              iChar += 1
                                              lstAccounts.Items(Index).SubItems(2).Text = "Refreshed " & iChar & "/" & Chars.Count & " Realm Character(s)..."
                                              Application.DoEvents()
                                              If iChar = Chars.Count Then Exit Do
                                            Else
                                              iChar += 1
                                              lstAccounts.Items(Index).SubItems(2).Text = "Failed to refresh " & Chars(iChar - 1) & "!"
                                              Application.DoEvents()
                                              If iChar = Chars.Count Then Exit Do
                                            End If
                                            sckMCP.Client.Send(DIABLO_MCP_CHARLOGON_Send(Chars(iChar)))
                                        End Select
                                      End Using
                                    End If
                                  End Using
                                Else
                                  If cmdClose.Text = "C&lose" Or Not Me.Visible Then Exit Sub
                                  Application.DoEvents()
                                  Threading.Thread.Sleep(100)
                                End If
                              Loop
                              sckMCP.Close()
                            End Using
                          Else
                            lstAccounts.Items(Index).SubItems(2).Text = "Failed LOGONREALMEX. Realm Unavailable or other Failure."
                            Application.DoEvents()
                            Exit Do
                          End If
                          iRealm += 1
                          If iRealm = sRealms.Count Then
                            sckBNet.Client.Send(DIABLO_ENTERCHAT_Send(Username))
                          End If
                        Case BNCS_ENTERCHAT
                          Exit Do
                        Case BNCS_PING
                          sckBNet.Client.Send(pktBNIn.GetAllBytes)
                      End Select
                    End Using
                  End If
                End Using
              Else
                If cmdClose.Text = "C&lose" Or Not Me.Visible Then Exit Sub
                Application.DoEvents()
                Threading.Thread.Sleep(100)
                iLoops += 1
                If iLoops >= TIMEOUT Then
                  sckBNet.Close()
                  lstAccounts.Items(Index).SubItems(2).Text = "Connection Timed Out. Retrying..."
                  Application.DoEvents()
                  Threading.Thread.Sleep(PAUSETIME)
                  ConnectToBNet(Index, Username, Password, Gateway, Cli, CDKey, EXPKey)
                  Exit Sub
                End If
              End If
            Loop
          Case "W"c 'Warcraft III

            sckBNet.Client.Send(WARCRAFT_AUTH_INFO_Send())
            Dim ServerToken, ClientToken As UInt32
            Dim MPQName As String = Nothing
            Dim MPQRequest() As Byte = Nothing
            Dim bCache() As Byte = Nothing
            Dim iPos As Integer = 0
            Dim NLS As clsNLS = Nothing
            Do
              If sckBNet.Available >= 4 Or (bCache IsNot Nothing AndAlso bCache.Count >= 4) Then
                If bCache IsNot Nothing Then iPos = bCache.Length
                If sckBNet.Available >= 4 Then
                  Dim bData(sckBNet.Available - 1) As Byte
                  sckBNet.Client.Receive(bData)
                  ReDim Preserve bCache(iPos + bData.Length - 1)
                  bData.CopyTo(bCache, iPos)
                End If
                Using pktTmp As New DataReader(bCache)
                  Dim bFF As Byte = pktTmp.ReadByte
                  Dim bID As Byte = pktTmp.ReadByte
                  Dim iLen As UInt16 = pktTmp.ReadUInt16
                  If bFF = &HFF And bCache.Length >= iLen Then
                    Dim bPacket(iLen - 1) As Byte
                    Array.Copy(bCache, bPacket, iLen)
                    Dim bNewCache(bCache.Length - iLen - 1) As Byte
                    Array.Copy(bCache, iLen, bNewCache, 0, bCache.Length - iLen)
                    bCache = bNewCache
                    Erase bNewCache
                    Using pktBNIn As New BNCSReader(bPacket)
                      iLoops = 0
                      Select Case pktBNIn.PacketID
                        Case BNCS_AUTH_INFO
                          If WARCRAFT_AUTH_INFO_Recv(pktBNIn, ServerToken, MPQName, MPQRequest) Then
                            NLS = New clsNLS(Username, Password)
                            If CDKey Is Nothing Then CDKey = New clsKey(GrabKeyStruct(Array.Find(GetCDKeys(False).ToArray, Function(cKey As Xml.Linq.XElement) ProdMatch(BNUI.GameType.WAR3, GrabKeyStruct(cKey).ProductVal, False))))
                            Dim bSend() As Byte = WARCRAFT_AUTH_CHECK_Send(ClientToken, ServerToken, MPQName, MPQRequest, CDKey)
                            If bSend IsNot Nothing Then
                              sckBNet.Client.Send(bSend)
                            Else
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_CHECK. Bad CDKey, Hashes, or ServerToken."
                              Application.DoEvents()
                              Exit Sub
                            End If
                          Else
                            lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_INFO."
                            Application.DoEvents()
                            Exit Sub
                          End If
                        Case BNCS_AUTH_CHECK
                          Select Case WARCRAFT_AUTH_CHECK_Recv(pktBNIn)
                            Case &H0
                              sckBNet.Client.Send(WARCRAFT_AUTH_ACCOUNTLOGON_Send(NLS, Username))
                              lstAccounts.Items(Index).SubItems(2).Text = "Logging In..."
                              Application.DoEvents()
                            Case &H100
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_CHECK - " & My.Resources.VERSION_UPGRADE
                              Application.DoEvents()
                              Exit Sub
                            Case &H101
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_CHECK - " & My.Resources.VERSION_FAIL
                              Application.DoEvents()
                              Exit Sub
                            Case &H102
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_CHECK - " & My.Resources.VERSION_DOWNGRADE
                              Application.DoEvents()
                              Exit Sub
                            Case &H200, &H201, &H202, &H203
                              If CDKey Is Nothing Then
                                CDKey = New clsKey(GrabKeyStruct(Array.Find(GetCDKeys(False).ToArray, Function(cKey As Xml.Linq.XElement) ProdMatch(BNUI.GameType.D2DV, GrabKeyStruct(cKey).ProductVal, False))))
                              Else
                                TryNextKey(False, BNUI.GameType.WAR3, CDKey.Key, CDKey)
                              End If
                              sckBNet.Close()
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed Login. Trying next CDKey..."
                              Application.DoEvents()
                              Threading.Thread.Sleep(PAUSETIME)
                              ConnectToBNet(Index, Username, Password, Gateway, Cli, CDKey, EXPKey)
                              Exit Sub
                          End Select
                        Case BNCS_AUTH_ACCOUNTLOGON
                          Select Case WARCRAFT_AUTH_ACCOUNTLOGON_Recv(pktBNIn, NLS)
                            Case &H0
                              sckBNet.Client.Send(WARCRAFT_AUTH_ACCOUNTLOGONPROOF_Send(NLS))
                            Case &H1
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_ACCOUNTLOGON. Account does not exist."
                              Application.DoEvents()
                              Exit Sub
                            Case &H2
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_ACCOUNTLOGON. Account requires upgrade."
                              Application.DoEvents()
                              Exit Sub
                            Case &H3
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_ACCOUNTLOGON. Bad Account."
                              Application.DoEvents()
                              Exit Sub
                          End Select
                        Case BNCS_AUTH_ACCOUNTLOGONPROOF
                          Dim sRet As String = WARCRAFT_AUTH_ACCOUNTLOGONPROOF_Recv(pktBNIn, NLS)
                          Select Case sRet
                            Case "OK" : sckBNet.Client.Send(WARCRAFT_ENTERCHAT_Send())
                            Case Else
                              lstAccounts.Items(Index).SubItems(2).Text = "Failed AUTH_ACCOUNTLOGONPROOF. " & sRet
                              Application.DoEvents()
                              Exit Sub
                          End Select
                        Case BNCS_REQUIREDWORK
                          Continue Do
                        Case BNCS_OPTIONALWORK
                          Continue Do
                        Case BNCS_ENTERCHAT
                          Exit Do
                        Case BNCS_PING
                          sckBNet.Client.Send(pktBNIn.GetAllBytes)
                      End Select
                    End Using
                  End If
                End Using
              Else
                If cmdClose.Text = "C&lose" Or Not Me.Visible Then Exit Sub
                Application.DoEvents()
                Threading.Thread.Sleep(100)
                iLoops += 1
                If iLoops >= TIMEOUT Then
                  sckBNet.Close()
                  lstAccounts.Items(Index).SubItems(2).Text = "Connection Timed Out. Retrying..."
                  Application.DoEvents()
                  Threading.Thread.Sleep(PAUSETIME)
                  ConnectToBNet(Index, Username, Password, Gateway, Cli, CDKey, EXPKey)
                  Exit Sub
                End If
              End If
            Loop
        End Select
        sckBNet.Close()
        lstAccounts.Items(Index).SubItems(2).Text = "Connection Closed."
        Application.DoEvents()
      End Using
      lstAccounts.Items(Index).SubItems(2).Text = "Complete!"
      lstAccounts.Items(Index).Checked = False
      Application.DoEvents()
    Catch ex As Exception
      If Me.Visible Then
        lstAccounts.Items(Index).SubItems(2).Text = "Error - " & ex.Message
      Else
        Debug.Print("Refresher: " & ex.Message)
      End If
    End Try
  End Sub
#Region "CLASSIC"
  Private Function CLASSIC_CLIENTID2_Send() As Byte()
    Using pktCLIENTID2 As New BNCSPacket(BNCS_CLIENTID2)
      Dim cReg As RegistryKey
      Dim RegType As UInt32
      cReg = Registry.CurrentUser.OpenSubKey("Software\Battle.net\Configuration")
      RegType = Int(Rnd() * 2)
      pktCLIENTID2.InsertUInt32(RegType)
      If cReg IsNot Nothing Then
        If RegType = 1 Then
          pktCLIENTID2.InsertInt32(cReg.GetValue("Registration Version", 0).ToString)
          pktCLIENTID2.InsertInt32(cReg.GetValue("Registration Authority", 0).ToString)
        Else
          pktCLIENTID2.InsertInt32(cReg.GetValue("Registration Authority", 0).ToString)
          pktCLIENTID2.InsertInt32(cReg.GetValue("Registration Version", 0).ToString)
        End If
        pktCLIENTID2.InsertInt32(cReg.GetValue("Client ID", 0).ToString)
        pktCLIENTID2.InsertInt32(cReg.GetValue("Client Token", 0).ToString)
      Else
        pktCLIENTID2.InsertInt32(0)
        pktCLIENTID2.InsertInt32(0)
        pktCLIENTID2.InsertInt32(0)
        pktCLIENTID2.InsertInt32(0)
      End If
      pktCLIENTID2.InsertCString(Environment.MachineName)
      pktCLIENTID2.InsertCString(Environment.UserName)
      Return pktCLIENTID2.GetData
    End Using
  End Function
  Private Function CLASSIC_LOCALEINFO_Send() As Byte()
    Using pktLOCALEINFO As New BNCSPacket(BNCS_LOCALEINFO)
      Dim lTime As UInt64 = DateTime.Now.ToFileTime
      Dim lAdd As Int64 = ((DateTime.UtcNow - DateTime.Now).TotalMilliseconds * 10000)
      pktLOCALEINFO.InsertUInt64(lTime)
      pktLOCALEINFO.InsertUInt64(lTime - lAdd)
      pktLOCALEINFO.InsertInt32((DateTime.UtcNow - DateTime.Now).TotalMinutes)
      pktLOCALEINFO.InsertInt32(CultureInfo.InstalledUICulture.LCID)
      pktLOCALEINFO.InsertInt32(CultureInfo.CurrentCulture.LCID)
      pktLOCALEINFO.InsertInt32(CultureInfo.CurrentUICulture.LCID)
      pktLOCALEINFO.InsertCString(CultureInfo.CurrentCulture.ThreeLetterWindowsLanguageName)
      pktLOCALEINFO.InsertCString(RegionInfo.CurrentRegion.NativeName)
      pktLOCALEINFO.InsertCString(RegionInfo.CurrentRegion.ThreeLetterWindowsRegionName)
      pktLOCALEINFO.InsertCString(RegionInfo.CurrentRegion.EnglishName)
      Return pktLOCALEINFO.GetData
    End Using
  End Function
  Private Function CLASSIC_STARTVERSIONING_Send() As Byte()
    Using pktSTARTVERSIONING As New BNCSPacket(BNCS_STARTVERSIONING)
      pktSTARTVERSIONING.InsertUInt32(BNUI.GameArch.IX86)
      pktSTARTVERSIONING.InsertUInt32(BNUI.GameType.DRTL)
      pktSTARTVERSIONING.InsertUInt32(ReadVerbyte(BNUI.GameType.DRTL))
      pktSTARTVERSIONING.InsertUInt32(&H0)
      Return pktSTARTVERSIONING.GetData
    End Using
  End Function
  Private Sub CLASSIC_CLIENTID_Recv(pktIn As BNCSReader)
    Dim cReg As RegistryKey
    cReg = Registry.CurrentUser.OpenSubKey("Software\Battle.net\Configuration", True)
    If cReg Is Nothing Then
      Registry.CurrentUser.CreateSubKey("Software\Battle.net\Configuration")
      cReg = Registry.CurrentUser.OpenSubKey("Software\Battle.net\Configuration", True)
    End If
    cReg.SetValue("Registration Version", pktIn.ReadInt32)
    cReg.SetValue("Registration Authority", pktIn.ReadInt32)
    cReg.SetValue("Client ID", pktIn.ReadInt32)
    cReg.SetValue("Client Token", pktIn.ReadInt32)
  End Sub
  Private Function CLASSIC_LOGONCHALLENGEEX_Recv(pktIn As BNCSReader) As UInt32
    Dim UDPToken As UInt32 = pktIn.ReadUInt32
    Return pktIn.ReadUInt32
  End Function
  Private Sub CLASSIC_STARTVERSIONING_Recv(pktBNIn As BNCSReader, ByRef MPQName As String, ByRef MPQRequest As Byte())
    Dim MPQTime As UInt64 = pktBNIn.ReadUInt64
    MPQName = pktBNIn.ReadCString
    MPQRequest = pktBNIn.ReadNullTerminatedByteArray
  End Sub
  Private Function CLASSIC_REPORTVERSION_Send(Server As Net.IPAddress, MPQName As String, MPQRequest As Byte()) As Byte()
    Using pktTemp As New BNCSPacket(BNCS_REPORTVERSION)
      Dim HashFiles(2) As String
      Dim BINFile As String = Nothing
      Dim EXEVer As Int32
      Dim EXEHash As Int32
      Dim EXEInfo() As Byte
      GetHashFiles(BNUI.GameType.DRTL, HashFiles, BINFile)
      If String.IsNullOrEmpty(MPQName) Then Return Nothing
      pktTemp.InsertUInt32(BNUI.GameArch.IX86)
      pktTemp.InsertUInt32(BNUI.GameType.DRTL)
      pktTemp.InsertUInt32(ReadVerbyte(BNUI.GameType.DRTL))
      If MPQName.ToLower.Contains("ix86") Then
        If MPQName.ToLower.Contains("ver") Then
          Dim sRequest = System.Text.Encoding.GetEncoding(LATIN_1).GetString(MPQRequest)
          Dim EXEInfoS As String = String.Empty
          EXEVer = CheckRevision.GetExeInfo(HashFiles(0), EXEInfoS)
          EXEHash = CheckRevision.DoCheckRevision(sRequest, HashFiles, CheckRevision.ExtractMPQNumber(MPQName))
          EXEInfo = System.Text.Encoding.GetEncoding(LATIN_1).GetBytes(EXEInfoS)
        ElseIf MPQName.ToLower.Contains("lockdown") Then
          Dim MPQPath As String = AppTemp & "\MPQs\" & MPQName
          Dim DLLPath As String = AppStore & "\CheckRevision Libraries\" & MPQName.Substring(0, InStr(MPQName, ".")) & "dll"
          If Not My.Computer.FileSystem.DirectoryExists(AppStore & "\CheckRevision Libraries") Then My.Computer.FileSystem.CreateDirectory(AppStore & "\CheckRevision Libraries")
          If Not My.Computer.FileSystem.FileExists(DLLPath) Then
            If Not BNFTPRequest(Server, BNUI.GameArch.IX86, BNUI.GameType.DRTL, MPQPath, Nothing) Then Return Nothing
            Using Archive As New MPQ(MPQPath)
              Dim sFile As String = Archive.GetListFile
              If String.IsNullOrEmpty(sFile) Then Return Nothing
              If InStr(sFile, vbCr) Then sFile = Split(sFile, vbCr)(0)
              sFile = sFile.Trim(" ", vbCr, vbLf, vbNullChar)
              Dim SaveRet As MPQ.MPQSaveError = Archive.SaveToPath(sFile, IO.Path.GetDirectoryName(DLLPath))
              Select Case SaveRet
                Case MPQ.MPQSaveError.Success
                  'OK
                Case MPQ.MPQSaveError.FileNotFound
                  Return Nothing
                Case MPQ.MPQSaveError.MPQCorrupt
                  Return Nothing
                Case MPQ.MPQSaveError.NoMPQ
                  Return Nothing
                Case MPQ.MPQSaveError.UnknownFailure
                  Return Nothing
              End Select
            End Using
          End If
          EXEInfo = Lockdown.CheckRevision(MPQRequest, HashFiles, DLLPath, BINFile, EXEVer, EXEHash)
        Else
          Return Nothing
        End If
      Else
        Return Nothing
      End If
      pktTemp.InsertInt32(EXEVer)
      pktTemp.InsertInt32(EXEHash)
      pktTemp.InsertByteArray(EXEInfo)
      pktTemp.InsertByte(0)
      Return pktTemp.GetData
    End Using
  End Function
  Private Function CLASSIC_REPORTVERSION_Recv(pktIn As BNCSReader) As String
    Dim lRet As UInt32 = pktIn.ReadUInt32
    Select Case lRet
      Case 0 : Return My.Resources.VERSION_FAIL
      Case 1 : Return ResString(My.Resources.VERSION_UPGRADE_PATCH, pktIn.ReadCString)
      Case 2 : Return "OK"
      Case 3 : Return My.Resources.VERSION_REINSTALL
      Case Else : Return lRet
    End Select
  End Function
  Private Function CLASSIC_LOGONRESPONSE_Send(ByRef ClientToken As UInt32, ServerToken As UInt32, Username As String, Password As String) As Byte()
    If ClientToken = 0 Then ClientToken = Environment.TickCount
    If ServerToken = 0 Then
      Return Nothing
    End If
    Using pktTemp As New BNCSPacket(BNCS_LOGONRESPONSE)
      pktTemp.InsertUInt32(ClientToken)
      pktTemp.InsertUInt32(ServerToken)
      pktTemp.InsertByteArray(XSHA.DoubleHashPassword(Password, ClientToken, ServerToken))
      pktTemp.InsertCString(Username)
      Return pktTemp.GetData
    End Using
  End Function
  Private Function CLASSIC_LOGONRESPONSE_Recv(pktIn As BNCSReader) As Boolean
    Return pktIn.ReadBoolean
  End Function
  Private Function CLASSIC_ENTERCHAT_Send(Username As String) As Byte()
    Using pktTemp As New BNCSPacket(BNCS_ENTERCHAT)
      pktTemp.InsertCString(Username)
      pktTemp.InsertCString("LTRD 1 0 0 50 50 50 50 100 0")
      Return pktTemp.GetData
    End Using
  End Function
#End Region
#Region "DIABLO II"
  Private Function DIABLO_AUTH_INFO_Send(Expansion As Boolean) As Byte()
    Using pktTemp As New BNCSPacket(BNCS_AUTH_INFO)
      pktTemp.InsertUInt32(&H0)
      pktTemp.InsertUInt32(BNUI.GameArch.IX86)
      If Expansion Then
        pktTemp.InsertUInt32(BNUI.GameType.D2XP)
        pktTemp.InsertUInt32(ReadVerbyte(BNUI.GameType.D2XP))
      Else
        pktTemp.InsertUInt32(BNUI.GameType.D2DV)
        pktTemp.InsertUInt32(ReadVerbyte(BNUI.GameType.D2DV))
      End If
      pktTemp.InsertDwordString(CultureInfo.CurrentCulture.TwoLetterISOLanguageName & RegionInfo.CurrentRegion.TwoLetterISORegionName)
      pktTemp.InsertUInt32(BitConverter.ToUInt32(GetLocalIP.GetAddressBytes, 0))
      pktTemp.InsertUInt32((DateTime.UtcNow - DateTime.Now).TotalMinutes)
      pktTemp.InsertInt32(CultureInfo.CurrentCulture.LCID)
      pktTemp.InsertInt32(CultureInfo.CurrentCulture.KeyboardLayoutId)
      pktTemp.InsertCString(RegionInfo.CurrentRegion.ThreeLetterWindowsRegionName)
      pktTemp.InsertCString(RegionInfo.CurrentRegion.EnglishName)
      Return pktTemp.GetData
    End Using
  End Function
  Private Function DIABLO_AUTH_INFO_Recv(pktRead As BNCSReader, ByRef ServerToken As UInt32, ByRef MPQName As String, ByRef MPQRequest() As Byte) As Boolean
    Dim LS As UInt32 = pktRead.ReadUInt32
    Select Case LS
      Case 0
        ServerToken = pktRead.ReadUInt32
        Dim UDPToken As UInt32 = pktRead.ReadUInt32
        Dim MPQTime As UInt64 = pktRead.ReadUInt64
        MPQName = pktRead.ReadCString
        MPQRequest = pktRead.ReadNullTerminatedByteArray
        Return True
      Case Else
        Return False
    End Select
  End Function
  Private Function DIABLO_AUTH_CHECK_Send(ByRef ClientToken As UInt32, ServerToken As UInt32, MPQName As String, MPQRequest() As Byte, CDKey As clsKey, Optional EXPKey As clsKey = Nothing) As Byte()
    Using pktTemp As New BNCSPacket(BNCS_AUTH_CHECK)
      If ClientToken = 0 Then ClientToken = Environment.TickCount
      If ServerToken = 0 Then Return Nothing
      Dim KeyCount As UInt32
      Dim HashFiles(2) As String
      Dim EXEVer As Int32
      Dim EXEHash As Int32
      Dim EXEInfo() As Byte = Nothing
      Dim cProd As BNUI.GameType
      If EXPKey IsNot Nothing Then
        KeyCount = 2
        cProd = BNUI.GameType.D2XP
      Else
        KeyCount = 1
        cProd = BNUI.GameType.D2DV
      End If
      GetHashFiles(cProd, HashFiles, Nothing)
      pktTemp.InsertUInt32(ClientToken)
      If MPQName.ToLower.Contains("ix86") And MPQName.ToLower.Contains("ver") Then
        Dim sRequest = System.Text.Encoding.GetEncoding(LATIN_1).GetString(MPQRequest)
        Dim EXEInfoS As String = String.Empty
        EXEVer = CheckRevision.GetExeInfo(HashFiles(0), EXEInfoS)
        EXEHash = CheckRevision.DoCheckRevision(sRequest, HashFiles, CheckRevision.ExtractMPQNumber(MPQName))
        EXEInfo = System.Text.Encoding.GetEncoding(LATIN_1).GetBytes(EXEInfoS)
      Else
        Return Nothing
      End If
      If EXEHash = -1 Or EXEVer = -1 Then Return Nothing
      pktTemp.InsertInt32(EXEVer)
      pktTemp.InsertInt32(EXEHash)
      pktTemp.InsertUInt32(KeyCount)
      pktTemp.InsertBoolean(False)

      If CDKey.IsValid And ProdMatch(cProd, CDKey.Product, False) Then
        pktTemp.InsertInt32(CDLegal(CDKey.Key).Length)
        pktTemp.InsertUInt32(CDKey.Product)
        pktTemp.InsertUInt32(CDKey.PublicVal)
        pktTemp.InsertUInt32(0)
        Dim KeyHash() As Byte = CDKey.GetHash(ClientToken, ServerToken)
        pktTemp.InsertByteArray(KeyHash)
      Else
        Return Nothing
      End If
      If EXPKey IsNot Nothing Then
        If EXPKey.IsValid And ProdMatch(cProd, EXPKey.Product, True) Then
          pktTemp.InsertInt32(CDLegal(EXPKey.Key).Length)
          pktTemp.InsertUInt32(EXPKey.Product)
          pktTemp.InsertUInt32(EXPKey.PublicVal)
          pktTemp.InsertUInt32(0)
          pktTemp.InsertByteArray(EXPKey.GetHash(ClientToken, ServerToken))
        Else
          Return Nothing
        End If
      End If
      pktTemp.InsertByteArray(EXEInfo)
      pktTemp.InsertByte(0)
      pktTemp.InsertCString("Entelechy")
      Return pktTemp.GetData
    End Using
  End Function
  Private Function DIABLO_AUTH_CHECK_Recv(pktRead As BNCSReader) As UInt32
    Dim Ret As UInt32 = pktRead.ReadUInt32
    Return Ret
  End Function
  Private Function DIABLO_LOGONRESPONSE2_Send(ByRef ClientToken As UInt32, ServerToken As UInt32, Username As String, Password As String) As Byte()
    If ClientToken = 0 Then ClientToken = Environment.TickCount
    If ServerToken = 0 Then Return Nothing
    Using pktTemp As New BNCSPacket(BNCS_LOGONRESPONSE2)
      pktTemp.InsertUInt32(ClientToken)
      pktTemp.InsertUInt32(ServerToken)
      pktTemp.InsertByteArray(XSHA.DoubleHashPassword(Password, ClientToken, ServerToken))
      pktTemp.InsertCString(Username)
      Return pktTemp.GetData
    End Using
  End Function
  Private Function DIABLO_LOGONRESPONSE2_Recv(pktRead As BNCSReader) As Boolean
    Select Case pktRead.ReadUInt32
      Case 0 : Return True
      Case Else : Return False
    End Select
  End Function
  Private Function DIABLO_QUERYREALMS2_Send() As Byte()
    Using pktTemp As New BNCSPacket(BNCS_QUERYREALMS2)
      Return pktTemp.GetData
    End Using
  End Function
  Private Function DIABLO_QUERYREALMS2_Recv(pktRead As BNCSReader) As String()
    Dim Unknown As UInt32 = pktRead.ReadUInt32
    Dim RealmCount As UInt32 = pktRead.ReadUInt32
    Dim sRet(RealmCount - 1) As String
    If RealmCount > 0 Then
      For I As UInt32 = 0 To RealmCount - 1
        Dim iOne As UInt32 = pktRead.ReadUInt32
        sRet(I) = pktRead.ReadCString
        Dim sDesc As String = pktRead.ReadCString
      Next I
      Return sRet
    Else
      Return Nothing
    End If
  End Function
  Private Function DIABLO_LOGONREALMEX_Send(RealmName As String, ClientToken As UInt32, ServerToken As UInt32, Optional RealmPassword As String = "password") As Byte()
    Using pktTemp As New BNCSPacket(BNCS_LOGONREALMEX)
      If ClientToken = 0 Or ServerToken = 0 Or String.IsNullOrEmpty(RealmName) Then Return Nothing
      pktTemp.InsertUInt32(ClientToken)
      pktTemp.InsertByteArray(XSHA.DoubleHashPassword(RealmPassword, ClientToken, ServerToken))
      pktTemp.InsertCString(RealmName)
      Return pktTemp.GetData
    End Using
  End Function
  Private Function DIABLO_LOGONREALMEX_Recv(pktRead As BNCSReader, ClientToken As UInt32) As BNUI.MCPData
    Dim MCP As BNUI.MCPData
    If ClientToken = pktRead.ReadUInt32 Then
      MCP.Status = pktRead.ReadUInt32
      If pktRead.Length - 4 > 8 Then
        MCP.BNCSIP = pktRead.ReadUInt32
        MCP.UDPToken = pktRead.ReadUInt32
        MCP.MCPIP = New Net.IPAddress(pktRead.ReadUInt32)
        MCP.MCPPort = Net.IPAddress.HostToNetworkOrder(pktRead.ReadInt32) >> &H10
        MCP.NullVal = pktRead.ReadUInt16
        MCP.KeyProd = pktRead.ReadUInt16
        MCP.KeyPub = pktRead.ReadUInt32
        MCP.GatewayID = pktRead.ReadUInt32
        MCP.ProductID = pktRead.ReadUInt32
        MCP.PlatformID = pktRead.ReadUInt32
        MCP.BNCSIP2 = pktRead.ReadUInt32
        MCP.Locale = pktRead.ReadUInt32
        MCP.MCPHash1 = pktRead.ReadUInt32
        MCP.MCPHash2 = pktRead.ReadUInt32
        MCP.MCPHash3 = pktRead.ReadUInt32
        MCP.MCPHash4 = pktRead.ReadUInt32
        MCP.MCPHash5 = pktRead.ReadUInt32
        Dim sUsername As String = pktRead.ReadCString
        Return MCP
      Else
        Select Case MCP.Status
          Case &H80000001UL
            Return Nothing 'Unavailable
          Case &H80000002UL
            Return Nothing 'Fail
          Case Else
            Return Nothing 'Unknown
        End Select
      End If
    Else
      Return Nothing
    End If
  End Function
  Private Function DIABLO_MCP_STARTUP_Send(MCP As BNUI.MCPData, ClientToken As UInt32, Username As String) As Byte()
    Using pktTemp As New MCPPacket(MCP_STARTUP)
      pktTemp.InsertUInt32(ClientToken)
      pktTemp.InsertUInt32(MCP.Status)
      pktTemp.InsertUInt32(MCP.BNCSIP)
      pktTemp.InsertUInt32(MCP.UDPToken)
      pktTemp.InsertUInt16(MCP.NullVal)
      pktTemp.InsertUInt16(MCP.KeyProd)
      pktTemp.InsertUInt32(MCP.KeyPub)
      pktTemp.InsertUInt32(MCP.GatewayID)
      pktTemp.InsertUInt32(MCP.ProductID)
      pktTemp.InsertUInt32(MCP.PlatformID)
      pktTemp.InsertUInt32(MCP.BNCSIP2)
      pktTemp.InsertUInt32(MCP.Locale)
      pktTemp.InsertUInt32(MCP.MCPHash1)
      pktTemp.InsertUInt32(MCP.MCPHash2)
      pktTemp.InsertUInt32(MCP.MCPHash3)
      pktTemp.InsertUInt32(MCP.MCPHash4)
      pktTemp.InsertUInt32(MCP.MCPHash5)
      pktTemp.InsertCString(Username)
      Return pktTemp.GetData
    End Using
  End Function
  Private Function DIABLO_MCP_STARTUP_Recv(pktRead As MCPReader) As Boolean
    Dim Result As UInt32 = pktRead.ReadUInt32()
    Select Case Result
      Case &H2, &HA, &HB, &HC, &HD : Return False 'Realm Unavailable
      Case &H7E : Return False 'Banned CDKey
      Case &H7F : Return False 'Restricted
      Case Else : Return True
    End Select
  End Function
  Private Function DIABLO_MCP_CHARLIST2_Send() As Byte()
    Using pktTemp As New MCPPacket(MCP_CHARLIST2)
      pktTemp.InsertUInt32(8)
      Return pktTemp.GetData
    End Using
  End Function
  Private Function DIABLO_MCP_CHARLIST2_Recv(pktRead As MCPReader, Expansion As Boolean) As String()
    Dim iRequest As UInt16 = pktRead.ReadUInt16
    Dim iChars As UInt32 = pktRead.ReadUInt32
    Dim iReturned As UInt16 = pktRead.ReadUInt16
    Dim RealmChars() As String = Nothing
    If iReturned > 0 Then
      Dim aList(iReturned - 1) As Object
      For I As UInt16 = 0 To iReturned - 1
        Dim Expires As UInt32 = pktRead.ReadUInt32
        Dim sChar As String = pktRead.ReadCString
        Dim StatString() As Byte = pktRead.ReadNullTerminatedByteArray
        Dim bExp As Boolean = CBool(StatString(26) And &H20)
        If (Expansion And bExp) Or ((Not Expansion) And (Not bExp)) Then
          If RealmChars Is Nothing OrElse RealmChars.Count = 0 Then
            ReDim RealmChars(0)
            RealmChars(0) = sChar
          Else
            Array.Resize(RealmChars, RealmChars.Length + 1)
            RealmChars(RealmChars.Length - 1) = sChar
          End If
        End If
      Next
      Return RealmChars
    Else
      Return Nothing
    End If
  End Function
  Private Function DIABLO_MCP_CHARLOGON_Send(CharName As String) As Byte()
    Using pktTemp As New MCPPacket(MCP_CHARLOGON)
      pktTemp.InsertCString(CharName)
      Return pktTemp.GetData
    End Using
  End Function
  Private Function DIABLO_MCP_CHARLOGON_Recv(pktRead As MCPReader) As Boolean
    Dim lRet As UInt32 = pktRead.ReadUInt32
    Select Case lRet
      Case &H0 : Return True
      Case Else : Return False
    End Select
  End Function
  Private Function DIABLO_ENTERCHAT_Send(Username As String) As Byte()
    Using pktTemp As New BNCSPacket(BNCS_ENTERCHAT)
      pktTemp.InsertCString(Username)
      pktTemp.InsertByte(0)
      Return pktTemp.GetData
    End Using
  End Function
#End Region
#Region "WARCRAFT III"
  Private Function WARCRAFT_AUTH_INFO_Send() As Byte()
    Using pktTemp As New BNCSPacket(BNCS_AUTH_INFO)
      pktTemp.InsertUInt32(&H0)
      pktTemp.InsertUInt32(BNUI.GameArch.IX86)
      pktTemp.InsertUInt32(BNUI.GameType.WAR3)
      pktTemp.InsertUInt32(ReadVerbyte(BNUI.GameType.WAR3))
      pktTemp.InsertDwordString(CultureInfo.CurrentCulture.TwoLetterISOLanguageName & RegionInfo.CurrentRegion.TwoLetterISORegionName)
      pktTemp.InsertUInt32(BitConverter.ToUInt32(GetLocalIP.GetAddressBytes, 0))
      pktTemp.InsertUInt32((DateTime.UtcNow - DateTime.Now).TotalMinutes)
      pktTemp.InsertInt32(CultureInfo.CurrentCulture.LCID)
      pktTemp.InsertInt32(CultureInfo.CurrentCulture.KeyboardLayoutId)
      pktTemp.InsertCString(RegionInfo.CurrentRegion.ThreeLetterWindowsRegionName)
      pktTemp.InsertCString(RegionInfo.CurrentRegion.EnglishName)
      Return pktTemp.GetData
    End Using
  End Function
  Private Function WARCRAFT_AUTH_INFO_Recv(pktRead As BNCSReader, ByRef ServerToken As UInt32, ByRef MPQName As String, ByRef MPQRequest() As Byte) As Boolean
    Dim LS As UInt32 = pktRead.ReadUInt32
    Select Case LS
      Case 2
        ServerToken = pktRead.ReadUInt32
        Dim UDPToken As UInt32 = pktRead.ReadUInt32
        Dim MPQTime As UInt64 = pktRead.ReadUInt64
        MPQName = pktRead.ReadCString
        MPQRequest = pktRead.ReadNullTerminatedByteArray
        Return True
      Case Else
        Return False
    End Select
  End Function
  Private Function WARCRAFT_AUTH_CHECK_Send(ByRef ClientToken As UInt32, ServerToken As UInt32, MPQName As String, MPQRequest() As Byte, CDKey As clsKey) As Byte()
    Using pktTemp As New BNCSPacket(BNCS_AUTH_CHECK)
      If ClientToken = 0 Then ClientToken = Environment.TickCount
      If ServerToken = 0 Then Return Nothing
      Dim KeyCount As UInt32
      Dim HashFiles(2) As String
      Dim EXEVer As Int32
      Dim EXEHash As Int32
      Dim EXEInfo() As Byte = Nothing
      Dim cProd As BNUI.GameType
      KeyCount = 1
      cProd = BNUI.GameType.WAR3
      GetHashFiles(cProd, HashFiles, Nothing)
      pktTemp.InsertUInt32(ClientToken)
      If MPQName.ToLower.Contains("ix86") And MPQName.ToLower.Contains("ver") Then
        Dim sRequest = System.Text.Encoding.GetEncoding(LATIN_1).GetString(MPQRequest)
        Dim EXEInfoS As String = String.Empty
        EXEVer = CheckRevision.GetExeInfo(HashFiles(0), EXEInfoS)
        EXEHash = CheckRevision.DoCheckRevision(sRequest, HashFiles, CheckRevision.ExtractMPQNumber(MPQName))
        EXEInfo = System.Text.Encoding.GetEncoding(LATIN_1).GetBytes(EXEInfoS)
      Else
        Return Nothing
      End If
      If EXEHash = -1 Or EXEVer = -1 Then Return Nothing
      pktTemp.InsertInt32(EXEVer)
      pktTemp.InsertInt32(EXEHash)
      pktTemp.InsertUInt32(KeyCount)
      pktTemp.InsertBoolean(False)

      If CDKey.IsValid And ProdMatch(cProd, CDKey.Product, False) Then
        pktTemp.InsertInt32(CDLegal(CDKey.Key).Length)
        pktTemp.InsertUInt32(CDKey.Product)
        pktTemp.InsertUInt32(CDKey.PublicVal)
        pktTemp.InsertUInt32(0)
        Dim KeyHash() As Byte = CDKey.GetHash(ClientToken, ServerToken)
        pktTemp.InsertByteArray(KeyHash)
      Else
        Return Nothing
      End If
      pktTemp.InsertByteArray(EXEInfo)
      pktTemp.InsertByte(0)
      pktTemp.InsertCString("Entelechy")
      Return pktTemp.GetData
    End Using
  End Function
  Private Function WARCRAFT_AUTH_CHECK_Recv(pktRead As BNCSReader) As UInt32
    Dim Ret As UInt32 = pktRead.ReadUInt32
    Return Ret
  End Function
  Private Function WARCRAFT_AUTH_ACCOUNTLOGON_Send(ByRef NLS As clsNLS, Username As String) As Byte()
    Using pktTemp As New BNCSPacket(BNCS_AUTH_ACCOUNTLOGON)
      pktTemp.InsertByteArray(NLS.A)
      pktTemp.InsertCString(Username)
      Return pktTemp.GetData
    End Using
  End Function
  Private Function WARCRAFT_AUTH_ACCOUNTLOGON_Recv(pktRead As BNCSReader, ByRef NLS As clsNLS) As Byte
    Dim Status As UInt32 = pktRead.ReadUInt32
    Select Case Status
      Case &H0
        NLS.Salt = pktRead.ReadByteArray(32)
        NLS.B = pktRead.ReadByteArray(32)
        Return 0
      Case &H1 : Return 1
      Case &H5 : Return 2
      Case Else : Return 3
    End Select
  End Function
  Private Function WARCRAFT_AUTH_ACCOUNTLOGONPROOF_Send(ByRef NLS As clsNLS) As Byte()
    Using pktTemp As New BNCSPacket(BNCS_AUTH_ACCOUNTLOGONPROOF)
      If NLS.S(0) = 0 Then
        Debug.Print("Probable Failure!")
      End If
      pktTemp.InsertByteArray(NLS.M1)
      Return pktTemp.GetData
    End Using
  End Function
  Private Function WARCRAFT_AUTH_ACCOUNTLOGONPROOF_Recv(pktRead As BNCSReader, ByRef NLS As clsNLS) As String
    Dim Status As UInt32 = pktRead.ReadUInt32
    Dim M2() As Byte = pktRead.ReadByteArray(20)
    Dim Info As String = pktRead.ReadCString
    Select Case Status
      Case &H0
        If NLS.VerifyServerProof(M2) Then
          Return "OK"
        Else
          Return "Bad Server Proof"
        End If
      Case &H2
        Return "Bad Password"
      Case &HE
        If NLS.VerifyServerProof(M2) Then
          Return "OK"
        Else
          Return "Bad Server Proof"
        End If
      Case &HF
        Return Info
      Case Else
        Return "Unknown Failure"
    End Select
  End Function
  Private Function WARCRAFT_ENTERCHAT_Send() As Byte()
    Using pktTemp As New BNCSPacket(BNCS_ENTERCHAT)
      pktTemp.InsertByte(0)
      pktTemp.InsertByte(0)
      Return pktTemp.GetData
    End Using
  End Function
#End Region
  Private Function TryNextKey(Expansion As Boolean, CurrentProd As BNUI.GameType, CurrentKey As String, ByRef NextKey As clsKey) As Boolean
    Dim CheckAgainst As BNUI.GameType
    If Expansion Then
      Select Case CurrentProd
        Case BNUI.GameType.D2XP : CheckAgainst = BNUI.GameType.D2DV
        Case BNUI.GameType.W3XP : CheckAgainst = BNUI.GameType.WAR3
      End Select
    Else
      CheckAgainst = CurrentProd
    End If
    Dim cdKeys = Array.FindAll(GetCDKeys(Expansion).ToArray, Function(cKey As Xml.Linq.XElement) ProdMatch(IIf(Expansion, IIf(CurrentProd = BNUI.GameType.D2XP, BNUI.GameType.D2DV, CurrentProd), CurrentProd), GrabKeyStruct(cKey).ProductVal, Expansion))
    If cdKeys.Count < 2 Then Return False
    For I As Integer = 0 To cdKeys.Count - 1
      Dim cKey As BNUI.ProductKey = GrabKeyStruct(cdKeys(I))
      If cKey.ToString = CurrentKey Then
        If I < cdKeys.Count - 1 Then
          NextKey = New clsKey(GrabKeyStruct(cdKeys(I + 1)))
        Else
          NextKey = New clsKey(GrabKeyStruct(cdKeys(0)))
        End If
        Return True
      End If
    Next
    Return False
  End Function
  Private Sub txtUsername_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtUsername.TextChanged
    cmdAdd.Enabled = Not (String.IsNullOrEmpty(txtUsername.Text) Or String.IsNullOrEmpty(txtPassword.Text) Or String.IsNullOrEmpty(cmbGateway.Text))
  End Sub
  Private Sub txtPassword_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtPassword.TextChanged
    cmdAdd.Enabled = Not (String.IsNullOrEmpty(txtUsername.Text) Or String.IsNullOrEmpty(txtPassword.Text) Or String.IsNullOrEmpty(cmbGateway.Text))
  End Sub
  Private Sub cmbGateway_TextChanged(sender As Object, e As System.EventArgs) Handles cmbGateway.TextChanged
    cmdAdd.Enabled = Not (String.IsNullOrEmpty(txtUsername.Text) Or String.IsNullOrEmpty(txtPassword.Text) Or String.IsNullOrEmpty(cmbGateway.Text))
  End Sub
  Private Sub lstAccounts_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles lstAccounts.SelectedIndexChanged
    cmdAdd.Tag = Nothing
    cmdAdd.Text = "&Add Account"
  End Sub
  Public NotInheritable Class BNFTPQueue
    Shared FileList As New Collection
    Shared Sub Getting(FileName As String)
      FileList.Add(FileName, FileName)
    End Sub
    Shared Sub Got(FileName As String)
      If FileList.Contains(FileName) Then FileList.Remove(FileName)
    End Sub
    Shared Function IsGetting(FileName As String) As Boolean
      Return FileList.Contains(FileName)
    End Function
  End Class
  Private Function BNFTPRequest(Server As Net.IPAddress, Platform As BNUI.GameArch, Product As BNUI.GameType, FileName As String, FileTime As Date, Optional BannerID As UInt32 = 0, Optional BannerExt As String = Nothing, Optional bResume As Boolean = False) As Boolean
    If BNFTPQueue.IsGetting(FileName) Then
      Do While BNFTPQueue.IsGetting(FileName)
        Threading.Thread.Sleep(50)
        'Application.DoEvents()
      Loop
      Return True
    End If
    BNFTPQueue.Getting(FileName)
    Dim bRet As Boolean = False
    Dim iTries As Integer = 0
    Do Until bRet
      Threading.Thread.Sleep(10)
      iTries += 1
      If iTries = 10 Then
        BNFTPQueue.Got(FileName)
        Return False
      End If
      Using BNFTP As New BNFTPv1(Platform, Product, FileName, FileTime, BannerID, BannerExt, bResume)
        BNFTP.Proxy = Nothing
        BNFTP.Server = Server
        bRet = BNFTP.ExecuteRequest
      End Using
    Loop
    BNFTPQueue.Got(FileName)
    Return True
  End Function
  Private Sub optClassic_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles optClassic.CheckedChanged

  End Sub
  Private Sub frmRefresher_ResizeEnd(sender As Object, e As System.EventArgs) Handles Me.ResizeEnd
    lstAccounts.AutoResizeColumn(0, ColumnHeaderAutoResizeStyle.ColumnContent)
    lstAccounts.AutoResizeColumn(1, ColumnHeaderAutoResizeStyle.ColumnContent)
    lstAccounts.Columns(2).Width = lstAccounts.DisplayRectangle.Width - lstAccounts.Columns(0).Width - lstAccounts.Columns(1).Width
  End Sub
End Class