﻿Imports Microsoft.WindowsAPICodePack.Taskbar
Public NotInheritable Class frmSplash
  Inherits AlphaForm
  Private Delegate Sub SetStatusCallBack(Status As String)
  Public Sub SetStatus(Status As String)
    If Me.InvokeRequired Then
      Me.BeginInvoke(New SetStatusCallBack(AddressOf SetStatus), Status)
    Else
      If Status = "OFF" Then
        Me.Close()
      Else
        pbLoader.Tag += 1
        SetProgress(pbLoader.Tag, 7)
        If TaskbarManager.IsPlatformSupported Then
          TaskbarManager.Instance.SetProgressState(TaskbarProgressBarState.Normal)
          TaskbarManager.Instance.SetProgressValue(pbLoader.Tag, 7)
        End If
        lblStatus.Text = Status
      End If
    End If
  End Sub
  Private Sub SetProgress(Value As Integer, Max As Integer)
    Dim bmpTmp As New Bitmap(pbLoader.Width, pbLoader.Height)
    Using g As Graphics = Graphics.FromImage(bmpTmp)
      g.Clear(Color.Transparent)
      Dim tmpBrush As New TextureBrush(My.Resources.RECORD_WAR3_EXPBAR, Drawing2D.WrapMode.Tile)
      g.FillRectangle(tmpBrush, 0, 0, CInt(pbLoader.Width * (Value / Max)), pbLoader.Height)
    End Using
    pbLoader.Image = bmpTmp
  End Sub
  Private Sub frmSplash_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
    If My.Computer.FileSystem.FileExists(AppData & "\Settings.bak") Then
      If My.Computer.FileSystem.FileExists(AppData & "\Settings.xml") Then
        My.Computer.FileSystem.RenameFile(AppData & "\Settings.xml", AppData & "\Settings.old")
        My.Computer.FileSystem.RenameFile(AppData & "\Settings.bak", AppData & "\Settings.xml")
      Else
        My.Computer.FileSystem.RenameFile(AppData & "\Settings.bak", AppData & "\Settings.xml")
      End If
    End If
    End
  End Sub
  Public Sub SetMozVer(Version As String)
    If Me.InvokeRequired Then
      Me.BeginInvoke(New SetStatusCallBack(AddressOf SetMozVer), Version)
    Else
      If Not lblMozVer.Text = "XULRunner v" & Version Then
        lblMozVer.ForeColor = Color.Black
        lblMozVer.Text = "XULRunner v" & Version
        For I As Integer = 0 To 255 Step 8
          lblMozVer.ForeColor = Color.FromArgb(255, I, I, I)
          Application.DoEvents()
          Threading.Thread.Sleep(50)
        Next
      End If
    End If
  End Sub
  Private Sub frmSplash_Load(sender As Object, e As System.EventArgs) Handles Me.Load
    If My.Settings.Splash Then
      UpdateLayeredBackground()
      lblVer.Text = Version
      If My.Computer.FileSystem.FileExists(XULRunnerDir & "platform.ini") Then
        Using geckoINI As New INIReader(XULRunnerDir & "platform.ini")
          lblMozVer.Text = "XULRunner v" & geckoINI.GetValue("Build", "Milestone")
        End Using
      Else
        lblMozVer.Text = ""
      End If
      ParseIconsDefault()
      If My.Computer.FileSystem.DirectoryExists(Icons_Temp & "\icons\") Then
        pctBLIZ.Visible = False
        pctBNET.Visible = False
        pctDRTL.Visible = False
        pctD2DV.Visible = False
        pctSTAR.Visible = False
        pctW2BN.Visible = False
        pctWAR3.Visible = False
        pctBLIZ.Image = Image.FromFile(Icons_Temp & "\icons\FLAG_1.png")
        pctBNET.Image = Image.FromFile(Icons_Temp & "\icons\FLAG_8.png")
        pctDRTL.Image = Image.FromFile(Icons_Temp & "\icons\DRTL.png")
        pctD2DV.Image = Image.FromFile(Icons_Temp & "\icons\D2DV.png")
        pctSTAR.Image = Image.FromFile(Icons_Temp & "\icons\STAR.png")
        pctW2BN.Image = Image.FromFile(Icons_Temp & "\icons\W2BN.png")
        pctWAR3.Image = Image.FromFile(Icons_Temp & "\icons\WAR3.png")
        tmrUpdate.Start()
      End If
    End If
  End Sub
  Private Sub cmdClose_Click(sender As System.Object, e As System.EventArgs) Handles cmdClose.Click
    Me.Close()
  End Sub
  Private Sub pctMozilla_Click(sender As System.Object, e As System.EventArgs) Handles pctMozilla.Click
    Process.Start("http://www.mozilla.org/poweredby")
  End Sub
  Private Sub pctBattleNet_Click(sender As System.Object, e As System.EventArgs) Handles pctBattleNet.Click
    Process.Start("http://www.battle.net/")
  End Sub
  Private Sub tmrUpdate_Tick(sender As System.Object, e As System.EventArgs) Handles tmrUpdate.Tick
    If Not pctBLIZ.Visible Then
      pctBLIZ.Visible = True
    ElseIf Not pctBNET.Visible Then
      pctBNET.Visible = True
    ElseIf Not pctDRTL.Visible Then
      pctDRTL.Visible = True
    ElseIf Not pctD2DV.Visible Then
      pctD2DV.Visible = True
    ElseIf Not pctSTAR.Visible Then
      pctSTAR.Visible = True
    ElseIf Not pctW2BN.Visible Then
      pctW2BN.Visible = True
    ElseIf Not pctWAR3.Visible Then
      pctWAR3.Visible = True
    Else
      tmrUpdate.Stop()
    End If
  End Sub
End Class